Package: NanoStringQCPro
Title: Quality metrics and data processing methods for NanoString mRNA
        gene expression data
Version: 1.26.0
Date: 2018-04-10
Author: Dorothee Nickles <nickles.dorothee@gene.com>, Thomas Sandmann
        <sandmann.thomas@gene.com>, Robert Ziman
        <ziman.robert@gene.com>, Richard Bourgon
        <bourgon.richard@gene.com>
Maintainer: Robert Ziman <ziman.robert@gene.com>
Description: NanoStringQCPro provides a set of quality metrics that can
        be used to assess the quality of NanoString mRNA gene
        expression data -- i.e. to identify outlier probes and outlier
        samples. It also provides different background subtraction and
        normalization approaches for this data. It outputs suggestions
        for flagging samples/probes and an easily sharable html quality
        control output.
Depends: R (>= 3.2), methods
Imports: AnnotationDbi (>= 1.26.0), org.Hs.eg.db (>= 2.14.0), Biobase
        (>= 2.24.0), knitr (>= 1.12), NMF (>= 0.20.5), RColorBrewer (>=
        1.0-5), png (>= 0.1-7)
Suggests: roxygen2 (>= 4.0.1), testthat, BiocStyle, knitr, rmarkdown
License: Artistic-2.0
biocViews: Microarray, mRNAMicroarray, Preprocessing, Normalization,
        QualityControl, ReportWriting
LazyData: true
RoxygenNote: 6.0.1
VignetteBuilder: knitr
git_url: https://git.bioconductor.org/packages/NanoStringQCPro
git_branch: RELEASE_3_14
git_last_commit: 42d2b8e
git_last_commit_date: 2021-10-26
Date/Publication: 2021-10-26
NeedsCompilation: no
Packaged: 2021-10-26 22:00:51 UTC; biocbuild

setGeneric( "nSolverBackground", function( rccSet, ... ) standardGeneric( "nSolverBackground" ) )

##' @rdname nSolverBackground
##' @aliases nSolverBackground
##' 
##' @title
##'
##' nSolver Analysis Software background estimation
##' 
##' @description
##'
##' Calculates initial probe- and lane-specific background estimates using an
##' algorithm that mimics the implementation in NanoString's nSolver Analysis
##' Software (see details below for the exact algorithm).
##'
##' @param rccSet
##'
##' NanoString RccSet object
##'
##' @param inputMatrix
##'
##' Name of the matrix in the RccSet's assayData to use as input for calculating
##' background estimates (one of "exprs" or "posCtrlData"). If posCtrlData is
##' specified but not present in the assayData, an error will be generated.
##' 
##' @param stringency
##'
##' Multiplier with which to adjust final values.
##' 
##' @param shrink
##'
##' Boolean specifying if probe-specific estimates should be shrunken towards
##' their global mean.
##' 
##' @param w1
##'
##' Shrink weight "w1".
##'
##' @return
##'
##' A matrix containing lane- and probe-specific background estimates.
##'
##' @details
##'
##' The mean values for each blank lane (not including positive control probes)
##' are computed from the original data, and a vector of probe-specific
##' background is established by taking the rowMeans of the blank measurements
##' for each probe after subtracting out these values. If shrink=TRUE, the
##' vector is adjusted via the following formula (where 'probe.bg' represents
##' the vector):
##'
##' \preformatted{w2 <- 1/length(blanks)
##' probe.bg <- (w1*probe.bg + w2*mean(probe.bg)) / (w1 + w2)
##' }
##'
##' This probe-specific background is further adjusted by subtracting the mean
##' of its values for the negative control probes. A lane-specific "affinity" is
##' calculated for all lanes in the original data by taking the colMeans of the
##' negative control probe values in the original data, and background estimates
##' for each probe and lane in the original data are computed by summing the
##' corresponding probe-specific background and lane-specific affinity. Any
##' resulting values less than zero are set to zero, and the last step before
##' returning these values is to multiply them by the given stringency.
##'
##' @seealso \code{\link{getBackground}}, \code{\link{subtractBackground}}
##'
##' @author Dorothee Nickles, Thomas Sandmann
##'
setMethod(
    "nSolverBackground",
    "RccSet",
    function(rccSet,
             stringency = 1,
             shrink = TRUE,
             w1 = 2.18,
             inputMatrix = c("posCtrlData", "exprs"))
    {
        stopifnot(hasBlanks(rccSet))
        blankLabel <- getBlankLabel(rccSet)

        inputMatrix <- match.arg(inputMatrix)

        M <- assayData(rccSet)[[ inputMatrix ]]
        if (is.null(M))
            stop(sprintf("Specified input matrix ('%s') is not present in the RccSet's assayData", inputMatrix))

        neg.ctrl.probes <- featureNames(rccSet)[ fData(rccSet)$CodeClass == "Negative" ]
        not.positive.ctrl.probes <- featureNames(rccSet)[ fData(rccSet)$CodeClass != "Positive" ]
        blanks <- (pData(rccSet)$SampleType %in% blankLabel)

        blank.bg <- colMeans( M[not.positive.ctrl.probes, blanks, drop=FALSE], na.rm=TRUE )
        probe.bg.diff <- sweep( M[, blanks, drop=FALSE], 2, blank.bg )
        probe.bg <- rowMeans(probe.bg.diff, na.rm=TRUE)
        
        if (shrink) {
            w2 <- 1/sum(blanks)
            probe.bg <- (w1 * probe.bg + w2 * mean(probe.bg))/(w1 + w2) 
        }

        mean.neg.probe.bg <- mean( probe.bg[neg.ctrl.probes] )
        probe.bg.model <- probe.bg - mean.neg.probe.bg

        laneAffinity <- colMeans( M[neg.ctrl.probes, ] )
        bg <- sapply(laneAffinity, function(x) probe.bg.model + x)
        bg[ bg < 0 ] <- 0
        bgEstimates <- bg * stringency

        return(bgEstimates)
    }
    )



setGeneric( "getBackground", function( rccSet, ... ) standardGeneric( "getBackground" ) )

##' @rdname getBackground
##' @aliases getBackground
##' 
##' @title
##' 
##' Get background estimates for a NanoString RccSet
##'
##' @description
##'
##' Returns background estimates for a NanoString RccSet object. The function
##' depends upon correct annotation in the RccSet: if the \code{bgReference}
##' argument is set to \code{"blanks"}, it expects blank measurements (i.e.,
##' water runs) to have their phenoData SampleType set to the value indicating
##' blanks or an error will be thrown. (See getBlankLabel(); normally this value
##' would have been set using an argument to newRccSet()). If \code{bgReference} is set to
##' \code{"negatives"}, then it expects to find the negative control probes via
##' CodeClass == "Negative". If set to \code{"both"}, it expects both of the above and
##' will calculate initial background estimates using an algorithm that mimics
##' the implementation in NanoString's nSolver Analysis Software (see the
##' nSolverBackground() man page for details on the algorithm).
##'
##' @param rccSet
##'
##' NanoString RccSet object.
##'
##' @param bgReference
##'
##' Measurements to use for background estimates: one of "blanks" (for blank
##' samples), "negatives" (for negative control probes), or "both". Blanks are
##' assumed to be indicated as in the description above.
##' 
##' @param summaryFunction
##'
##' Summary function for background measurements (e.g. "mean" or "median").
##' User-defined functions similar to these can be specified here as well.
##' 
##' @param stringency
##'
##' Factor by which deviation (SD or MAD) of the summarization output will be
##' multiplied to obtain final background estimates.
##' 
##' @param nSolverBackground.shrink
##'
##' Value to use for the 'shrink' argument to nSolverBackground().
##' 
##' @param nSolverBackground.w1
##'
##' Value to use for the 'w1' argument to nSolverBackground().
##'
##' @param inputMatrix
##'
##' Name of the matrix in the RccSet's assayData to use as input for calculating
##' background estimates (one of "exprs" or "posCtrlData"). If posCtrlData is
##' specified but not present in the assayData, an error will be generated.
##'
##' @return
##'
##' A matrix containing background estimates for a NanoString RccSet object.
##'
##' @export
##'
##' @examples
##'
##' data(example_rccSet)
##'
##' ## Calculate probe-specific background based on negative control probes
##' bg <- getBackground(example_rccSet, bgReference="negatives", summaryFunction="mean",
##'     inputMatrix="exprs")
##'
##' ## Calculate sample-specific background based on blanks
##' bg <- getBackground(example_rccSet, bgReference="blanks", inputMatrix="exprs")
##'
##' ## Calculate background that is both sample- and probe-specific
##' bg <- getBackground(example_rccSet, bgReference="both", stringency=1,
##'     inputMatrix="exprs")
##'
##' @seealso \code{\link{subtractBackground}}
##'
##' @author Dorothee Nickles
##'
setMethod(
    "getBackground",
    "RccSet",
    function(rccSet,
             bgReference                = c("both", "blanks", "negatives"),
             summaryFunction            = "median",
             stringency                 = 0,
             nSolverBackground.shrink   = TRUE,
             nSolverBackground.w1       = 2.18,
             inputMatrix                = c("posCtrlData", "exprs"))
    {
        bgReference <- match.arg(bgReference)
        if (class(summaryFunction) == "character")
            sfun <- get(summaryFunction)
        else
            sfun <- summaryFunction
        stopifnot(stringency >= 0)
        inputMatrix <- match.arg(inputMatrix)

        M <- assayData(rccSet)[[ inputMatrix ]]
        if (is.null(M))
            stop(sprintf("Specified input matrix ('%s') is not present in the RccSet's assayData", inputMatrix))

        metric1 <- sfun
        if (as.character(quote(sfun)) == "median") {
            metric2 <- mad
        } else {
            metric2 <- sd
        }

        blankLabel <- getBlankLabel(rccSet)

        if (bgReference == "both") {

            if (!hasBlanks(rccSet)) {
                stop("bgReference == \"both\" but the RccSet does not contain blanks (try bgReference=\"negatives\" instead)")
            }

            bgEstimates <- nSolverBackground(rccSet,
                                             stringency,
                                             shrink = nSolverBackground.shrink,
                                             w1 = nSolverBackground.w1,
                                             inputMatrix)

        } else if (bgReference == "blanks") {

            # Previously the code below was just "stopifnot(hasBlanks(rccSet))".
            # Replaced this with a more helpful error message since several users emailed about
            # datasets that do not have blanks. [zimanr 10-Apr-2017]
            if (!hasBlanks(rccSet)) {
                stop("bgReference == \"blanks\" but the RccSet does not contain blanks (try bgReference=\"negatives\" instead)")
            }

            blanks <- (pData(rccSet)$SampleType %in% blankLabel)
            refMed <- apply( M[, blanks], 1, metric1 )
            refMAD <- apply( M[, blanks], 1, metric2 )
            row_estimates <- refMed + refMAD * stringency
            bgEstimates <- matrix(nrow(M), ncol(M), byrow=FALSE, data=rep(row_estimates, nrow(pData(rccSet))))

        } else { # bgReference == "negatives"

            refMed <- apply( M[fData(rccSet)$CodeClass == "Negative", ], 2, metric1 )
            refMAD <- apply( M[fData(rccSet)$CodeClass == "Negative", ], 2, metric2 )
            col_estimates <- refMed + refMAD * stringency
            bgEstimates <- matrix(nrow(M), ncol(M), byrow=TRUE, data=rep(col_estimates, nrow(fData(rccSet))))

        }

        rownames(bgEstimates) <- rownames(fData(rccSet))
        colnames(bgEstimates) <- rownames(pData(rccSet))

        return(bgEstimates)
    }
    )



setGeneric( "subtractBackground", function( rccSet, ... ) standardGeneric( "subtractBackground" ) )

##' @rdname subtractBackground
##' @aliases subtractBackground
##'
##' @title
##'
##' Subtract background estimates for a NanoString RccSet
##'
##' @description
##'
##' Returns a NanoString \code{\linkS4class{RccSet}} with background-corrected
##' count data. During subtraction, any counts below 1 will be truncated to 1 to
##' enable subsequent log transformation of the data.
##'
##' @param rccSet
##'
##' NanoString RccSet object
##'
##' @param inputMatrix
##'
##' Name of the matrix in the RccSet's assayData to use as input for subtracting
##' background estimates (one of "exprs" or "posCtrlData"). If posCtrlData is
##' specified but not found in the assayData, an error will be generated.
##'
##' @param bgEstimates
##'
##' Matrix containing the background estimates to subtract.
##'
##' @param bgEstimatesParams
##'
##' A list with the parameters that were used to generate the background
##' estimates (see getBackground()):
##'
##' \itemize{
##'   \item bgReference
##'   \item summaryFunction
##'   \item stringency
##'   \item nSolverBackground.w1
##'   \item nSolverBackground.shrink
##'   \item inputMatrix
##' }
##'
##' The values of these list elements will be assigned to corresponding elements
##' in the output's experimentData@@preprocessing list. If any element is NULL,
##' the corresponding element in the output's preprocessing list will be NA.
##'
##' @param quietly
##'
##' Boolean specifying whether or not messages and warnings should be omitted.
##'
##' @return
##' 
##' A NanoString \code{linkS4class{RccSet}} object with background estimates
##' subtracted from the count data.
##'
##' @export
##'
##' @examples
##'
##' data(example_rccSet)
##'
##' pcnorm_rccSet <- posCtrlNorm(example_rccSet)
##'
##' bg1 <- getBackground(pcnorm_rccSet, bgReference="negatives", summaryFunction="mean")
##' bg2 <- getBackground(pcnorm_rccSet, bgReference="blanks")
##' bg3 <- getBackground(pcnorm_rccSet, bgReference="both", stringency=1)
##'
##' bgCor1 <- subtractBackground(pcnorm_rccSet, bgEstimates=bg1)
##' bgCor2 <- subtractBackground(pcnorm_rccSet, bgEstimates=bg2)
##' bgCor3 <- subtractBackground(pcnorm_rccSet, bgEstimates=bg3)
##'
##' @seealso \code{\link{getBackground}}
##'
##' @author Dorothee Nickles
##'
setMethod(
    "subtractBackground",
    "RccSet",
    function( rccSet,
              bgEstimates,
              bgEstimatesParams = list(),
              inputMatrix = c("posCtrlData", "exprs"),
              quietly = FALSE )
    {
        if (missing(rccSet) || missing(bgEstimates))
            stop("subtractBackground: missing some arguments")

        inputMatrix <- match.arg(inputMatrix)

        M <- assayData(rccSet)[[ inputMatrix ]]
        if (is.null(M))
            stop(sprintf("Specified input matrix ('%s') is not present in the RccSet's assayData", inputMatrix)) 

        if (!quietly && ("bgEstimates" %in% ls(assayData(rccSet))))
            warning("Input already contains background estimates")
        if (!quietly && ("bgCorrData" %in% ls(assayData(rccSet))))
            warning("Input already contains background corrected data")

        M <- M - bgEstimates

        M[ M < 1 ] <- 1     # Truncate to 1 any counts below 1 (cf. pseudocount in pdata_fdata_adata.to.rccSet())

        srccSet <- copyRccSet(rccSet)

        assayData(srccSet)$bgCorrData <- M
        assayData(srccSet)$bgEstimates <- bgEstimates

        preproc(srccSet)$bgEstimates_bgReference              <- NAifNULL( bgEstimatesParams$bgReference )
        preproc(srccSet)$bgEstimates_summaryFunction          <- NAifNULL( bgEstimatesParams$summaryFunction )
        preproc(srccSet)$bgEstimates_stringency               <- NAifNULL( bgEstimatesParams$stringency )
        preproc(srccSet)$bgEstimates_nSolverBackground.w1     <- NAifNULL( bgEstimatesParams$nSolverBackground.w1 )
        preproc(srccSet)$bgEstimates_nSolverBackground.shrink <- NAifNULL( bgEstimatesParams$nSolverBackground.shrink )
        preproc(srccSet)$bgEstimates_inputMatrix              <- NAifNULL( bgEstimatesParams$inputMatrix )

        return(srccSet)
    }
    )

library(NanoStringQCPro)

dataDir <- system.file("extdata", package="NanoStringQCPro")
rccDir <- file.path(dataDir, "RCC")

example_rccSet <- newRccSet(
     rccFiles               = file.path(rccDir, dir(rccDir))
    ,rlf                    = file.path(dataDir, "RLF", "NQCP_example.rlf")
    ,cdrDesignData          = file.path(dataDir, "CDR", "CDR-DesignData.csv")
    ,extraPdata             = file.path(dataDir, "extraPdata", "SampleType.txt")
    ,blankLabel             = "blank"
    ,addEgAnnotations       = TRUE
    ,experimentData.name    = "Dorothee Nickles"
    ,experimentData.lab     = "Richard Bourgon"
    ,experimentData.contact = "nickles.dorothee@gene.com"
    ,experimentData.title   = "NanoStringQCPro example dataset"
    ,experimentData.abstract= "Example data for the NanoStringQCPro package"
)

save(list="example_rccSet", file="../../data/example_rccSet.rdata")

norm_example_rccSet <- preprocRccSet(example_rccSet)

qc_example_rccSet <- makeQCReport(norm_example_rccSet,
                                  outputBaseName="example_QC_report",
                                  heatmaps=TRUE,
                                  verbose=TRUE)

##' Create a preview of a PNG
##'
##' Generates a resized, vertically-cropped preview version of the input PNG.
##'
##' @param inputFile
##' Input PNG filename
##'
##' @param outputFile
##' Output PNG filename
##'
##' @param width
##' Width (in pixels) for the preview image
##'
##' @param cropHeight
##' Height (in pixels) for the preview image (if the rescaled input is larger
##' than this, it will be cropped)
##'
##' @param res
##' Output PNG resolution (passed to the `res' argument of png())
##'
##' @return
##' A resized, vertically-cropped preview version of the input PNG.
##'
##' @importFrom png readPNG
##'
previewPNG <- function(inputFile, outputFile, width, cropHeight, res=72)
{
  if (file.exists(inputFile))
  {
    inputRaster <- readPNG(inputFile)
  
    rescale_factor <- width / ncol(inputRaster)
    height <- min( nrow(inputRaster)*rescale_factor, cropHeight )
  
    croppedInputRaster <- inputRaster[ 1:(height/rescale_factor), 1:(width/rescale_factor), 1:3 ]
    
    png(filename = outputFile,
        width = width,
        height = height,
        units = "px",
        res = res)
  
    op <- par(mar = rep(0,4))
  
    y_max <- nrow(croppedInputRaster)
    x_max <- ncol(croppedInputRaster)
    if (y_max < x_max) {
      x <- 1:x_max
      y <- c(1:y_max, rep(y_max, x_max - y_max))
    } else {
      x <- c(1:x_max, rep(x_max, y_max - x_max))
      y <- 1:y_max
    }  
    plot( y, x, type = "n", xlab = "", ylab = "", axes = FALSE )
  
    rasterImage( croppedInputRaster, 1, 1, y_max, x_max )
  
    par(op)
    
    dev.off()
  }
  else {
    print("Input file not found")
  }
}

setGeneric( "copyRccSet", function( rccSet ) standardGeneric( "copyRccSet" ) )

##' @rdname copyRccSet
##' @aliases copyRccSet
##'
##' @title
##' Deep-copy a NanoString RccSet
##'
##' @description
##' 
##' Returns a copy of the input RccSet where the copy's assayData has been
##' produced via copyEnv() rather than a simple assignment -- hence deep-copying
##' the environment pointed to by assayData rather than just copying the
##' pointer. This guarantees that if the copy's assayData is affected later in
##' the code, assayData for the original won't be affected.
##'
##' @param rccSet A NanoString RccSet to be copied.
##'
##' @return
##'
##' A new RccSet that is a deep copy of the original.
##'
##' @export
##'
##' @examples
##' data(example_rccSet)
##' example_rccSet_2 <- copyRccSet(example_rccSet)
##' assayData(example_rccSet)
##' assayData(example_rccSet_2) # Should be different
##'
##' @author Robert Ziman
##'
setMethod(
    "copyRccSet",
    "RccSet",
    function(rccSet)
    {
        RccSet( rccSet ) # Constructor always deep copies
    }
    )



setGeneric( "checkRccSet", function( rccSet, ... ) standardGeneric( "checkRccSet" ) )

##' @rdname checkRccSet
##' @aliases checkRccSet
##'
##' @title
##' Check an RccSet
##'
##' @description
##' Provides additional checks and generates warnings for unexpected or unusual conditions
##' which, though permitted by the RccSet class, may indicate data import errors.
##'
##' @param  rccSet          An RccSet to be checked.
##' @param  reportWarnings  Logical. If TRUE, warnings are reported.
##' @param  showMessages    Logical. If TRUE, notes are shown indicating any optional missing
##'                         columns and the like.
##'
##' @return                 Returns TRUE if no warnings were generated and FALSE otherwise.
##'
##' @examples
##' data(example_rccSet)
##' checkRccSet(example_rccSet)
##'
##' @export
##'
##' @author Robert Ziman
##'
setMethod(
    "checkRccSet",
    "RccSet",
    function(rccSet, reportWarnings=TRUE, showMessages=FALSE)
    {
        result.messages <- character()
        result.warnings <- character()
        result.errors <- character()

        if (is(rccSet, "RccSet"))
        {
            fData.optionalCols <- c(
                 "BarCode"
                ,"ProbeID"
                ,"TargetSeq"
                ,"Species"
               #,"RefSeqMrna"
               #,"GeneID"
               #,"Hgnc_Symbol"
                ,"Comments"
            )
            result.messages <- c(result.messages, check_cols(fData.optionalCols, colnames(fData(rccSet)), "Optional featureData cols not found"))

            pData.optionalCols <- c(
                 "Comments"
                ,"Date"
            )
            result.messages <- c(result.messages, check_cols(pData.optionalCols, colnames(pData(rccSet)), "Optional phenoData cols not found"))

            if ("normData" %in% ls(assayData(rccSet))) {
                pData.qcCols <- c(
                     "TechnicalFlags"
                    ,"ControlFlags"
                    ,"CountFlags"
                    #,"pData_qc"
                )
                result.messages <- c(result.messages, check_cols(pData.qcCols, colnames(pData(rccSet)), "QC-related phenoData cols not found"))
            }

            blankLabel <- getBlankLabel(rccSet, showWarnings=FALSE)
            if (is.na(blankLabel)) {
                result.warnings <- c(result.warnings, "blankLabel not recorded in varMetadata for phenoData SampleType column")
            }

            if (!is.null(pData(rccSet)$FovCount)) {
                if (length(unique(pData(rccSet)$FovCount)) > 1) {
                    result.warnings <- c(result.warnings, "The data seems to have been generated using two different settings (more than one value appears in the FOV Count field)")
                }
            }

            if (!is.null(fData(rccSet)$CodeClass))
            {
                CodeClass.values <- unique(fData(rccSet)$CodeClass)
                CodeClass.nonstandard_values <- setdiff( CodeClass.values, c("Endogenous", "Housekeeping", "Positive", "Negative") )
                if (length(CodeClass.nonstandard_values) > 0) {
                    result.warnings <- c(result.warnings,
                        paste0("Non-standard CodeClass values found in featureData (values currently recognized are \"Endogenous\", \"Housekeeping\", \"Positive\", and \"Negative\"): ", paste(collapse=", ", CodeClass.nonstandard_values), ")")
                    )
                }

                if ("Housekeeping" %in% fData(rccSet)$CodeClass)
                {
                    result.messages <- c(result.messages,
                        sprintf( "The following panel housekeeping genes were found: %s",
                            paste(fData(rccSet)$GeneName[ fData(rccSet)$CodeClass == "Housekeeping" ],
                                  collapse=", "))
                    )
                } else {
                    result.messages <- c(result.messages, "No panel housekeeping genes were found")
                }
            }

            # Check for duplicate accessions. (This can happen when the GeneName field contains
            # something which is not a legitimate gene symbol. A message or warning is appropriate
            # in this case since downstream analysis is unlikely to anticipate multiple probe pairs
            # for the same annotated transcript and will need to handle this specially.)

            if (!is.null(fData(rccSet)$Accession)) {
                if (any(duplicated(fData(rccSet)$Accession))) {
                    result.messages <- c(result.messages, "Duplicate accessions were found")
                }
            }

            #@assayData
            #@annotation

        } else {
            stop("Input is not an RccSet")
        }

        if (showMessages && length(result.messages) > 0) {
            message(paste(collapse="\n", c(
                "checkRccSet() messages:",
                paste0("  ", result.messages)
            )))
        }

        if (reportWarnings && length(result.warnings) > 0) {
            warning(paste(collapse="\n", c(
                "",     # force wordwrap of the first line
                paste0("  ", result.warnings)
            )))
        }

        if (length(result.warnings) > 0)
            return(FALSE)
        else
            return(TRUE)
    }
    )



setGeneric( "getBlankLabel", function( rccSet, ... ) standardGeneric( "getBlankLabel" ) )

##' @rdname getBlankLabel
##' @aliases getBlankLabel
##'
##' @title
##' Get the SampleType value that indicates blank samples
##'
##' @description
##' Returns the phenoData SampleType value that indicates blank samples (i.e. water runs).
##' This value is parsed from the single-quoted string enclosed by "blankLabel='...'"
##' in the varMetadata for SampleType.
##'
##' @param rccSet           An RccSet
##' @param showWarnings     Logical. If FALSE, no warnings will be generated (if any).
##'
##' @return
##' NULL if the SampleType column is missing altogether, NA if the varMetadata doesn't
##' have blankLabel recorded, or the blankLabel value otherwise.
##'
##' @examples
##' data(example_rccSet)
##' blankLabel <- getBlankLabel(example_rccSet)
##'
##' @export
##'
##' @author Robert Ziman
##'
setMethod(
    "getBlankLabel",
    "RccSet",
    function(rccSet, showWarnings=TRUE)
    {
        SampleType.rownum <- which(rownames(varMetadata(phenoData(rccSet))) == "SampleType")
        if (length(SampleType.rownum) == 0) {   # "SampleType" was not found amongst the rownames
            if (showWarnings) {
                warning("phenoData doesn't have a 'SampleType' column")
            }
            return(NULL)
        } else {
            SampleType.metadata <- varMetadata(phenoData(rccSet))$labelDescription[ SampleType.rownum ]
            if (!grepl("blankLabel='.*'", SampleType.metadata)) {
                if (showWarnings) {
                    warning("phenoData 'SampleType' varMetadata doesn't contain blankLabel string")
                }
                return(NA)
            } else {
                blankLabel <- sub("'.*", "", sub(".*blankLabel='", "", SampleType.metadata))
                return (blankLabel)
            }
        }
    }
    )

setGeneric( "hasBlanks", function( rccSet ) standardGeneric( "hasBlanks" ) )
setMethod(
    "hasBlanks",
    "RccSet",
    function(rccSet) {
        blankLabel <- getBlankLabel(rccSet)
        any(pData(rccSet)$SampleType %in% blankLabel)
    }
    )

setGeneric( "hasPanelHousekeeping", function( rccSet ) standardGeneric( "hasPanelHousekeeping" ) )
setMethod(
    "hasPanelHousekeeping",
    "RccSet",
    function(rccSet) {
        any(fData(rccSet)$CodeClass == "Housekeeping")
    }
    )

setGeneric( "paStringency", function( rccSet ) standardGeneric( "paStringency" ) )
setMethod(
    "paStringency",
    "RccSet",
    function(rccSet)
    {
        paData_preprocList_value <- preproc(rccSet)$assayData_paData

        if (!is.null(paData_preprocList_value)) {
            m <- regexec(".*stringency factor: ([0-9\\.]*)", paData_preprocList_value)
            unlist(regmatches(paData_preprocList_value, m))[2]
        } else {
            NULL
        }
    }
    )


NAifNULL <- function(x)
{
    if (is.null(x))
        NA
    else
        x
}

setGeneric( "makeQCReport", function( rccSet, ... ) standardGeneric( "makeQCReport" ) )

##' @rdname makeQCReport
##' @aliases makeQCReport
##'
##' @title
##' Make NanoString QC report
##'
##' @description
##' Creates an html QC report for an RccSet object. Alongside the html file, a
##' directory with matching filename is produced that contains additional files
##' as well as high resolution versions of the various plots in the report.
##' In addition to generating the QC report, the function returns a copy of the
##' input RccSet with columns added to phenoData that show the QC flags for each
##' sample.
##'
##' @description
##' The various plots in the report depend upon correct annotation and
##' preprocessing in the input object. If the input is missing any elements
##' required for a given plot, the plot will be replaced with a message
##' indicating the missing elements. If the preprocOverride argument is set to
##' TRUE, the input's preprocessing will be ignored and a default configuration
##' will be used so that all applicable plots will be rendered.
##' 
##' @param rccSet
##' RccSet object for which to generate the QC report.
##'
##' @param outputBaseName
##' Character string specifying the base filename (without extension) to use
##' for the output file.
##'
##' @param outputDir
##' Character string specifying the path to the output directory for the QC
##' report and associated files.
##'
##' @param preprocOverride
##' Logical. If TRUE, the input's preprocessing will be ignored, and a default
##' preprocessing configuration (specifically, the defaults for
##' preprocRccSet()) will be applied so that all applicable plots can be
##' rendered in the report.
##'
##' @param experimentTitle
##' Character string specifying an easy to read identifier of the experiment.
##'
##' @param covar
##' Character string specifying a covariate for stratifying samples (e.g.
##' "SampleType").
##'
##' @param method
##' Method to determine outlier samples: either "cutoffByVar" or
##' "cutoffByMMAD".
##'
##' @param stringency
##' Multiplier with which to adjust cutoff values for determining outlier
##' samples.
##'
##' @param maxMiss
##' Numeric specifying the allowable fraction of genes below the lower limit
##' of detection in a sample.
##'
##' @param sampleNameCol
##' Character string specifying the name of the phenoData column holding the
##' sample names.
##'
##' @param heatmaps
##' Logical: render and show heatmaps?
##'
##' @param cleanMarkdown
##' Logical: upon completion, delete markdown files used to produce QC report?
##'
##' @param verbose
##' Logical: print progress messages?
##'
##' @return
##' An html report is written to disk and a copy of the input RccSet is
##' invisibly returned with columns added to phenoData that show the QC flags
##' for each sample.
##'
##' @examples
##' data(example_rccSet)
##' norm_example_rccSet <- preprocRccSet(example_rccSet)
##' qc_example_rccSet <- makeQCReport(norm_example_rccSet, "example_QC_report")
##'
##' @import knitr
##'
##' @export
##'
##' @author Dorothee Nickles, Thomas Sandmann, Robert Ziman, Richard Bourgon
##'
setMethod(
  "makeQCReport",
  "RccSet",
  function(rccSet,
           outputBaseName    = "NanoStringQCPro_QC_report",
           outputDir         = getwd(),
           preprocOverride   = FALSE,
           experimentTitle   = expinfo(experimentData(rccSet))["title"],
           covar             = "SampleType",
           method            = c("cutoffByMMAD", "cutoffByVar"),
           stringency        = 4,
           maxMiss           = 0.2,
           sampleNameCol     = "SampleID",
           heatmaps          = FALSE,
           cleanMarkdown     = TRUE,
           verbose           = FALSE)
  {
    method <- match.arg(method)

    outputExtrasDir <- outputBaseName
  
    fileNames <- sapply(
      c( "Rmd", "md", "html" ),
      function( ext ) sprintf( "%s.%s", outputBaseName, ext ),
      simplify = FALSE
      )
    
    # Create the output dirs if they don't exist.
  
    if (!file.exists(outputDir))
      if ( !dir.create(outputDir, recursive=TRUE) )
        stop( "outputDir doesn't exist and couldn't be created" )
  
    oldDir <- getwd()
    on.exit( setwd( oldDir ) )
    setwd( outputDir ) # Fails automatically if not successful
    
    if (!file.exists(outputExtrasDir))
      if ( !dir.create(outputExtrasDir) )
        stop( "outputExtrasDir doesn't exist in outputDir and couldn't be created" )
  
    # Validate arguments and check the input rccSet
  
    checkRccSet(rccSet, reportWarnings=TRUE, showMessages=FALSE)
  
    if (!is.numeric(stringency) || length(stringency) != 1)
      stop("stringency needs to be a scalar numeric value")
  
    if (!is.numeric(maxMiss) || length(maxMiss) != 1)
      stop("maxMiss needs to be a scalar numeric value")
  
    if (!(covar %in% colnames(pData(rccSet))))
      stop("covar not found amongst the phenoData columns")
  
    if (!(sampleNameCol %in% colnames(pData(rccSet))))
      stop(sprintf("sampleNameCol ('%s') not found amongst the phenoData columns", sampleNameCol))
  
    # Assign any additional variables required by the template.
  
    blankLabel <- getBlankLabel(rccSet)

    scMainImage         <- file.path( outputExtrasDir, "SampleClustering.png" )
    scPreviewImage      <- file.path( outputExtrasDir, "SampleClustering_preview.png" ) 
    gcibsMainImage      <- file.path( outputExtrasDir, "GenewiseCountsInBlankSamples.png" )
    gcibsPreviewImage   <- file.path( outputExtrasDir, "GenewiseCountsInBlankSamples_preview.png" )
    ncblMainImage       <- file.path( outputExtrasDir, "NegativeControlsByLane.png" )
    ncblPreviewImage    <- file.path( outputExtrasDir, "NegativeControlsByLane_preview.png" )
    gcgMainImage        <- file.path( outputExtrasDir, "GeneClusteringGlobal.png" )
    gcgPreviewImage     <- file.path( outputExtrasDir, "GeneClusteringGlobal_preview.png" )
    gchMainImage        <- file.path( outputExtrasDir, "GeneClusteringHousekeeping.png" )
    gchPreviewImage     <- file.path( outputExtrasDir, "GeneClusteringHousekeeping_preview.png" )
    cscMainImage        <- file.path( outputExtrasDir, "CenteredSampleClustering.png" )
    cscPreviewImage     <- file.path( outputExtrasDir, "CenteredSampleClustering_preview.png" )
    cscxfsMainImage     <- file.path( outputExtrasDir, "CenteredSampleClusteringExcludingFlaggedSamples.png" )
    cscxfsPreviewImage  <- file.path( outputExtrasDir, "CenteredSampleClusteringExcludingFlaggedSamples_preview.png" )

    # If specified, override the RccSet's preprocessing with a default
    # configuration. This ensures the availability of assayData matrices
    # and other elements required so that all applicable QC plots will be shown
    # in the report.

    if (preprocOverride) {
        rccSet <- preprocRccSet(rccSet)
    }

    # Generate the report
  
    message("Generating QC report...")

    if (verbose) message("  Gene-wise counts in blank samples: main image...")
    countsInBlankSamples_verticalPlot(rccSet, gcibsMainImage)

    if (verbose) message("  Gene-wise counts in blank samples: preview image...")
    previewPNG(gcibsMainImage, gcibsPreviewImage, width=1500, cropHeight=600, res=300)

    if (verbose) message("  Negative controls by lane: main image...")
    negCtrlsByLane_verticalPlot(rccSet, ncblMainImage)

    if (verbose) message("  Negative controls by lane: preview image...")
    previewPNG(ncblMainImage, ncblPreviewImage, width=1500, cropHeight=600, res=300)

    if (verbose) message("  Raw and content normalized data for density plots and gene clustering...")

    rawData <- assayData(rccSet)$exprs

    if ("bgCorrData" %in% ls(assayData(rccSet)))
      normInputMatrix <- "bgCorrData"
    else if ("posCtrlData" %in% ls(assayData(rccSet)))
      normInputMatrix <- "posCtrlData"
    else
      normInputMatrix <- "exprs"

    if (preproc(rccSet)$normData_method %in% "global") {    # Don't use == here (normData_method can be NA)
      gmrccSet <- copyRccSet(rccSet)
      gmnormData <- assayData(gmrccSet)$normData
    } else {
      gmrccSet <- contentNorm(rccSet,
                              method = "global",
                              summaryFunction = "median",
                              inputMatrix = normInputMatrix,
                              quietly = TRUE)
      gmnormData <- assayData(gmrccSet)$normData
    }

    if (preproc(rccSet)$normData_method %in% "housekeeping") {  # Don't use == here (normData_method can be NA)
      hkrccSet <- copyRccSet(rccSet)
      hknormData <- assayData(hkrccSet)$normData
    } else if (hasPanelHousekeeping(rccSet)) {
      hkrccSet <- contentNorm(rccSet,
                              method="housekeeping",
                              summaryFunction = "median",
                              inputMatrix = normInputMatrix,
                              quietly=TRUE)
      hknormData <- assayData(hkrccSet)$normData
    } else {
      hkrccSet <- NULL
      hknormData <- NULL
    }

    flags <- rep(FALSE, ncol(rccSet)*3)
    dim(flags) <- c(ncol(rccSet), 3)
    rownames(flags) <- colnames(rccSet)
    colnames(flags) <- c("TechnicalFlags", "ControlFlags", "CountFlags")
    flags[,"TechnicalFlags"][flagSamplesTech(rccSet)] <- TRUE
    flags[,"ControlFlags"][flagSamplesCtrl(rccSet, method, stringency)] <- TRUE
    flags[,"CountFlags"][flagSamplesCount(rccSet, method, stringency, maxMiss)] <- TRUE
    flags2 <- cbind(SampleIdentifier=rownames(flags),
                    SampleName=as.character(pData(rccSet)[, sampleNameCol]),
                    flags)
    flags2 <- cbind(flags2, SampleType=pData(rccSet)$SampleType)
    write.table(flags2, file=file.path(outputExtrasDir, "SampleFlags.txt"), sep="\t", row.names=FALSE, quote=FALSE)

    if (heatmaps) {

        if (verbose) message("  Heatmaps...")

        if (verbose) message("    Sample clustering: main image...")
        sampleClustering(rccSet     = rccSet,
                         outputFile = scMainImage,
                         covar      = covar)
        
        if (verbose) message("    Sample clustering: preview image...")
        previewPNG(scMainImage, scPreviewImage, width=1500, cropHeight=1500, res=300)

        if (verbose) message("    Gene clustering (global normalization): main image...")
        geneClustering(rccSet     = gmrccSet,
                       outputFile = gcgMainImage,
                       main       = "Gene clustering (global normalization)")

        if (verbose) message("    Gene clustering (global normalization): preview image...")
        previewPNG(gcgMainImage, gcgPreviewImage, width=1500, cropHeight=1500, res=300)

        if (!is.null(hkrccSet)) {

            if (verbose) message("    Gene clustering (housekeeping normalization): main image...")
            geneClustering(rccSet     = hkrccSet,
                           outputFile = gchMainImage,
                           main       = "Gene clustering (housekeeping normalization)")

            if (verbose) message("    Gene clustering (housekeeping normalization): preview image...")
            previewPNG(gchMainImage, gchPreviewImage, width=1500, cropHeight=1500, res=300)

        } else {
            if (verbose) message("    Gene clustering (housekeeping normalization): main image... skipped")
            if (verbose) message("    Gene clustering (housekeeping normalization): preview image... skipped")
        }

        if (verbose) message("    Centered sample clustering: main image...")
        centeredSampleClustering(gmrccSet,
                                 outputFile = cscMainImage,
                                 main = "Sample clustering of all samples run",
                                 flags = flags,
                                 excludeFlagged = FALSE)

        if (verbose) message("    Centered sample clustering: preview image...")
        previewPNG(cscMainImage, cscPreviewImage, width=1500, cropHeight=1500, res=300)

        if (verbose) message("    Centered sample clustering (excluding flagged samples): main image...")
        centeredSampleClustering(gmrccSet,
                                 outputFile = cscxfsMainImage,
                                 main = "Sample clustering after exclusion of outlier samples",
                                 flags = flags,
                                 excludeFlagged = TRUE)

        if (verbose) message("    Centered sample clustering (excluding flagged samples): preview image...")
        previewPNG(cscxfsMainImage, cscxfsPreviewImage, width=1500, cropHeight=1500, res=300)

    } else {
        if (verbose) message("  Heatmaps... skipped")
    }
 
    report.date <- date()
    qcReportHeader <- system.file("misc", "qcReportHeader.html", package="NanoStringQCPro")
    rmdTemplate <- system.file("templates", "QualityControlReportTemplate.Rmd", package="NanoStringQCPro")
 
    file.copy( rmdTemplate, fileNames$Rmd, overwrite = TRUE )
  
    # Some other potentially relevant arguments that can be passed, which go to markdownToHTML: stylesheet, title.
    knit2html(
      fileNames$Rmd,
      fileNames$html,
      options = c( "use_xhtml", "smartypants", "toc" ), # passed to markdownToHTML. Skipping base64_images, mathjax, and highlight_code
      header = qcReportHeader,
      quiet = TRUE,
      force_v1 = TRUE
        #
        # Fixes the "It seems you should call rmarkdown::render() instead of knitr::knit2html() because NanoStringQCPro_QC_report.Rmd
        # appears to be an R Markdown v2 document" error that started coming up with knitr_1.12 (no such error was coming up with knitr_1.11).
        # -RZ 2016-03-03
        #
      )
  
    if ( cleanMarkdown ) {
      unlink( fileNames$Rmd )
      unlink( fileNames$md )
    }
  
    message( sprintf( "Report file has been generated: %s", file.path( outputDir, fileNames$html ) ) )
  
    # Add sample flags and return.
  
    sampleFlagFile <- file.path( outputExtrasDir, "SampleFlags.txt" )
    if ( !file.exists(sampleFlagFile) )
      stop(paste0("File not found: [", sampleFlagFile, "]"))
    rccSet <- addQCFlags(rccSet, sampleFlagFile)
  
    invisible(rccSet)
  
    # on.exit() above returns us to previous working directory
    
  }
  )

## Data import and normalization functions -- and some small convenience functions

##' @title          Read an .RCC file
##' @description    Parse an .RCC file into a list with each part of the file (Header,
##'                 Sample_Attributes, Lane_Attributes, Code_Summary, etc) stored as a vector
##'                 or data frame.
##'
##' @param  rcc                 Path to the .RCC file.
##' @param  removeSpikeInLabels Logical. If TRUE (the default), RNA \dQuote{spike-in} input labels (if any)
##'                             in the GeneName for positive and negative control probes will be removed.
##'
##' @return
##' A list where each element holds the contents of one part of the .RCC file
##' (Header, Sample_Attributes, Lane_Attributes, Code_Summary, etc) as a
##' vector or data frame.
##'
##' @export
##'
##' @examples
##' rcc <- system.file("extdata", "RCC", "20140604_C1-unstim_C1-unstim_01.RCC", package="NanoStringQCPro")
##' rcc.ls <- readRcc(rcc)
##'
##' @author Robert Ziman
##'
readRcc <- function(rcc, removeSpikeInLabels=TRUE)
{
	suppressWarnings(
		lines <- readLines(rcc)
	)
	lines.df <-
	    data.frame(stringsAsFactors=FALSE,
	         line   = lines
	        ,tag    = rep("", length(lines))
	    )

	tags <- c("Header", "Sample_Attributes", "Lane_Attributes", "Code_Summary", "Messages")
	for(i in 1:length(tags))
	{
	    tag_start <- which(lines.df$line == paste0("<", tags[i], ">"))
	    tag_end <- which(lines.df$line == paste0("</", tags[i], ">"))
	    lines.df$tag[ tag_start:tag_end ] <- tags[i]
	}

	unrecognized_lines <- lines.df$line[ lines.df$tag == "" ]
	unrecognized_tags <- grep(value=TRUE, "^<", unrecognized_lines)
	unrecognized_tags <- grep(invert=TRUE, value=TRUE, "^</", unrecognized_tags)
	if (length(unrecognized_tags) > 0) {
	    warning(paste0("Unrecognized tags: ", paste(collapse=" ", unrecognized_tags)))
	}

	lines.df <- lines.df[ (lines.df$tag != ""), ]
	lines.df <- lines.df[ !grepl("<", lines.df$line), ]
	lines.df <- lines.df[ !grepl("</", lines.df$line), ]

	ID_lnum <- grep("^ID,", lines.df$line)
	lines.df$line[ID_lnum] <- paste0( sub("_Attributes", "", lines.df$tag[ID_lnum]), lines.df$line[ID_lnum] )

	rcc.ls <- list()

	rcc.ls$File_path <- rcc

	for (attr_tag in c("Header", "Sample_Attributes", "Lane_Attributes")) {
		attr_lnum <- which(lines.df$tag == attr_tag)
		attr.strsplit <- strsplit(lines.df$line[attr_lnum], ",")
		attr.v <- vapply(attr.strsplit, function(x) {if (!is.na(x[2])) {x[2]} else {""}}, character(1))
		names(attr.v) <- vapply(attr.strsplit, function(x) {x[1]}, character(1))
		rcc.ls[[attr_tag]] <- attr.v
	}

	Code_Summary_lnum.all <- which(lines.df$tag == "Code_Summary")
	Code_Summary_lnum.header <- Code_Summary_lnum.all[1]
	Code_Summary_lnum.body <- Code_Summary_lnum.all[2:length(Code_Summary_lnum.all)]

	if (lines.df$line[Code_Summary_lnum.header] != "CodeClass,Name,Accession,Count") {
	    stop(
	        paste0("Unrecognized header line for Code_Summary section of \"", rcc.ls, "\"",
	            " (expected \"CodeClass,Name,Accession,Count\" but got \"", lines.df$line[Code_Summary_lnum.header], "\")")
	    )
	}

	Code_Summary_fields <- strsplit(lines.df$line[Code_Summary_lnum.body], ",")
	rcc.ls$Code_Summary <- data.frame(stringsAsFactors=FALSE
		,CodeClass   = vapply(Code_Summary_fields, function(x) {x[1]}, character(1))
		,Name        = vapply(Code_Summary_fields, function(x) {x[2]}, character(1))
		,Accession   = vapply(Code_Summary_fields, function(x) {x[3]}, character(1))
		,Count       = vapply(Code_Summary_fields, function(x) {x[4]}, character(1))
	)

    if(removeSpikeInLabels)
    {
        spikein <- getSpikeInInput(CodeClass=rcc.ls$Code_Summary$CodeClass, GeneName=rcc.ls$Code_Summary$Name)
        rcc.ls$Code_Summary$Name <- spikein$GeneName
    }

	return(rcc.ls)
}

##' @title          rccFiles.to.pdata_fdata_adata
##' @description    First stage of readRccBatch(): produces a list containing matrices (for pdata and adata) and a data frame (for fdata) that
##'                 pdata_fdata_adata.to.rccSet() then transforms into a full RccSet (after some further checks and adjustments).
##'                 See also nSolverCsv.to.pdata_fdata_adata().
##'
##' @param  rccFiles  Vector of .RCC paths
##'
##' @return
##' A list containing matrices (for pdata and adata) and a data frame (for fdata)
##' that pdata_fdata_adata.to.rccSet() then transforms into a full ExpessionSet.
##'
##' @author Robert Ziman
##'
rccFiles.to.pdata_fdata_adata <- function(rccFiles)
{
    if (missing(rccFiles) || is.null(rccFiles) || length(rccFiles) == 0)
        stop("rccFiles argument is missing, NULL, or empty")

	rcc_1 <- readRcc( rccFiles[1] )

    filename <- basename( rccFiles[1] )
    names(filename) <- "FileName"
	rcc_1.pdata <- c(filename, rcc_1$Header, rcc_1$Sample_Attributes, rcc_1$Lane_Attributes)
	rcc_1.fdata <- data.frame(stringsAsFactors=FALSE
		,CodeClass   = rcc_1$Code_Summary$CodeClass
		,GeneName    = rcc_1$Code_Summary$Name
		,Accession   = rcc_1$Code_Summary$Accession
	)
	rcc_1.adata <- as.integer(rcc_1$Code_Summary$Count)

	pdata.m <- matrix(NA, nrow=length(rccFiles), ncol=length(rcc_1.pdata))
	colnames(pdata.m) <- names(rcc_1.pdata)
	pdata.m[1, ] <- rcc_1.pdata

	fdata.df <- rcc_1.fdata

	adata.m.t <- matrix(NA, nrow=length(rccFiles), ncol=nrow(rcc_1.fdata))
	adata.m.t[1, ] <- rcc_1.adata

	for (i in 2:length(rccFiles))
	{
		rcc <- readRcc( rccFiles[i] )

        filename <- basename( rccFiles[i] )
        names(filename) <- "FileName"
		rcc.pdata <- c(filename, rcc$Header, rcc$Sample_Attributes, rcc$Lane_Attributes)
		rcc.fdata <- data.frame(stringsAsFactors=FALSE
			,CodeClass   = rcc$Code_Summary$CodeClass
			,GeneName    = rcc$Code_Summary$Name
			,Accession   = rcc$Code_Summary$Accession
		)
		rcc.adata <- as.numeric(rcc$Code_Summary$Count)

		if (!identical(names(rcc.pdata), names(rcc_1.pdata))) {
			stop(
				paste0("The attribute labels in the Header, Sample_Attributes, and Lane_Attributes sections of \"", filename,
					"\" don't exactly match those in the other RCC files parsed so far")
			)
		}
		if (!identical(rcc.fdata, rcc_1.fdata)) {
			stop(
				paste0("Values in the key cols (i.e. CodeClass, Name, and Accession) in the Code_Summary section of \"", filename,
					"\" don't exactly match those in the other RCC files parsed so far")
			)
		}

		pdata.m[i, ] <- rcc.pdata
		adata.m.t[i, ] <- rcc.adata
	}

    return( list(pdata.m=pdata.m, fdata.df=fdata.df, adata.m=t(adata.m.t)) )
}

##' @title          nSolverCsv.to.pdata_fdata_fdata
##' @description    First stage of readRccCollectorToolExport(): produces a list containing
##'                 matrices (for pdata and adata) and a data frame (for fdata) that
##'                 pdata_fdata_adata.to.rccSet then transforms into a full RccSet
##'                 (after some further checks and adjustments). Not intended for
##'                 external use; see also rccFiles.to.pdata_fdata_adata().
##'
##' @param  rccCollectorToolExport  Path to the nSolver RCC Collector Tool .CSV export.
##'
##' @return
##' A list containing matrices (for pdata and adata) and a data frame (for fdata)
##' that pdata_fdata_adata.to.rccSet() then transforms into a full ExpessionSet.
##'
##' @author Dorothee Nickles, Thomas Sandmann, Robert Ziman
##'
nSolverCsv.to.pdata_fdata_adata <- function(rccCollectorToolExport)
{
	csv <- read.csv(rccCollectorToolExport, header=FALSE, stringsAsFactors=FALSE)

    #
    # pdata
    #

    csv.fdata_linenums <- which(csv[, 1] %in% c("Endogenous", "Housekeeping"))
    if (length(csv.fdata_linenums) == 0)
    {
        stop("Expected but didn't find \"Endogenous\" or \"Housekeeping\" in the CodeClass column (the first column) of the input .CSV; check that the file contains the correct kind of data and is in the correct format")
    }
	pdata.m.t <- as.matrix( csv[1:(min(csv.fdata_linenums)-1), ] )
	rownames(pdata.m.t) <- pdata.m.t[, 1]

    # Strip the first col ("File Name" "Description" "Sample ID" ...) and the
    # next two cols (which should be blank in the pdata rows since they're
    # placeholders over the fdata GeneName and Accession cols so that the
    # pdata entries line up with the adata values).
    if ( !(all(pdata.m.t[, 2] == "") && all(pdata.m.t[, 3] == "")) ) {
        stop("Expected 2nd and 3rd cols of the .CSV's phenoData header (the first ~20 lines) to be empty")
    }
    pdata.m.t <- pdata.m.t[, -c(1,2,3)]

    # Check that the RLF field looks correct
    if ( !("Gene RLF" %in% rownames(pdata.m.t)) ) {
        stop("Expected but didn't find \"Gene RLF\" in the .CSV header section")
    }
    Gene_RLF.nonempty.unique <- unique(grep(value=TRUE, invert=TRUE, pattern="^ *$", x=pdata.m.t["Gene RLF", ]))
    if (length(Gene_RLF.nonempty.unique) == 0) {
        stop("Missing or empty values in \"Gene RLF\"")
    }
    if (length(Gene_RLF.nonempty.unique) > 1) {
        stop("The data seems to have been generated using more than one codeset (more than one unique value appears in \"Gene RLF\")")
    }

    # Remove header rows that have no info
    pdata_row_is_empty_throughout <- apply(pdata.m.t, 1, function(x) all(x == ""))
    if (any(pdata_row_is_empty_throughout)) {
        droppedRows <- rownames(pdata.m.t)[ pdata_row_is_empty_throughout ]
	    pdata.m.t <- pdata.m.t[ !pdata_row_is_empty_throughout, ]
		warning(
            paste0("The following rows in the .CSV's phenoData section (the first ~20 lines) were dropped since they have blank values throughout: \"",
                paste(collapse="\", \"", droppedRows), "\"")
        )
	}

    # Adjust "FOV Count" to "FovCount" and "FOV Counted" to "FovCounted"
    # (n.b. further error checking is in pdata_fdata_adata.to.rccSet())
    if ("FOV Count" %in% rownames(pdata.m.t)) {
        rownames(pdata.m.t)[ rownames(pdata.m.t) == "FOV Count" ] <- "FovCount"
    }
    if ("FOV Counted" %in% rownames(pdata.m.t)) {
        rownames(pdata.m.t)[ rownames(pdata.m.t) == "FOV Counted" ] <- "FovCounted"
    }

    # Remove any spaces in the labels and ensure that the first, which is the FileName column,
    # is actually labeled "FileName" (sometimes it may come in as "File name")
    rownames(pdata.m.t) <- gsub(" ", "", rownames(pdata.m.t))
    rownames(pdata.m.t)[1] <- "FileName"

    colnames(pdata.m.t) <- NULL

    #
    # fdata
    #

    fdata.df <- csv[min(csv.fdata_linenums):nrow(csv), 1:3]
    colnames(fdata.df) <- c("CodeClass", "GeneName", "Accession")

	#if (any(duplicated( fdata[, 2] )))
        #
        # GeneName duplication check: appeared in original readRccCollectorToolExport but no
        # longer needed since the feature names are now the concatenation of
        # CodeClass, GeneName, and Accession. -RZ 2015-01
        #

    #
    # adata
    #

    csv.adata <- csv[min(csv.fdata_linenums):nrow(csv), 4:ncol(csv)]
    adata.m <- data.matrix(csv.adata)
    dimnames(adata.m) <- NULL

    #
    # Final output
    #

    return( list(pdata.m=t(pdata.m.t), fdata.df=fdata.df, adata.m=adata.m) )
}

##' @title
##' pdata_fdata_adata.to.rccSet
##'
##' @description
##' Second stage of readRccBatch()/readRccCollectorToolExport() -- not intended for external use.
##'
##' @param  pdata_fdata_adata   List containing the pdata, fdata, and adata returned by
##'                             rccFiles.to.pdata_fdata_adata() or nSolverCsv.to.pdata_fdata_adata().
##'
##' @return
##'
##' An \code{\linkS4class{RccSet}} whose contents reflect the input data.
##'
##' @details
##' 
##' Note that a pseudo-count of 1 is always added to all measurements, to enable
##' subsequent log transformation of the data in cases where zero-counts are
##' present.
##'
##' N.B. The function currently expects certain columns to be present in
##' \code{pdata_fdata_a_data$pdata.m}, and it converts these to numerics. These
##' expectations should be incorporated into the class definition, and
##' conversion should only take place with a warning. Future updates will
##' address this.
##' 
##' @author Robert Ziman
##'
pdata_fdata_adata.to.rccSet <- function(pdata_fdata_adata)
{
    pdata.m  <- pdata_fdata_adata$pdata.m
    fdata.df <- pdata_fdata_adata$fdata.df
    adata.m  <- pdata_fdata_adata$adata.m

    # phenoData

    rownames(pdata.m) <- pdata.m[,"FileName"]

    pdata.adf <- new("AnnotatedDataFrame", data=as.data.frame(pdata.m, stringsAsFactors = FALSE))

    pdata.adf$BindingDensity <- as.numeric(pdata.adf$BindingDensity)
    pdata.adf$LaneID <- as.numeric(pdata.adf$LaneID)
    pdata.adf$FovCount <- as.numeric(pdata.adf$FovCount)
    pdata.adf$FovCounted <- as.numeric(pdata.adf$FovCounted)
    pdata.adf$StagePosition <- as.numeric(pdata.adf$StagePosition)

    # featureData

    rownames(fdata.df) <- with(fdata.df, paste0(CodeClass, "_", GeneName, "_", Accession)) # N.B. the same string is used as the merge key for adding annotations (see addCodesetAnnotation())
    fdata.adf <- new("AnnotatedDataFrame", data=fdata.df)

    # assayData

    dimnames(adata.m) <- list(rownames(fdata.df), rownames(pdata.m))

    # Output RccSet

    rccSet <- RccSet( adata.m, phenoData = pdata.adf, featureData = fdata.adf )
    
    # Pseudocount

    exprs(rccSet) <- exprs(rccSet) + 1

    return(rccSet)
}

##' @title
##' Read RCC files
##'
##' @description
##'
##' Reads the contents of all .RCC files from a given directory into a new
##' RccSet object. Note: this function is not intended for external use. For
##' that, see newRccSet().
##'
##' @param  rccFiles  Vector of .RCC file paths
##'
##' @return
##'
##' An RccSet object that has raw counts in assayData, probe information
##' in fData, and sample annotation in pData.
##'
##' @author Robert Ziman
##'
readRccBatch <- function(rccFiles)
{
    pdata_fdata_adata <- rccFiles.to.pdata_fdata_adata(rccFiles)
    rccSet <- pdata_fdata_adata.to.rccSet(pdata_fdata_adata)
    return(rccSet)
}

##' @title
##' Read RCC Collector Tool Export
##'
##' @description
##' Reads the contents of a .CSV file generated from the RCC Collector Tool Export feature
##' of NanoString's nSolver Analysis software into a new RccSet object.
##' (Note: this function is not intended for external use. For that, see newRccSet().)
##'
##' @details
##' See 'details' in the readRccBatch() help page.
##'
##' @param  file    Path to the NSolver .CSV file to be read.
##'
##' @return
##' An RccSet object that has count data in exprs, probe
##' information in fData and sample annotation in pData.
##'
##' @author Dorothee Nickles, Thomas Sandmann
##'
readRccCollectorToolExport <- function(file)
{
    #stringsAsFactors.prev <- getOption("stringsAsFactors")

    pdata_fdata_adata <- nSolverCsv.to.pdata_fdata_adata(file)
    rccSet <- pdata_fdata_adata.to.rccSet(pdata_fdata_adata)

    #options(stringsAsFactors = stringsAsFactors.prev)

    if(!validObject(rccSet)) {
        stop( paste0("validObject() returns FALSE on rccSet generated from NSolver .CSV file \"", file, "\"") )
    }

    return(rccSet)
}

##' @title
##' getSpikeInInput
##'
##' @description
##' Gets the RNA \dQuote{spike-in} input levels for positive and negative control probes from the label in their GeneName.
##' Note that this is a helper function for readRlf() and elsewhere and is not intended for external use.
##'
##' @param CodeClass        Character vector with code classes for each probe.
##' @param GeneName         Character vector with gene names/symbols for each probe.
##' @param nonCtrlProbeVal  Value to assign as the spike-in input for the non-control probes.
##'
##' @return
##' A data frame with the input CodeClass and GeneName but where the latter has been split into
##' two columns: one showing the GeneName for each probe with spike-in input labels removed
##' -- and another with the spike-in input levels.
##'
##' @author Robert Ziman
##
getSpikeInInput <- function(CodeClass, GeneName, nonCtrlProbeVal=NA)
{
    stopifnot(!is.null(CodeClass))
    stopifnot(!is.null(GeneName))
    stopifnot(length(CodeClass) == length(GeneName))

    GeneName.split <- strsplit(GeneName, '\\(')
    GeneName.without_parentheses <- vapply(GeneName.split, function(x) {x[1]}, character(1))
    SpikeInInput.char <- sub('\\)$', '', vapply(GeneName.split, function(x) {x[2]}, character(1)))

    ctrls <- (CodeClass %in% c("Positive", "Negative"))

    GeneName.adjusted <- GeneName
    GeneName.adjusted[ ctrls ] <- GeneName.without_parentheses[ ctrls ]     # Only strip the labels from the control probes (in some cases there will be GeneNames with parentheses!)

    SpikeInInput <- rep(nonCtrlProbeVal, length(GeneName))
    SpikeInInput[ ctrls ] <- as.numeric(SpikeInInput.char[ ctrls ])

    return(
        data.frame(stringsAsFactors=FALSE,
            CodeClass   = CodeClass,
            GeneName    = GeneName.adjusted,
            SpikeInInput = SpikeInInput
        )
    )
}

##' @title
##' Read RLF file
##'
##' @description
##' Reads the contents of an .RLF file into a data frame. RNA \dQuote{spike-in} concentrations recorded in the
##' GeneName for positive and negative control probes are stripped and stored in a separate
##' column in the output. An error will be generated for any recognized deviations from the
##' expected file format.
##'
##' @param  rlf     Path to the .RLF file
##'
##' @return
##' A data frame containing the contents of the .RLF file.
##'
##' @export
##'
##' @examples
##' rlf <- system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro")
##' rlf.df <- readRlf(rlf)
##'
##' @author Robert Ziman
##'
readRlf <- function(rlf)
{
    if (!file.exists(rlf)) {
        stop(sprintf("rlf \"%s\" not found", rlf))
    }

	suppressWarnings(
		all.lines <- readLines(rlf)
                        #
                        # N.B. readLines() appears to automatically strip any trailing carriage returns (^M, 0xD)
                        # from files coming from Windows, etc.
                        #
	)

	i <- which(all.lines == "[Content]")

	if (!(    grepl("^ColumnCount=", all.lines[i+1])
           && grepl("^RecordCount=", all.lines[i+2])
           && grepl("^Columns=",     all.lines[i+3]) ))
	{
		stop("expected but did not find \"ColumnCount=\", \"RecordCount=\", and \"Columns=\" lines after \"[Content]\"")
	}

	nrec <- as.integer(sub("RecordCount=", "", all.lines[i+2]))

	content.lines.header <- all.lines[i+3]
	content.lines.header <- sub("Columns=", "", content.lines.header)

    i_content.lines.records_start <- i+4
    i_content.lines.records_end <- i+4+nrec-1
    if (i_content.lines.records_end != length(all.lines)) {
        stop("mismatch between RecordCount and the number of records actually in the file")
    }
	content.lines.records <- all.lines[ (i+4):(i+4+nrec-1) ]
	content.lines.records <- sub("Record[0-9]*=", "", content.lines.records)

	content.lines <- c(content.lines.header, content.lines.records)
	
	tc <- textConnection(content.lines)
	rlf.df <- read.csv(tc, header=TRUE, as.is=TRUE)

    classnames.lines <- all.lines[ grepl("^ClassName", all.lines) ]
    classnames.lines.strsplit <- strsplit(classnames.lines, "=")
    classnames        <- vapply(classnames.lines.strsplit, function (x) {x[2]}, character(1))
    names(classnames) <- vapply(classnames.lines.strsplit, function (x) {x[1]}, character(1))

    rlf.df$ClassNameID <- paste0("ClassName", rlf.df$Classification)
    rlf.df$ClassName <- as.character( classnames[rlf.df$ClassNameID] )
    rlf.df$Classification <- NULL
    rlf.df$ClassNameID <- NULL

    #rlf.df <- rlf.df[ !(rlf.df$ClassName == "Reserved"), ]     # TODO: check if this will ever be an issue
    #rlf.df <- rlf.df[ !(rlf.df$ClassName == "Binding"), ]
    #rlf.df <- rlf.df[ !(rlf.df$ClassName == "Purification"), ]
    rlf.df <- rlf.df[ !(rlf.df$ClassName %in% c("Reserved", "Binding", "Purification")), ]

    spikein <- getSpikeInInput(CodeClass=rlf.df$ClassName, GeneName=rlf.df$GeneName, nonCtrlProbeVal=0)
    rlf.df$GeneName <- spikein$GeneName
    rlf.df$SpikeInInput <- spikein$SpikeInInput

    ctrls <- (rlf.df$ClassName %in% c("Positive", "Negative"))
    if (any(is.na(rlf.df$SpikeInInput[ ctrls ]))) {
        stop("Missing or malformed spike-in labels in GeneName for some control probes")
    }

    if (any(is.na(rlf.df$Accession))) {
        stop("Missing accessions for some entries")
    }

    colnames(rlf.df)[ colnames(rlf.df) == "ClassName" ] <- "CodeClass"

    return(rlf.df)
}

##' @title          Read .CSV containing CDR 'Design Data' extract
##' @description    Return a data frame containing the contents of the 'Design Data' tab
##'                 extracted from a CDR spreadsheet. The extract, a .CSV file, must be
##'                 manually prepared in advance (see 'details' section in the
##'                 buildCodesetAnnotation() help page for more info).
##'
##' @param  cdrDesignData    Path to the .CSV file containing the content extracted from the CDR's 'Design Data' tab
##'
##' @return
##' A data frame containing the contents of the CDR 'Design Data' tab.
##'
##' @export
##'
##' @examples
##' path <- system.file("extdata", "CDR", "CDR-DesignData.csv", package="NanoStringQCPro")
##' cdr <- readCdrDesignData(path)
##'
##' @author Robert Ziman
##'
readCdrDesignData <- function(cdrDesignData)
{
    if (!file.exists(cdrDesignData)) {
        stop(
            paste0("CDR Design Data .CSV \"", cdrDesignData, "\" not found")
        )
    }

    cdr <- read.csv(cdrDesignData, header=TRUE, as.is=TRUE)

    if (!"Customer.Identifier" %in% colnames(cdr)) {
        stop(
            paste0("'Customer Identifier' not found in CDR Design Data \"", cdrDesignData,
                "\"; check that the file has the right format (see details in buildCodesetAnnotation() help page)")
        )
    }

    if (which(colnames(cdr) == "Customer.Identifier") == 2) {
        cdr <- cdr[, -1]     # TODO: Confirm exactly what the column is that's being dropped here -RZ 2015-02-12
    }

    tmp <- which(colnames(cdr) == "Comments")
    cdr <- cdr[, 1:tmp]

    if (any(is.na(cdr$Accession))) {
        cdr <- cdr[!is.na(cdr$Accession), ]
        warning(
            paste0("Dropped some rows in CDR Design Data \"", cdrDesignData, "\" since their Accession field was empty")
        )
    }

    return(cdr)
}

##' @title          Build NanoString codeset annotation
##' @description    This function returns a data frame whose content is the combination of
##'                 the NanoString-provided codeset annotation (.RLF file and the
##'                 "Design Data" tab of the CDR spreadsheet) with gene annotation in the
##'                 org.Hs.eg.db package. 
##'
##' @param  rlf                     Path to the RLF file
##' @param  cdrDesignData           Path to a manually prepared .CSV export of the
##'                                 "Design Data" tab of the CDR file (optional;
##'                                 see 'details' section below for how the export
##'                                 should be prepared)
##' @param  removeRedundantCols     Logical. If TRUE, cols in the CDR that are redundant
##'                                 with those in the RLF will be omitted from the output.
##' @param  addEgAnnotations        Logical indicating whether or not to add
##'                                 EntrezGene IDs and HGNC symbols from the
##'                                 org.Hs.eg.db package.
##'
##' @return
##' A data frame whose content is the combination of the NanoString-provided
##' codeset annotation with gene annotation in the org.Hs.eg.db package.
##'
##' @details
##' The original NanoString provided .RLF file is expected as input. This
##' file is the master (i.e. only probes listed here will be annotated;
##' any extra ones in the CDR export will be dropped). If
##' the CDR "Design Data" .CSV is specified, the function expects this .CSV
##' file to be generated from the "Design Data" tab of the original NanoString
##' provided Excel CDR file. This tab needs to be trimmed by skipping the
##' NanoString header and first column containing only integers;
##' the resulting .CSV should contain the actual table (including its header
##' -- beginning with "Customer Identifier"). The function will match and
##' join the .RLF and CDR .CSV using their "ProbeID" and "NSID" fields, and
##' then it will add gene annotation (EntrezGene ID, HGNC symbol, and
##' chromosomal position) by doing lookups in the org.Hs.eg.db package using
##' the RefSeq accessions from the RLF.
##'
##' @import
##' org.Hs.eg.db
##' AnnotationDbi
##'
##' @export
##'
##' @examples
##'	rlf <- system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro")
##'	cdrDesignData <- system.file("extdata", "CDR", "CDR-DesignData.csv", package="NanoStringQCPro")
##'	annot <- buildCodesetAnnotation(rlf, cdrDesignData)
##'
##' @author Dorothee Nickles, Robert Ziman
##'
buildCodesetAnnotation <- function(rlf=NULL,
                                   cdrDesignData=NULL,
                                   removeRedundantCols=TRUE,
                                   addEgAnnotations=FALSE)
{
    if (is.null(rlf)) {
        stop("RLF not specified")
    }
    rlf.df <- readRlf(rlf)

    if (!is.null(cdrDesignData))
    {
        cdr <- readCdrDesignData(cdrDesignData)

        misProbes <- summary(cdr$NSID %in% rlf.df$ProbeID)["FALSE"]
        if (!is.na(misProbes)) {
            warning(sprintf("%s probe(s) in the CDR have no entry in the RLF. These will be excluded from annotation.", misProbes))
        }
    
        annot <- merge(rlf.df, cdr, by.x="ProbeID", by.y="NSID", all.x=TRUE, suffixes=c("", "_CDR"))

        tmp <- is.na(annot$PN.CP.RP.)
        annot$PN.CP.RP.[tmp] <- annot$ProbeID[tmp]

        if (removeRedundantCols)
        {
            annot$Accession_CDR <- NULL     # redundant with Accession
            annot$Gene <- NULL              # redundant with GeneName
            if ("TargetSeq" %in% colnames(annot)) {
                annot$Target.Sequence <- NULL
            }
        }
    }
    else {
        annot <- rlf.df
    }

    if (addEgAnnotations == TRUE)
    {
        #
        # N.B. Before renaming any of the cols below, check for references to them.
        # Other parts of the code, QC template, or old import scripts may depend on
        # these columns having the precise names they have here. In turn, see
        # createExpressionplotAnnot() for renaming of some of the columns
        # to the precise names ExpressionPlot expects...
        # -RZ 2015-01-19
        #

        annot$RefSeqMrna <- vapply(as.character(annot$Accession), function(x) {unlist(strsplit(x, "[.]"))[1]}, character(1))

        #
        # EntrezGene ID
        #
        gene_ids <- AnnotationDbi::mget(
            annot$RefSeqMrna,
            org.Hs.egREFSEQ2EG,
            ifnotfound = NA_character_
        )
        if ( !all( vapply(gene_ids, length, integer(1)) == 1 ) ) {
            stop( "Unexpected length for some org.Hs.egREFSEQ2EG lookup results" )
        }
        annot$GeneID <- unlist( gene_ids )

        nonNA_geneID <- !is.na(annot$GeneID)

        #
        # HGNC symbol
        #
        hgnc_symbols <- AnnotationDbi::mget(
            annot$GeneID[ nonNA_geneID ],
            org.Hs.egSYMBOL,
            ifnotfound = NA_character_
        )
        if (!all( vapply(hgnc_symbols, length, integer(1)) == 1 )) {
            stop("Unexpected length for some org.Hs.egSYMBOL lookup results")
        }
        annot$Hgnc_Symbol[ nonNA_geneID ] <- unlist(hgnc_symbols)
    }

    #
    # Output
    #

    annot <- annot[ order(annot$Accession), ]

    #if (!is.null(annotPath)) {
    #    write.table(annot, file=annotPath, sep=",", row.names=FALSE)           # Removed as per decision
    #    message(paste0("Wrote codeset annotation to \"", annotPath, "\""))     # following the code review.
    #}                                                                          # -RZ 2015-03-25

    return(annot)
}


setGeneric( "addCodesetAnnotation", function( rccSet, ... ) standardGeneric( "addCodesetAnnotation" ) )

##' @rdname addCodesetAnnotation
##' @aliases addCodesetAnnotation
##'
##' @title          Add NanoString codeset annotation to an RccSet
##' @description    Returns a copy of the input RccSet where the codeset annotation
##'                 has been merged into its fData slot. The merge key for each is a string
##'                 formed from the concatenation of their CodeClass, GeneName, and
##'                 Accession columns ("<CodeClass>_<GeneName>_<Accession>"). For creating
##'                 the codeset annotation object, see buildCodesetAnnotation().
##'
##' @param  rccSet          An RccSet object.
##' @param  annot           Data frame containing the codeset annotation.
##' @param  reorder         Logical indicating whether the probes should be reordered
##'                         according to their barcodes (this can help in identifying
##'                         barcode-specific artifacts -- i.e. background noise).
##' @param  showWarnings    Logical indicating whether or not warnings should be shown, if any.
##'
##' @return
##' A copy of the input RccSet where the codeset annotation has been
##' merged into its fData slot.
##'
##' @export
##'
##' @examples
##' rccDir <- system.file("extdata", "RCC", package="NanoStringQCPro")
##' rccSet <- newRccSet(rccFiles = dir(rccDir, full.names=TRUE))
##' rlf <- system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro")
##' annot <- buildCodesetAnnotation(rlf)
##' rccSet.annotated <- addCodesetAnnotation(rccSet, annot)
##'
##' @author Dorothee Nickles, Robert Ziman
##'
setMethod(
    "addCodesetAnnotation",
    "RccSet",
    function( rccSet, annot, reorder=TRUE, showWarnings=TRUE )
    {
        fdata <- fData(rccSet)

        CodeClass <- NULL   # prevent BiocCheck warning
        GeneName <- NULL
        Accession <- NULL
        fdata$mergekey <- with(fdata, paste0(CodeClass, "_", GeneName, "_", Accession))
        annot$mergekey <- with(annot, paste0(CodeClass, "_", GeneName, "_", Accession))

        annot$mergeflag <- rep(TRUE, nrow(annot))

        fdata.annot <- merge(
            fdata
            ,annot
            ,by.x="mergekey"
            ,by.y="mergekey"
            ,all.x=TRUE
            ,suffixes=c("", "_codesetAnnot")
        )

        fdata.annot$CodeClass_codesetAnnot <- NULL
        fdata.annot$Accession_codesetAnnot <- NULL
        fdata.annot$GeneName_codesetAnnot <- NULL

        if (showWarnings && any(grepl('_codesetAnnot$', colnames(fdata.annot))))
            {
                warning("The names of some columns in the codeset annotation were identical to those already in the rccSet's fData. To distinguish them from the fData columns in the input, the output's fData has these columns suffixed with \"_codesetAnnot\".")
            }

        # merge() messes up the order of the rows -- put them back as they were!
        fdata.annot <- fdata.annot[ match(fdata$mergekey, fdata.annot$mergekey), ]

        # Error out if any of the features didn't have a matching entry in annot. This should
        # hopefully take care of anything incomplete, mistaken, or unusual in the RLF.
        mergeflag_NA <- which(is.na(fdata.annot$mergeflag))
        if (length(mergeflag_NA) > 0)
            {
                stop(
                    paste0("could not find annotations for some features ",
                           ifelse(length(mergeflag_NA) <= 3, "", "(only the first few shown here)"),
                           ": ", paste(collapse=", ", fdata.annot$mergekey[ head(mergeflag_NA, n=3) ]))
                    )
            }
        fdata.annot$mergeflag <- NULL

        fdata.annot$mergekey <- NULL
        rownames(fdata.annot) <- rownames(fdata)

        rccSet.annot <- copyRccSet(rccSet) # Using copyRccSet() to be *sure* the original doesn't get affected in later code!
        fData(rccSet.annot) <- fdata.annot

        if (reorder == TRUE) {
            if (is.null(fData(rccSet.annot)$BarCode)) {
                stop("reorder == TRUE but featureData BarCode column is missing")
            }
            rccSet.annot <- rccSet.annot[order(fData(rccSet.annot)$BarCode),]
            rccSet.annot <- rccSet.annot[order(fData(rccSet.annot)$CodeClass),]
        }

        return(rccSet.annot)
    }
    )



##' @title
##' Create a new RccSet object
##'
##' @description
##' 
##' This is the main wrapper function for generating an RccSet from NanoString
##' data. The function takes as input a vector of NanoString .RCC files with the
##' raw data or a .CSV file generated via the RCC Collector Tool Export feature
##' of NanoString's nSolver Analysis Software, an optional path to the .RLF file
##' describing the codeset used, optional paths to additional annotation about
##' the features and samples, and details about the experiment. It returns an
##' RccSet object.
##'
##' @param  rccFiles                Vector of paths to .RCC files with the raw count data.
##' 
##' @param  rccCollectorToolExport  Path to a .CSV file generated via the RCC Collector
##'                                 Tool Export feature of NanoString's nSolver
##'                                 Analysis Software. (Note that this is an alternative
##'                                 to rccFiles, and if both arguments are specified at the
##'                                 same time, the function will throw an error.)
##'
##' @param  rlf                     Path to the NanoString .RLF file describing
##'                                 the codeset used in generating the .RCCs. 
##' 
##' @param  cdrDesignData           Path to a .CSV extract of the "Design Data"
##'                                 tab of a CDR spreadsheet corresponding to the
##'                                 rest of the input files. See 'Details'
##'                                 section of the buildCodesetAnnotation() help page
##'                                 for more info on how this extract should be
##'                                 prepared.
##' 
##' @param  extraPdata              Vector of paths to files containing additional
##'                                 annotation about the samples which will be added
##'                                 to the phenoData of the output RccSet. All
##'                                 files should be tab-separated and should contain
##'                                 a column labelled "FileName" whose values correspond
##'                                 exactly to the basenames (including .RCC extension)
##'                                 of the files specified in rccFiles or listed in
##'                                 the RCC Collector Tool Export. More than one such file
##'                                 may be used. A SampleType column should be present
##'                                 in at most one file.
##' 
##' @param  blankLabel              Value for the output's phenoData SampleType column
##'                                 that will indicate blank samples. This will be
##'                                 recorded in the varMetadata for
##'                                 SampleType. Blank samples, if available,
##'                                 play an important role in preprocessing.
##' 
##' @param  addEgAnnotations        Logical indicating whether or not to add
##'                                 EntrezGene annotations from the org.Hs.eg.db
##'                                 package.
##'
##' @param  dropPdataCols           Character vector specifying phenoData columns
##'                                 to be dropped from the output object (if empty or
##'                                 NULL, no columns will be dropped).
##'
##' @param  dropFdataCols           Character vector specifying featureData columns
##'                                 to be dropped from the output object (if empty or
##'                                 NULL, no columns will be dropped).
##'
##' @param  experimentData.name     String passed to the 'name' slot of the
##'                                 output RccSet's experimentData.
##' 
##' @param  experimentData.lab      String passed to the 'lab' slot of the
##'                                 output RccSet's experimentData.
##' 
##' @param  experimentData.contact  String passed to the 'contact' slot of the
##'                                 output RccSet's experimentData.
##' 
##' @param  experimentData.title    String passed to the 'title' slot of the
##'                                 output RccSet's experimentData.
##' 
##' @param  experimentData.abstract String passed to the 'abstract' slot of the
##'                                 output RccSet's experimentData.
##' 
##' @param  experimentData.url      String passed to the 'url' slot of the
##'                                 output RccSet's experimentData.
##' 
##' @param  experimentData.other    List passed to the 'other' slot of the
##'                                 output RccSet's experimentData.
##'
##' @return
##' 
##' An \code{\linkS4class{RccSet}} containing the raw NanoString data and annotations.
##'
##' @details
##' 
##' In the .RLF (and sometimes in the .RCC files), the GeneName field for
##' positive and negative control probes contains a parenthesized label
##' indicating the RNA \dQuote{spike-in} levels for each probe. These labels are
##' removed from the control probe GeneNames in the output and recorded instead
##' in SpikeInInput in the output's featureData.
##'
##' A pseudocount of 1 is added to all measurements to enable subsequent
##' log transformation of the data.
##'
##' If the phenoData SampleType column is not specified via an annotation file
##' passed in through extraPdata, it will be created and assigned NA for all
##' samples.
##'
##' @import Biobase
##'
##' @export
##'
##' @examples
##' rccDir <- system.file("extdata", "RCC", package="NanoStringQCPro")
##' rccSet <- newRccSet(
##'     rccFiles = dir(rccDir, full.names=TRUE),
##'     rlf = system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro"),
##'     extraPdata = system.file("extdata", "extraPdata", "SampleType.txt", package="NanoStringQCPro"),
##'     blankLabel = "blank",
##'     experimentData.name = "Robert Ziman",
##'     experimentData.lab = "Richard Bourgon",
##'     experimentData.contact = "ziman.robert@@gene.com",
##'     experimentData.title = "NanoStringQCPro example dataset",
##'     experimentData.abstract = "Example data for the NanoStringQCPro package"
##' )
##'
##' @author Robert Ziman
##'
newRccSet <- function(rccFiles,
                      rccCollectorToolExport    = NULL,
                      rlf                       = NULL,
                      cdrDesignData             = NULL,
                      extraPdata                = NULL,
                      blankLabel                = "blank",
                      addEgAnnotations          = FALSE,
                      dropPdataCols             = c("FileVersion",
                                                    "SoftwareVersion",
                                                    "Owner",
                                                    "SystemAPF",
                                                   #"FovCount",             # Required in the QC report
                                                   #"FovCounted",           # Required in the QC report
                                                    "ScannerID",
                                                   #"StagePosition",        # Required in the QC report
                                                   #"BindingDensity",       # Required in the QC report
                                                   #"CartridgeID",          # See comment by corresponding line in createOrUpdateEpProject() (in NanoStringQCProGNE)
                                                    "CartridgeBarcode"
                                                    ),
                      dropFdataCols             = c("CodeClass_codesetAnnot",
                                                    "Accession_codesetAnnot",
                                                    "GeneName_codesetAnnot",
                                                    "Accession_CDR"
                                                    ),
                      experimentData.name       = "",
                      experimentData.lab        = "",
                      experimentData.contact    = "",
                      experimentData.title      = "",
                      experimentData.abstract   = "",
                      experimentData.url        = "",
                      experimentData.other      = list())
{
    if (!missing(rccFiles) && !is.null(rccFiles))
    {
        if(!missing(rccCollectorToolExport) && !is.null(rccCollectorToolExport)) {
            stop("Both rccFiles and rccCollectorToolExport are specified")
        }

        if (grepl('\\.csv$', tolower(rccFiles[1]))) {
            stop("A .CSV file appears to have been specified as the rccFiles argument (if this is the RCC Collector Tool Export, specify its path in the rccCollectorToolExport argument instead)")
        }

        message("Reading RCC files...")
        rccSet <- readRccBatch(rccFiles)

    } else if(!missing(rccCollectorToolExport) && !is.null(rccCollectorToolExport)) {

        message("Reading RCC Collector Tool Export...")
        rccSet <- readRccCollectorToolExport(rccCollectorToolExport)

    } else {
        stop("Either rccFiles or rccCollectorToolExport must be specified")
    }
                                  
    experimentData(rccSet) <- new("MIAME",
                                  name       = experimentData.name,
                                  lab        = experimentData.lab,
                                  contact    = experimentData.contact,
                                  title      = experimentData.title,
                                  abstract   = experimentData.abstract,
                                  url        = experimentData.url,
                                  other      = experimentData.other)

    GeneRLF <- unique(as.character(pData(rccSet)$GeneRLF))
    if (length(GeneRLF) != 1) {
        stop("Expecting exactly one RLF file to be referenced by all RCC files; check RCCs or RCC Collector Tool Export")
    }
    annotation(rccSet) <- GeneRLF
    pData(rccSet)$GeneRLF <- NULL # Removing it from pData since it's now in annotation(rccSet)

    if (!is.null(rlf))
    {
        rlfFile <- basename(rlf)
        if (grepl('\\.rlf$', rlfFile)) {
            rlfFile.noext <- sub('\\.rlf$', '', rlfFile)
        } else if (grepl('\\.RLF$', rlfFile)) {
            rlfFile.noext <- sub('\\.RLF$', '', rlfFile)
        }
        if (GeneRLF != rlfFile.noext) {
            stop(paste0("Specified RLF (\"", rlf, "\") doesn't match that in the input RCCs or RCC Collector Tool Export (\"", GeneRLF, "\")"))
        }
    }

    if ((!is.null(extraPdata)) && (length(extraPdata) > 0))
        {
            new_pdata <- pData(rccSet)

            for(i in 1:length(extraPdata))
                {
                    extraPdataPath <- extraPdata[i]

                    if (!file.exists(extraPdataPath))
                        stop( paste0("extraPdata file does not exist: \"", extraPdataPath, "\"") )

                    xpd <- read.table(file=extraPdataPath, header=TRUE, sep="\t", stringsAsFactors=FALSE, comment.char="")

                    colnames(xpd)[ tolower(colnames(xpd)) == "filename" ] <- "FileName"
                    colnames(xpd)[ tolower(colnames(xpd)) == "sampletype" ] <- "SampleType"

                    if (!("FileName" %in% colnames(xpd)))
                        stop( "extraPdata file \"", extraPdataPath, "\" is missing the \"FileName\" column" )

                    missing_samples <- setdiff( pData(rccSet)$FileName, xpd$FileName )
                    if ( length( missing_samples ) > 0 )
                        stop( "Some samples were not found in extraPdata file \"", extraPdataPath, "\": ", paste( missing_samples, collapse = ", " ) )

                    if (any(duplicated(xpd$FileName)))
                        stop( "Duplicate entries found (check FileName column) in extraPdata file \"", extraPdataPath, "\"" )

                    if (nrow(xpd) > ncol(rccSet))
                        warning( "Ignoring extraneous entries found in extraPdata file \"", extraPdataPath, "\"" )

                    if ( "SampleType" %in% colnames( xpd ) ) {
                        if ( !all( is.na( new_pdata$SampleType ) ) )
                            stop( "SampleType column being supplied by more than one extraPdata file" )
                        new_pdata$SampleType <- NULL
                    }

                    new_pdata <- merge(
                        new_pdata
                        ,xpd
                        ,by="FileName"
                        ,all.x=TRUE
                        ,all.y=FALSE
                        ,sort=FALSE
                        ,suffixes=c("", paste0("_", basename(extraPdata[i])))
                        )

                }

            # Ensure that the order of new_pdata exactly matches that in the
            # original (even with sort=FALSE, merge() doesn't necessarily ensure that).
            order_in_orig_pdata <- match(new_pdata$FileName, pData(rccSet)$FileName)
            new_pdata <- new_pdata[order_in_orig_pdata, ]
            stopifnot(identical(new_pdata$FileName, pData(rccSet)$FileName))

            # Restore the rownames (merge() mucks that up too).
            rownames(new_pdata) <- rownames(pData(rccSet))

            # Now, finally, the original pData can be updated.
            pData(rccSet) <- new_pdata
        }

    varMetadata( phenoData( rccSet ) )[ "SampleType", "labelDescription" ] <- paste0("blankLabel='", blankLabel, "'")

    if (!is.null(rlf))
    {
        # The codeset annotation should be rebuilt from input RLF/CDR/etc *every* time; the .CSV output to annotPath will thus
        # be just for reference. -RZ 2014-12-14
        annot <- buildCodesetAnnotation(
            rlf                 = rlf,
            cdrDesignData       = cdrDesignData,
            addEgAnnotations    = addEgAnnotations,
            removeRedundantCols = TRUE
            )
        rccSet <- addCodesetAnnotation(
            rccSet          = rccSet,
            annot           = annot,
            reorder         = TRUE,
            showWarnings    = FALSE
            )
    }

    #
    # Record the org.Hs.eg.db version
    #
    if (addEgAnnotations == TRUE) {

        if ("org.Hs.eg.db" %in% names(sessionInfo()$otherPkgs)) {
            org.Hs.eg.db_version <- sessionInfo()$otherPkgs$org.Hs.eg.db$Version

        } else if ("org.Hs.eg.db" %in% names(sessionInfo()$loadedOnly)) {
            org.Hs.eg.db_version <- sessionInfo()$loadedOnly$org.Hs.eg.db$Version

        } else {
            warning("Attempted to record org.Hs.eg.db version but did not find it in the expected locations in sessionInfo()")
        }

        preproc(rccSet)$org.Hs.eg.db_version <- org.Hs.eg.db_version

    } else {
        preproc(rccSet)$org.Hs.eg.db_version <- NA
    }

    # Remove superfluous columns (see also additional code in createOrUploadEpProject() (in NanoStringQCProGNE)).
    if (!is.null(dropPdataCols) && (length(dropPdataCols) > 0)) {
        for (x in dropPdataCols) {
            pData(rccSet)[[ x ]] <- NULL
        }
    }
    if (!is.null(dropFdataCols) && (length(dropFdataCols) > 0)) {
        for (x in dropFdataCols) {
            fData(rccSet)[[ x ]] <- NULL
        }
    }

    checkRccSet(rccSet, reportWarnings=TRUE, showMessages=TRUE)
    
    return(rccSet)

}



setGeneric( "posCtrlNorm", function( rccSet, ... ) standardGeneric( "posCtrlNorm" ) )

##' @rdname posCtrlNorm
##' @aliases posCtrlNorm
##'
##' @title
##' Positive control normalization
##'
##' @description
##' Applies positive control normalization to the data in an RccSet object.
##'
##' @param rccSet
##' An RccSet object.
##'
##' @param summaryFunction
##' Function to be used for the normalization (e.g. "mean", "median", or
##' "sum"). User-defined functions similar to these can be specified here as
##' well.
##'
##' @param quietly
##' Logical. If TRUE, messages and warnings will not be shown.
##'
##' @return
##' A copy of the input RccSet that has count data adjusted by positive control
##' counts. The positive control scaling factor is recorded in PosFactor in the
##' output's phenoData (if this column already exists in the input, it will
##' be overwritten in the output copy).
##'
##' @export
##'
##' @examples
##' data(example_rccSet)
##' pcnorm_example_rccSet <- posCtrlNorm(example_rccSet)
##'
##' @author Dorothee Nickles
##'
setMethod(
    "posCtrlNorm",
    "RccSet",
    function(rccSet,
             summaryFunction = "sum",
             quietly = FALSE)
    {
        if (!quietly && "posCtrlData" %in% ls(assayData(rccSet)))
            warning("Input already contains positive control normalized data")

        prccSet <- copyRccSet(rccSet)

        if (class(summaryFunction) == "character") {
            fun <- get(summaryFunction)
            summaryFunction.char <- summaryFunction
        }
        else {
            fun <- summaryFunction
            summaryFunction.char <- as.character(quote(summaryFunction))
        }

        posSignal <- apply(exprs(prccSet)[fData(prccSet)$CodeClass == "Positive", ], 2, fun)
        signalMean <- mean(posSignal)
        posFactor <- signalMean/posSignal

        if (!quietly && "posCtrlData" %in% ls(assayData(prccSet)))
            warning("Input already contains positive-control normalized data")

        assayData(prccSet)$posCtrlData <- t(apply(assayData(prccSet)$exprs, 1, function(x) { x * posFactor }))
        pData(prccSet)$PosFactor <- posFactor
        PosFactor.metadata_rownum <- which(rownames(varMetadata(phenoData(prccSet))) == "PosFactor")
        varMetadata(phenoData(prccSet))$labelDescription[ PosFactor.metadata_rownum ] <- "Positive control scaling factor"

        preproc(prccSet)$posCtrlData_summaryFunction <- summaryFunction.char

        return(prccSet)
    }
    )



setGeneric( "presAbsCall", function( rccSet, ... ) standardGeneric( "presAbsCall" ) )

##' @rdname presAbsCall
##' @aliases presAbsCall
##'
##' @title
##' Presence/absence call
##'
##' @description
##' Adds a matrix to assayData (`paData') which indicates the presence/absence
##' call for each gene in each sample using the background estimates and
##' a stringency value. A gene is considered present in a sample if
##' its count in that sample exceeds the corresponding background estimate
##' times the stringency. The count values can be taken from either the
##' positive control normalized data or the raw data (see
##' the inputMatrix agrument). If the input doesn't contain background-corrected
##' data, an error will be generated.
##'
##' @param rccSet
##' An RccSet with background-corrected data.
##'
##' @param stringency
##' Multiplier to use in establishing the presence/absence call as
##' mentioned in the description.
##'
##' @param inputMatrix
##' Name of the matrix in the RccSet's assayData on which to apply the
##' presence/absence call (either "posCtrlData" or "exprs").
##'
##' @param quietly
##' Logical. If TRUE, messages and warnings will not be shown.
##' 
##' @return
##' A copy of the input is returned with a new matrix named `paData' added to
##' the assayData that contains the presence/absence calls.
##'
##' @export
##'
##' @examples
##' data(example_rccSet)
##' pcnorm_rccSet <- posCtrlNorm(example_rccSet)
##' bgEst <- getBackground(pcnorm_rccSet)
##' bgcorr_rccSet <- subtractBackground(pcnorm_rccSet, bgEst)
##' pa_rccset <- presAbsCall(bgcorr_rccSet)
##'
setMethod(
    "presAbsCall",
    "RccSet",
    function(rccSet,
             stringency = 2,
             inputMatrix = c("posCtrlData", "exprs"),
             quietly = FALSE
            )
    {
        inputMatrix <- match.arg(inputMatrix)

        if (!("bgEstimates" %in% ls(assayData(rccSet))))
            stop("Background-corrected data required but not found in the input RccSet")

        bgEstimates <- assayData(rccSet)$bgEstimates

        M <- assayData(rccSet)[[ inputMatrix ]]
        if (is.null(M)) 
            stop(sprintf("Specified input matrix ('%s') is not present in the RccSet's assayData", inputMatrix)) 

        if (!quietly && "paData" %in% ls(assayData(rccSet)))
            warning("Input already contains a presence/absence matrix")

        parccSet <- copyRccSet(rccSet)
        assayData(parccSet)$paData <- (M > bgEstimates * stringency)
        preproc(parccSet)$paData_stringency <- stringency
        preproc(parccSet)$paData_inputMatrix <- inputMatrix

        return(parccSet)
    }
    )



setGeneric( "contentNorm", function( rccSet, ... ) standardGeneric( "contentNorm" ) )

##' @rdname contentNorm
##' @aliases contentNorm
##'
##' @title
##' Content normalization
##'
##' @description
##' Performs content normalization on the given RccSet.
##'
##' @param rccSet
##' An RccSet.
##'
##' @param method
##' Specifies the features to be used for normalization. "global" indicates that all
##' features should be used and "housekeeping" indicates that only housekeeping
##' features should be used. If "housekeeping" is specified and the `hk' argument
##' (below) is also specified, then the features indicated by `hk' will be used.
##' If "housekeeping" is specified and `hk' is left NULL, then the default
##' housekeeping features (i.e. those with CodeClass == "Housekeeping") will be used.
##'
##' @param summaryFunction
##' Character specifying the summary function to apply to the selected features
##' (e.g. "mean" or "median"). User-defined functions similar to these can be
##' specified here as well.
##'
##' @param hk
##' Logical vector defining, for each feature, whether or not it shall
##' be used for housekeeping normalization if housekeeping is specified as the
##' normalization method.
##'
##' @param inputMatrix
##' Name of the matrix in the RccSet's assayData to use as input for performing
##' content normalization (one of "exprs", "posCtrlData", or "bgCorrData"). If
##' posCtrlData or bgCorrData are specified but not found in the assayData, an
##' error will be generated.
##'
##' @param quietly
##' Boolean specifying whether or not messages and warnings should be omitted.
##'
##' @return
##' A copy of the input is returned with a new matrix named `normData' added to
##' the assayData that contains the content-normalized counts. (\bold{NOTE}: normData
##' contains values on a log2 scale while all other matrices in assayData are
##' on a linear scale.) If housekeeping is specified as the normalization method,
##' then the housekeeping features used will be recorded in the returned RccSet in
##' a new featureData column named `Housekeeping'. Parameters specified in the
##' function call are also recorded in the output's experimentData@@preprocessing
##' list.
##'
##' @export
##'
##' @examples
##' data(example_rccSet)
##'
##' pcnorm_example_rccSet <- posCtrlNorm(example_rccSet)
##' bg <- getBackground(pcnorm_example_rccSet)
##' bgcorr_example_rccSet <- subtractBackground(pcnorm_example_rccSet, bg)
##'
##' gmnorm_example_rccSet <- contentNorm(bgcorr_example_rccSet, method="global",
##'     inputMatrix="exprs")
##' hknorm_example_rccSet <- contentNorm(bgcorr_example_rccSet, method="housekeeping",
##'     summaryFunction="mean")
##'
##' @author Dorothee Nickles
##'
setMethod(
    "contentNorm",
    "RccSet",
    function(rccSet,
             method = c("global", "housekeeping"),
             summaryFunction = "median",
             hk = NULL,
             inputMatrix = c("bgCorrData", "posCtrlData", "exprs"),
             quietly = FALSE)
    {
        if (class(summaryFunction) == "character") {
            sfun <- get(summaryFunction)
            summaryFunction.char <- summaryFunction
        } else {
            sfun <- summaryFunction
            summaryFunction.char <- as.character(quote(summaryFunction))
        }

        inputMatrix <- match.arg(inputMatrix)

        M <- assayData(rccSet)[[ inputMatrix ]]
        if (is.null(M))
            stop(sprintf("Specified input matrix ('%s') is not present in the RccSet's assayData", inputMatrix)) 

        if (!quietly && "normData" %in% ls(assayData(rccSet)))
            warning("Input already contains content-normalized data")

        # Apply the log2 transformation. Note that all the code below is thus
        # operating on values that are on a log2 scale.
        M <- log2(M)

        if (method == "global") {

            nFactors <- apply( M[ fData(rccSet)$CodeClass == "Endogenous", ], 2, sfun )
            nFact <-  nFactors - mean(nFactors)

        } else { # method == "housekeeping"

            if (is.null(hk)) {
                hk <- (fData(rccSet)$CodeClass == "Housekeeping")
                if (all(hk == FALSE)) {
                    stop("no housekeeping features defined ('hk' arg is missing or NULL and no features have CodeClass == \"Housekeeping\")")
                }
            }
            if (!is.logical(hk)) {
                stop("'hk' arg must be a logical (TRUE/FALSE) vector")
            }
            if (all(hk == FALSE)) {
                stop("no housekeeping features defined (all entries in 'hk' are FALSE)")
            }
            if (!quietly && (sum(hk) < 3)) {
                warning("Less than three housekeeping features are defined")
            }

            fData(rccSet)$Housekeeping <- hk

            if (sum(hk) > 1)
                nFact <- apply( M[hk, ], 2, sfun )
            else
                nFact <- sfun( M[hk, ] )
        }

        M <- sweep(M, 2, nFact, "-")      # N.B. "-" is valid here since the opration is being performed
                                          # with log2-based values, so the matrix is effectively being
                                          # divided by nFact.

        nrccSet <- copyRccSet(rccSet)

        assayData(nrccSet)$normData <- M

        preproc(nrccSet)$normData_method          <- method
        preproc(nrccSet)$normData_summaryFunction <- summaryFunction.char
        if (method == "housekeeping") {
            preproc(nrccSet)$normData_hkgenes     <- fData(nrccSet)$GeneName[ hk ]
            preproc(nrccSet)$normData_hkfeatures  <- featureNames(nrccSet)[ hk ]
        } else {
            preproc(nrccSet)$normData_hkgenes     <- NA
            preproc(nrccSet)$normData_hkfeatures  <- NA
        }
        preproc(nrccSet)$normData_inputMatrix     <- inputMatrix

        return(nrccSet)
    }
    )



setGeneric( "preprocRccSet", function( rccSet, ... ) standardGeneric( "preprocRccSet" ) )

##' @rdname preprocRccSet
##' @aliases preprocRccSet
##'
##' @title
##' Preprocess an RccSet
##'
##' @description
##' This function is a wrapper to perform any combination of positive control
##' normalization, background correction, and content normalization on the
##' input RccSet. For each completed preprocessing step, a matrix is added to
##' the assayData of the resulting RccSet object:
##'
##' \itemize{
##'   \item posCtrlData: expression data after positive control normalization
##'   \item bgEstimates: background estimates
##'   \item bgCorrData: expression data after positive control normalization and
##'         background correction
##'   \item normData: expression data after positive control normalization,
##'         background correction, and content normalization
##' }
##'
##' (\bold{NOTE}: normData is on a log2 scale while all the other matrices are
##' on a linear scale.)
##'
##' If any step is omitted, the corresponding matrix will not be present in
##' the output's assayData. The parameters for all steps are recorded in the
##' output's experimentData@@preprocessing list (accessible through
##' preproc(rccSet) where rccSet is an RccSet output by this function). In
##' addition:
##'
##' \itemize{
##'   \item If blanks are not present in the data, use bgReference="negatives"
##'         to prevent the function from throwing an error.
##'   \item If positive control normalization is performed, a column named
##'         'PosCtrl' is added to the output's phenoData to record the
##'         positive control scaling factors.
##'   \item If the presence/absence call is performed, a matrix named `paData'
##'         is added to the output's assayData to indicate the
##'         presence/absence of each feature in each sample. See the `pa'
##'         argument for details.
##'   \item If housekeeping normalization is performed, a column labeled
##'         `Housekeeping' is added to the featureData to indicate which
##'         features were used for it.
##' }
##'
##' @details
##' For more information on the rationale behind the recommended
##' preprocessing and normalization steps, please see the vignette.
##'
##' @param rccSet
##' An RccSet.
##'
##' @param doPosCtrlNorm
##' Boolean specifying whether or not to perform positive control normalization.
##' (`pcd' is short for `posCtrlData', the matrix which gets added to assayData
##' when this step is performed.)
##'
##' @param doBackground
##' Boolean specifying whether or not to perform background correction.
##'
##' @param doPresAbs
##' Boolean specifying whether or not the presence/absence call should be
##' performed. For details, see presAbsCall().
##'
##' @param doContentNorm
##' Boolean specifying whether or not content normalization should be performed.
##'
##' @param pcnSummaryFunction
##' Function to be used for the positive control normalization (e.g. "mean",
##' "median", or "sum"). User-defined functions similar to these can be
##' specified here as well.
##'
##' @param bgReference
##' Measurements to use for background estimates: either "blank" (for blank
##' samples), "negatives" (for negative control probes), or "both". For
##' details on exactly how the background estimates are computed in each
##' case, see getBackground().
##'
##' @param bgSummaryFunction
##' Summary function for background measurements (e.g. "mean" or "median").
##' User-defined functions similar to these can be specified here as well.
##'
##' @param bgStringency
##' Factor by which deviation (SD or MAD) of the summarization output will be
##' multiplied to obtain final background estimates.
##'
##' @param nSolverBackground.w1
##' Value to use for the 'w1' argument to nSolverBackground(). (Only takes
##' effect if bgReference == "both"; see getBackground().)
##'
##' @param nSolverBackground.shrink
##' Value to use for the 'shrink' argument to nSolverBackground(). (Only takes
##' effect if bgReference == "both"; see getBackground().)
##'
##' @param paStringency
##' Multiplier to use in establishing the presence/absence call. For details,
##' see presAbsCall().
##'
##' @param normMethod
##' Specifies the features to be used for content normalization. "global" indicates that all
##' features should be used and "housekeeping" indicates that only housekeeping
##' features should be used. If "housekeeping" is specified and the `hk' argument
##' (below) is also specified, then the features indicated by `hk' will be used.
##' If "housekeeping" is specified and `hk' is left NULL, then the default
##' housekeeping features (i.e. those with CodeClass == "Housekeeping") will be used.
##'
##' @param normSummaryFunction
##' Character specifying the summary function to apply to the selected features
##' (e.g. "mean" or "median") during the content normalization step. User-defined
##' functions similar to these can be specified here as well.
##'
##' @param hkgenes
##' Character vector with gene symbols to be used for content normalization if
##' housekeeping is specified as the normalization method. If specified, all
##' features that match any of the specified symbols will be used. (To specify
##' specific features, use the `hkfeatures' argument instead; see below.)
##'
##' @param hkfeatures
##' Character vector with full feature names
##' ("<CodeClass>_<GeneName>_<Accession>", e.g. "Endogenous_ACTG1_NM_001614.1")
##' to be used for content normalization if housekeeping is specified as the normalization
##' method. (Note: if this argument is specified at the same time as `hkgenes',
##' an error will be thrown.)
##'
##' @param quietly
##' Boolean specifying whether or not messages and warnings should be omitted.
##'
##' @return
##' A copy of the input RccSet with additional matrices in the assayData for each
##' successive preprocessing step along with parameters for each step recorded in the
##' experimentData@@preprocessing list.
##'
##' @export
##'
##' @examples
##' data(example_rccSet)
##' hknorm_example_rccSet <- preprocRccSet(example_rccSet)
##'
##' @references
##' \href{http://www.nanostring.com/media/pdf/MAN_nCounter_Gene_Expression_Data_Analysis_Guidelines.pdf}{NanoString nCounter(R) Expression Data Analysis Guide (2012)}
##'
##' @author Dorothee Nickles, Robert Ziman
##'
setMethod(
    "preprocRccSet",
    "RccSet",
    function(rccSet,
             doPosCtrlNorm = TRUE,      # pcd = TRUE,
             doBackground = TRUE,       # bg = TRUE,
             doPresAbs = TRUE,          # pa = TRUE,
             doContentNorm = TRUE,      # cn = TRUE,
             pcnSummaryFunction = "sum",
             bgReference = c("both", "blanks", "negatives"),
             bgSummaryFunction = "median",
             bgStringency = 1,
             nSolverBackground.w1 = 2.18,
             nSolverBackground.shrink = TRUE,
             paStringency = 2,
             normMethod = c("global", "housekeeping"),
             normSummaryFunction = "median",
             hkgenes = NULL,
             hkfeatures = NULL,
             quietly = FALSE)
    {
        bgReference <- match.arg(bgReference)
        normMethod <- match.arg(normMethod)
       
        # Positive control normalization

        if (doPosCtrlNorm) {

            temp_rccSet_1 <- posCtrlNorm(rccSet,
                                         summaryFunction = pcnSummaryFunction)

            bgInputMatrix <- "posCtrlData"

        } else {

            temp_rccSet_1 <- copyRccSet(rccSet)
            preproc(temp_rccSet_1)$posCtrlData_summaryFunction <- NA

            bgInputMatrix <- "exprs"
        }

        # Background correction

        if (doBackground) {

            bgEstimates <- getBackground(rccSet                   = temp_rccSet_1,
                                         bgReference              = bgReference,
                                         summaryFunction          = bgSummaryFunction,
                                         stringency               = bgStringency,
                                         nSolverBackground.w1     = nSolverBackground.w1,
                                         nSolverBackground.shrink = nSolverBackground.shrink,
                                         inputMatrix              = bgInputMatrix)

            temp_rccSet_2 <- subtractBackground(rccSet            = temp_rccSet_1,
                                                bgEstimates       = bgEstimates,
                                                bgEstimatesParams = list(bgReference              = bgReference,
                                                                         summaryFunction          = bgSummaryFunction,
                                                                         stringency               = bgStringency,
                                                                         nSolverBackground.w1     = nSolverBackground.w1,
                                                                         nSolverBackground.shrink = nSolverBackground.shrink,
                                                                         inputMatrix              = bgInputMatrix),
                                                inputMatrix       = bgInputMatrix)

            normInputMatrix <- "bgCorrData"

        } else {

            temp_rccSet_2 <- copyRccSet(temp_rccSet_1)
            preproc(temp_rccSet_2)$bgEstimatesParams <- list(bgReference              = NA,
                                                             summaryFunction          = NA,
                                                             stringency               = NA,
                                                             nSolverBackground.w1     = NA,
                                                             nSolverBackground.shrink = NA,
                                                             inputMatrix              = NA)

            if (doPosCtrlNorm)
                normInputMatrix <- "posCtrlData"
            else
                normInputMatrix <- "exprs"

        }

        # Presence/absence matrix

        if (doPresAbs) {
            if (doBackground) {
                if (doPosCtrlNorm)
                    temp_rccSet_3 <- presAbsCall(temp_rccSet_2, stringency=paStringency, inputMatrix="posCtrlData")
                else
                    temp_rccSet_3 <- presAbsCall(temp_rccSet_2, stringency=paStringency, inputMatrix="exprs")
            }
        } else {
            temp_rccSet_3 <- copyRccSet(temp_rccSet_2)
            preproc(temp_rccSet_3)$paData_stringency <- NA
            preproc(temp_rccSet_3)$paData_inputMatrix <- NA
        }

        # Content normalization

        if (doContentNorm) {

            if (normMethod == "housekeeping")
                #
                # Note that some of the code in the QC report template may be depend
                # on the exact strings (e.g. "Median", "Housekeeping") in the
                # preproc list, so be careful when changing them below. -RZ 2015-01-18
                #
            {
                if (length(hkgenes) > 0)
                {
                    fdataGenes <- fData(rccSet)$GeneName

                    hkgenesNotFound <- setdiff(hkgenes, fdataGenes)
                    if (length(hkgenesNotFound) > 0) {
                        stop(
                            paste0("the following genes specified in hkgenes were not found in the input's featureData: ",
                                paste(collapse=" ", hkgenesNotFound))
                        )
                    }

                    hk <- rep(FALSE, nrow(fData(rccSet)))
                    GeneName.match <- match(hkgenes, fdataGenes)
                    hk[ GeneName.match ] <- TRUE

                } else if (length(hkfeatures) > 0) {

                    fdataRownames <- rownames(fData(rccSet))

                    hkfeaturesNotFound <- setdiff(hkfeatures, fdataRownames)
                    if (length(hkfeaturesNotFound) > 0) {
                        stop(
                            paste0("the following features specified in hkfeatures were not found in the input's featureData: \"",
                                paste(collapse="\", \"", hkfeaturesNotFound), "\"")
                        )
                    }

                    hk <- rep(FALSE, nrow(fData(rccSet)))
                    rowname.match <- match(hkfeatures, rownames(fData(rccSet)))
                    hk[ rowname.match ] <- TRUE

                } else {
                    hk <- fData(rccSet)$CodeClass == "Housekeeping"
                }

                if (all(hk == FALSE)) {
                    stop("Housekeeping normalization selected but no housekeeping features are defined")
                }

            } else {

                hk <- NULL

            }

            temp_rccSet_4 <- contentNorm(rccSet          = temp_rccSet_3,
                                         method          = normMethod,
                                         summaryFunction = normSummaryFunction,
                                         hk              = hk,
                                         inputMatrix     = normInputMatrix)

        } else {

            temp_rccSet_4 <- copyRccSet(temp_rccSet_3)

            preproc(temp_rccSet_4)$normData_method          <- NA
            preproc(temp_rccSet_4)$normData_summaryFunction <- NA
            preproc(temp_rccSet_4)$normData_hkgenes         <- NA
            preproc(temp_rccSet_4)$normData_hkfeatures      <- NA
            preproc(temp_rccSet_4)$normData_inputMatrix     <- NA

        }

        return(temp_rccSet_4)
    }
    )



setGeneric( "addQCFlags", function( rccSet, ... ) standardGeneric( "addQCFlags" ) )

##' @rdname addQCFlags
##' @aliases addQCFlags
##'
##' @title          Add sample QC flags to an rccSet
##' @description    Returns a copy of the input RccSet with columns added to pData
##'                 from the provided sample QC flag annotation file. (That file is
##'                 produced by makeQCReport(); see its help page for more
##'                 details.)
##'
##' @param  rccSet      An RccSet object
##' @param  flagFile    Path to a sample QC flag file as generated by the
##'                     NanoStringQCPro QC report (see makeQCReport())
##'
##' @return
##' A copy of the input RccSet with columns added to pData from the QC
##' flag file.
##'
##' @author Dorothee Nickles
##'
setMethod(
    "addQCFlags",
    "RccSet",
    function(rccSet, flagFile)
    {
        if (!file.exists(flagFile)) {
            stop("flagFile not found")
        }

        flags <- read.table(flagFile, header=TRUE, as.is=TRUE, sep="\t")
        stopifnot(all(flags$SampleIdentifier %in% pData(rccSet)$FileName))

        rccSet.withflags <- copyRccSet(rccSet)    # Using copyRccSet() to be *sure* the original doesn't get affected in later code!

        has.QCflag <-
            apply(
                flags,
                1,
                function(x) {
                    return(ifelse(length(grep("TRUE", x[c("TechnicalFlags", "ControlFlags", "CountFlags")])) != 0, TRUE, FALSE))
                }
            )
        flags$has.QCflag <- has.QCflag

        mt <- match(pData(rccSet.withflags)$FileName, flags$SampleIdentifier)
        pData(rccSet.withflags) <- cbind(pData(rccSet.withflags),
            flags[mt,c("TechnicalFlags", "ControlFlags", "CountFlags", "has.QCflag")])

        return(rccSet.withflags)
    }
    )

##' @title          myCols
##' @description    Function that defines nice colors
##'
##' @return
##' A vector of colors
##'
##' @author Dorothee Nickles
myCols <- function() {
  myColsSet1 <- c("antiquewhite3", "aquamarine3", "azure3", "lightpink1", "cadetblue4", "coral2",
                  "firebrick", "lightblue", "olivedrab", "palevioletred3")
  myColsSet2 <- c("darkgoldenrod", "darkgoldenrod2", "cornflowerblue", "darkkhaki", "coral3",
                  "chartreuse3", "dodgerblue4", "blueviolet", "darkturquoise", "thistle4") 
  myColsSet3 <- c("darkgreen", "darkmagenta", "cyan4", "darkorange", "darkred", "gold",
                  "darkblue", "deeppink2", "yellowgreen", "orangered3")
  c(myColsSet3, myColsSet2, myColsSet1)
}

##' @title          dCoVar
##' @description    Determine standard deviation at a certain percent CV
##'
##' @param  x       numeric vector 
##' @param  d       scalar numeric, percent CV
##' @param  ...     additional parameters passed on to mean()
##'
##' @return standard deviation of x at d percent of CV
##'
##' @author Dorothee Nickles
##'
dCoVar <- function(x, d, ...) {
  d * mean(x, ...)
}

##' @title          cutoffByVar
##' @description    Determine cutoffs of x (for outlier detection) based on a certain percent CV
##'
##' @param  x       numeric vector 
##' @param  d       scalar numeric, percent CV; passed on to dCoVar
##' @param  ...     additional parameters passed on to mean()
##'
##' @return
##' A list of length 2, with a scalar numeric in each slot, one giving the lower threshold (mean(x) - CV% based cutoff),
##' the other giving the upper threshold (mean(x) + percent CV based cutoff) for outlier definition.
##'
##' @author Dorothee Nickles
##'
cutoffByVar <- function(x, d, ...) {
  thresholds <- list(mean(x, ...) - dCoVar(x, d, ...), mean(x, ...) + dCoVar(x, d, ...))
  return(thresholds)
}

##' @title          cutoffByMMAD
##' @description    Determine cutoffs of x (for outlier detection) based on median
##'
##' @param  x       numeric vector 
##' @param  d       scalar numeric, factor by which to multiply MAD of x
##' @param  ...     additional parameters passed on to median()
##'
##' @return
##' A list of length 2, with a scalar numeric in each slot, one giving the lower threshold (median(x) - d * mad(x)),
##' the other giving the upper threshold (median(x) + d * mad(x)) for outlier definition.
##'
##' @author Dorothee Nickles
##'
cutoffByMMAD <- function(x, d, ...) {
  thresholds <- list(median(x, ...) - d * mad(x, ...), median(x, ...) + d * mad(x, ...))
  return(thresholds)
}

##' @title          colByFun
##' @description    Color x based on upper and lower thresholds
##'
##' @param  x           Numeric vector 
##' @param  thresholds  List of length 2, with a scalar numeric in each slot, one giving the lower the upper threshold (for outlier definition)
##'
##' @return
##' A vector of colors, with "red" for all values of x exceeding thresholds and "black" for all other values
##'
##' @author Dorothee Nickles
##'
colByFun <- function(x, thresholds) {
  ifelse(x < thresholds[[1]], "red", 
      ifelse(x > thresholds[[2]], "red", "black"))
}

##' @title          colByCovar
##' @description    Define colors based on a covariate of an RccSet object
##'
##' @param  pdata   pData() of an RccSet object
##' @param  covar   character, colname in the pdata used to stratify (color) data
##'
##' @return
##' A list of length 2, with [["color"]] being a character vector of colors (one color for each level of covar) of length=number of observations
##' and [["legend"]] providing the levels of covar to map colors to covar
##'
##' @author Dorothee Nickles
##'
colByCovar <- function(pdata, covar) {
  if(!covar %in% colnames(pdata)) {
    stop("The covariate you chose is not defined.")
  } else {
    diffTypes <- list()
    diffTypes[["color"]] <- myCols()[as.numeric(as.vector(factor(pdata[, covar], 
            labels=c(1:length(unique(pdata[, covar]))))))]
    diffTypes[["legend"]] <- unique(pdata[, covar])
    return(diffTypes)
  }         
}

setGeneric( "fovPlot", function( rccSet ) standardGeneric( "fovPlot" ) )
##' @rdname fovPlot
##' @aliases fovPlot
##'
##' @title Fields of view (FOV) plot
##'
##' @description
##' Plot the fraction of successfully imaged fields of view (FOV) in the given RccSet.
##' The RccSet's phenoData should have 'FovCount' and 'FovCounted' columns populated with the total
##' and successfully imaged FOV counts, respectively. Samples with a FOV counted/FOV count of less than
##' 80% are marked in red (dashed red line indicates threshold).
##'
##' @param  rccSet  An RccSet object
##'
##' @return
##' A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "fovPlot",
  "RccSet",
  function(rccSet) {
    fov <- as.numeric(as.vector(pData(rccSet)$FovCounted))/
           as.numeric(as.vector(pData(rccSet)$FovCount))
    plot(fov,
         pch=16,
         main="FOV Counted versus FOV Count",
        #ylab="FOV Counted/FOV Count",
         ylab="ratio",
         xlab="Sample Index",
         las=1,
         col=ifelse(fov < 0.8, "red", "black"),
         ylim=c(min(fov, 0.8), 1))
    abline(h=0.8, col="red", lty=2)	
  }
  )

setGeneric( "bdPlot", function( rccSet ) standardGeneric( "bdPlot" ) )
##' @rdname bdPlot
##' @aliases bdPlot
##'
##' @title Binding density plot
##'
##' @description
##' Plot the binding density of each sample in an RccSet object.
##' Samples with a binding density < 0.05 or > 2.25 (thresholds defined by NanoString) 
##' are marked in red (dashed red line indicates threshold).
##'
##' @param  rccSet  An RccSet object
##'
##' @return
##' A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "bdPlot",
  "RccSet",
  function(rccSet) {
    plot(as.numeric(as.vector(pData(rccSet)$BindingDensity)), pch=16, 
         ylim=c(0, max(c(as.numeric(as.vector(pData(rccSet)$BindingDensity)), 2.25))),
         main="Binding Density", ylab="Binding density",
         xlab="Sample Index",
         las=1,
         col=ifelse(as.numeric(as.vector(pData(rccSet)$BindingDensity)) > 2.25, "red", 
              ifelse(as.numeric(as.vector(pData(rccSet)$BindingDensity)) < 0.05, "red", "black")))
    abline(h=c(0.05, 2.25), col="red", lty=2)
  }
  )

setGeneric( "flagSamplesTech", function( rccSet ) standardGeneric( "flagSamplesTech" ) )
##' @rdname flagSamplesTech
##' @aliases flagSamplesTech
##'
##' @title          flagSamplesTech
##' @description    Flag samples based on their technical performance, i.e. field of vision (FOV) counted and binding density
##'
##' @details
##' Samples with a FOV counted/FOV count of less than 80% will be flagged. Also samples with a binding density
##'
##' @param  rccSet  An RccSet object
##'
##' @return
##' A numeric vector giving the indices of samples with outlier values in FOV counted and
##' binding density < 0.05 or > 2.25 (thresholds defined by NanoString) will be flagged.
##'
##' @author Dorothee Nickles
##'
setMethod(
  "flagSamplesTech",
  "RccSet",
  function(rccSet) {
    return(unique(c(which(as.numeric(as.vector(pData(rccSet)$FovCounted))/as.numeric(as.vector(pData(rccSet)$FovCount)) < 0.8),
                    which(as.numeric(as.vector(pData(rccSet)$BindingDensity)) > 2.25 | as.vector(pData(rccSet)$BindingDensity) < 0.05))))
  }
  )

setGeneric( "ctrlsOverviewPlot", function( rccSet ) standardGeneric( "ctrlsOverviewPlot" ) )
##' @rdname ctrlsOverviewPlot
##' @aliases ctrlsOverviewPlot
##'
##' @title          ctrlsOverviewPlot
##' @description    Plot individual negative and positive controls across all samples in an RccSet object.
##'
##' @param  rccSet  An RccSet object
##'
##' @return
##' A plot with two panels, one for the negative controls, one for the positive controls.
##'
##' @author Dorothee Nickles
##'
setMethod(
  "ctrlsOverviewPlot",
  "RccSet",
  function(rccSet) {
    par(mfrow=c(1,2))
  
    M <- assayData(rccSet)$exprs
  
    negCtrls <- (fData(rccSet)$CodeClass == "Negative")
    M.negCtrls <- M[ negCtrls, ]
    rownames(M.negCtrls) <- fData(rccSet)$GeneName[negCtrls]
    M.negCtrls.ordered <- M.negCtrls[ order(rownames(M.negCtrls)), ]
  
    boxplot(t(M.negCtrls.ordered),
            las=2,
            cex.axis=0.6,
            ylab="counts (raw)",
            log="y",
            main="Negative Controls")
  
    posCtrls <- which(fData(rccSet)$CodeClass == "Positive")
    M.posCtrls <- M[ posCtrls, ]
    rownames(M.posCtrls) <- fData(rccSet)$GeneName[posCtrls]
    M.posCtrls.ordered <- M.posCtrls[ order(rownames(M.posCtrls)), ]
  
    boxplot(t(M.posCtrls.ordered),
            las=2,
            cex.axis=0.6, 
            ylab="counts (raw)",
            log="y",
            main="Positive Controls")
  }
  )

setGeneric( "negCtrlsPlot", function( rccSet ) standardGeneric( "negCtrlsPlot" ) )
##' @rdname negCtrlsPlot
##' @aliases negCtrlsPlot
##'
##' @title          negCtrlsPlot
##' @description    Plot negative controls across all samples in an RccSet object
##'
##' @details
##' In the second panel, boxplots are colored by lane (as specified in the pData slot). Bars on top of
##' the panel indicate the stage position for each cartridge/sample (as specified in the pData slot).
##'
##' @param  rccSet  An RccSet object
##'
##' @return
##' A plot with two panels: one showing boxplots for the individual negative controls across all samples, and 
##' one showing boxplots for the negative control counts for each individual sample (lane-specific background).
##'
##' @author Dorothee Nickles
##'
setMethod(
  "negCtrlsPlot",
  "RccSet",
  function(rccSet) {
    
    negCtrls <- (fData(rccSet)$CodeClass == "Negative")
    M <- assayData(rccSet)$exprs
  
    par(mfrow=c(1,2))
  
    boxplot(t(M[ negCtrls, ]),
            las=2,
            cex.axis=0.6,
            ylab="counts (raw)",
            log="y",
            main="Negative Controls")
  
    boxplot(M[ negCtrls, ],
            log="y",
            xaxt="n",
            col=myCols()[ pData(rccSet)$LaneID ],
            ylab="counts",
            xlab="lane")
  
    axis(1,
         at = 1:ncol(M),
         labels = as.integer(pData(rccSet)$LaneID),
         cex.axis=0.6)
  
    n <- 1
    for (i in 1:length(unique(pData(rccSet)$StagePosition))) {
      tmp <- which(pData(rccSet)$StagePosition == pData(rccSet)$StagePosition[i])
      lines(y = rep(max(M[ negCtrls, ]) + 5, length(tmp)),
            x = n:(n+length(tmp)-1),
            col=i,
            lwd=4,
            xpd=TRUE)
      n <- n + length(tmp)
    }
  }
  )

setGeneric( "negCtrlsByLane", function( rccSet ) standardGeneric( "negCtrlsByLane" ) )
##' @rdname negCtrlsByLane
##' @aliases negCtrlsByLane
##'
##' @title          negCtrlsByLane
##' @description    Plot negative controls per lane in an RccSet object
##'
##' @details
##' Boxplots are colored by lane (as specified in the pData slot). Bars on top of
##' the panel indicate the stage position for each cartridge/sample (as specified in the pData slot).
##'
##' @param  rccSet  An RccSet object
##'
##' @return
##' A plot with boxplots for the negative control counts for each individual sample (lane-specific background)
##'
##' @author Dorothee Nickles
##'
setMethod(
  "negCtrlsByLane",
  "RccSet",
  function(rccSet) {
  
    negCtrls <- (fData(rccSet)$CodeClass == "Negative")
  
    M <- assayData(rccSet)$exprs
    laneid <- as.numeric(pData(rccSet)$LaneID)
  
    boxplot(
       M[ negCtrls, ]
      ,log="y"
      ,xaxt="n"
      ,col=myCols()[laneid]
      ,ylab="counts"
      ,xlab="lane"
      ,main="Negative Controls by lane -\nlane-specific background"
    )
    axis(1,
         at = 1:ncol(M),
         labels = laneid,
         cex.axis = min(0.2 + 1/log2(length(laneid)), 0.8), las=2)
    ## disable addition of StagePosition indicator for now
    #n <- 1
    #for (i in 1:length(unique(pData(rccSet)$StagePosition))) {
    #  tmp <- which(pData(rccSet)$StagePosition == pData(rccSet)$StagePosition[i])
    #  lines(y = rep(max(M[ negCtrls, ]) + 5, length(tmp)),
    #        x = n:(n+length(tmp)-1),
    #        col = i,
    #        lwd = 4,
    #        xpd = TRUE)
    #  n <- n + length(tmp)
    #}
    legend(x=(length(laneid)+3), y=max(M[ negCtrls, ]), cex=0.5,
            xpd=TRUE, bty="n", fill=myCols()[sort(unique(laneid))],
            legend=paste(rep("Lane", length(unique(laneid))), sort(unique(laneid))))
  }
  )

##' Plot of negative controls by lane (vertical orientation)
##'
##' @param rccSet
##' An RccSet
##'
##' @param outputFile
##' Output PNG filename
##'
##' @return
##' A PNG file containing a boxplot of the counts for negative controls by lane
##' in the input. The PNG is set to a fixed resolution of 300 pixels per inch and
##' a fixed width of 2250 pixels (i.e. 7.5" at 300ppi), but the height varies
##' with the size of the input. The font size is also fixed so that the labels
##' will be legible even for large datasets.
##'
negCtrlsByLane_verticalPlot <- function(rccSet, outputFile)
{
  rccSet.sorted <- rccSet[ , rev(order(rownames(pData(rccSet))))]
  
  negCtrls <- (fData(rccSet.sorted)$CodeClass == "Negative")
  
  M <- assayData(rccSet.sorted)$exprs
  laneid <- as.numeric(pData(rccSet.sorted)$LaneID)

  png(filename=outputFile,
      width=2250,
      height=200 + 30*ncol(M),
      res=300,
      units="px",
      pointsize=7
  )
  
  par(mai=c(0.5,3,0.5,0.75))
  
  par(yaxs="i")
  
  boxplot(M[negCtrls, ],
          horizontal=TRUE,
          log="x",
          xlab="Counts (raw)",
          ylab="",
          xlim=c(0,(ncol(M)+1)),  # This gets assigned to ylim by boxplot() when horizontal=TRUE.
          las=1,
          col=myCols()[laneid],
          main="Negative controls by lane -\nlane-specific background"
  )

  ## disable addition of StagePosition indicator for now
  #n <- 1
  #for (i in 1:length(unique(pData(rccSet)$StagePosition))) {
  #  tmp <- which(pData(rccSet)$StagePosition == pData(rccSet)$StagePosition[i])
  #  lines(y = rep(max(M[ negCtrls, ]) + 5, length(tmp)),
  #        x = n:(n+length(tmp)-1),
  #        col = i,
  #        lwd = 4,
  #        ypd = TRUE)
  #  n <- n + length(tmp)
  #}

  legend(x=max(M[ negCtrls, ])*1.2,
         y=(length(laneid)+3),
        #cex=0.5,
         xpd=TRUE,
         bty="n",
         fill=myCols()[sort(unique(laneid))],
         legend=paste(rep("Lane", length(unique(laneid))), sort(unique(laneid))))
  
  dev.off()
  
  return(TRUE)
}

##' @title          scatterPair
##' @description    Helper function for a scatter plot inside a pairs plots
##'
##' @param  x   integer, x positions
##' @param  y   integer, y positions
##'
##' @return
##' A scatter plot x versus y.
##'
scatterPair <- function(x,y) {points(x,y, pch=20)}

##' @title          panelCor
##' @description    Helper function for printing correlation coefficients inside a pairs plots
##'
##' @param  x       integer
##' @param  y       integer, same length as x
##' @param  digits  scalar integer, indicating the number of decimal positions for displaying the correlation coefficient
##' @param  cex.cor scalar numeric to specify relative font size for priting the correlation coefficient
##' @param  doTest  boolean, whether a results of cor.test should be displayed as well
##'
##' @return
##' Prints correlation coefficients (and p-values if doTest = TRUE) within a pairs plot.
##'
panelCor <- function(x, y, digits=2, cex.cor=0.75, doTest=FALSE)
{
  usr <- par("usr"); on.exit(par(usr))
  par(usr = c(0, 1, 0, 1))
  r <- abs(cor(x, y))
  txt <- format(c(r, 0.123456789), digits=digits)[1]
  if (doTest) {
    test <- cor.test(x,y)
    Signif <- ifelse(round(test$p.value,3)<0.001,"p<0.001",paste("p=",round(test$p.value,3)))  
    text(0.5, 0.25, paste("r=",txt))
    text(.5, .75, Signif)
  } else {
    text(0.5, 0.5, paste("r=",txt), cex=cex.cor)
  }
}

setGeneric( "negCtrlsPairs", function( rccSet, ... ) standardGeneric( "negCtrlsPairs" ) )
##' @rdname negCtrlsPairs
##' @aliases negCtrlsPairs
##'
##' @title          negCtrlsPairs
##' @description    Pairs plot of negative controls across all samples in an RccSet object
##'
##' @param  rccSet          An RccSet object
##' @param  log.transform   boolean, whether data needs to be log2 transformed
##'
##' @return
##' Pairs plot of the negative controls with a scatter plot in the lower panel and
##' correlatation coefficients printed in the upper panel.
##'
##' @author Dorothee Nickles
##'
setMethod(
  "negCtrlsPairs",
  "RccSet",
  function(rccSet, log.transform=FALSE) {
  
    M <- assayData(rccSet)$exprs
    negCtrls <- fData(rccSet)$CodeClass == "Negative"
  
    tmp <- M[ negCtrls, ]
    if (log.transform) {
      tmp <- log2(tmp)
    }
  
    pairs(t(tmp),
          upper.panel=panelCor,
          lower.panel=scatterPair)
  }
  )

setGeneric( "posNormFactPlot", function( rccSet ) standardGeneric( "posNormFactPlot" ) )
##' @rdname posNormFactPlot
##' @aliases posNormFactPlot
##'
##' @title          posNormFactPlot
##' @description    Plot positive control scaling factor for each sample in an RccSet object
##'
##' @param  rccSet  An RccSet object
##'
##' @return
##' A plot of the positive control scaling factor for each sample in an RccSet object.
##' Samples with a positive control scaling factor < 0.3 or > 3 (thresholds defined by NanoString) are
##' marked in red (dashed red line indicates threshold).
##'
##' @author Dorothee Nickles
##'
setMethod(
  "posNormFactPlot",
  "RccSet",
  function(rccSet)
  {
    if ("posCtrlData" %in% ls(assayData(rccSet))) {
        M <- assayData(rccSet)$exprs
        positives <- (fData(rccSet)$CodeClass == "Positive")

        posFactor <- pData(rccSet)$PosFactor
      
        plot(posFactor,
             las = 1,
             cex.axis = 0.6,
             ylab = "Positive control scaling factor",
             pch = 16,
             xlab = "Sample index",
             main = "Positive control scaling factors across samples", 
             col = ifelse(posFactor < 0.3, "red", ifelse(posFactor > 3, "red", "black")),
             ylim = c(min(c(posFactor, 0.3)), max(c(posFactor, 3))))
        abline(h = c(0.3, 3),
               col = "red",
               lty = 2)
    } else {
        print("This plot requires the RccSet to have positive control normalized data")
    }
  }
  )

##' @title          zfacFun
##' @description    Calculate Z' Factor
##'
##' @param  p   numeric vector: measurements for the positive controls (or actual measurement)
##' @param  n   numeric vector: measurements for the negative controls
##'
##' @return     Scalar numeric: the Z' Factor
##'
##' @author Dorothee Nickles
##'
zfacFun <- function(p, n) {
  return( 1 - ((3* (mad(p) + mad(n))) / abs(median(p) - median(n))) )
}

setGeneric( "ctrlsZprimePlot", function( rccSet ) standardGeneric( "ctrlsZprimePlot" ) )
##' @rdname ctrlsZprimePlot
##' @aliases ctrlsZprimePlot
##'
##' @title          ctrlsZprimePlot
##' @description    Plot distribution of counts and the Z' Factors comparing the nagative controls and
##'                 the three highest input positive controls of an RccSet object.
##'
##' @param  rccSet  An RccSet object
##'
##' @return         A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "ctrlsZprimePlot",
  "RccSet",
  function(rccSet) {
  
    M <- assayData(rccSet)$exprs
    negatives    <- (fData(rccSet)$CodeClass == "Negative")
    positive_128 <- (fData(rccSet)$SpikeInInput == 128)
    positive_32  <- (fData(rccSet)$SpikeInInput == 32)
    positive_8   <- (fData(rccSet)$SpikeInInput == 8)
  
    posN <- log2(apply( M[negatives, ], 2, median ))
    
    zfac1 <- round(zfacFun(log2(M[ positive_128, ]), posN), digits=2)
    zfac2 <- round(zfacFun(log2(M[ positive_32,  ]), posN), digits=2)
    zfac3 <- round(zfacFun(log2(M[ positive_8,   ]), posN), digits=2)
    plot(density(posN),
         col = myCols()[1],
         xlim = c(1, log2(max(M[ positive_128, ]))),
         main = "Frequency distributions of log2 transformed counts\nfor negative and positive controls")
    lines(density(log2(M[ positive_8,   ])), col=myCols()[2])        		
    lines(density(log2(M[ positive_32,  ])), col=myCols()[3])
    lines(density(log2(M[ positive_128, ])), col=myCols()[4])
    legend("top",
           lty = 1,
           col = myCols()[1:4],
           legend = c("negCtrls",
                      paste0("pos8: Z'=", zfac3),
                      paste0("pos32: Z'=", zfac2),
                      paste0("pos128: Z'=", zfac1)))
  }
  )

setGeneric( "iqrPlot", function( rccSet, ... ) standardGeneric( "iqrPlot" ) )
##' @rdname iqrPlot
##' @aliases iqrPlot
##'
##' @title
##' iqrPlot
##'
##' @description
##' Plot the interquartile range (IQR) for a certain code class of probes in an
##' RccSet object.
##'
##' @details
##' IQR of the specified code class for each sample in the RccSet are plotted
##' and outliers (as determined by the function specified in the method
##' argument) are marked in red (thresholds for outlier definition are plotted
##' as red dashed lines).
##'
##' @param rccSet
##' An RccSet object
##'
##' @param codeClass
##' Character string specifying the code class (as annotated in the
##' fData(rccSet)$CodeClass column) for which the IQR shall be determined.
##'
##' @param method
##' Character string specifying the method for outlier detection: either
##' "cutoffByMMAD" or "cutoffByVar".
##'
##' @param stringency
##' Numeric value passed to the cutoff function specified by the method
##' argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
##'
##' @return
##' A plot
##'
##' @seealso \code{\link{cutoffByMMAD}}, \code{\link{cutoffByVar}}
##'
##' @author Dorothee Nickles
##'
setMethod(
  "iqrPlot",
  "RccSet",
  function(rccSet,
           codeClass = c("Negative", "Positive", "Endogenous", "Housekeeping"),
           method = c("cutoffByMMAD", "cutoffByVar"),
           stringency = 4)
  {
    codeClass <- match.arg(codeClass)
    fun <- match.fun(method)
  
    M <- assayData(rccSet)$exprs
  
    iqr <- apply(log2(M[ fData(rccSet)$CodeClass == codeClass, ]), 2, IQR)
    thresholds <- fun(iqr, stringency)
  
    plot(iqr,
         las = 1,
         cex.axis = 0.6,
         ylab = "counts (log2)",
         pch = 16,
         xlab = "Sample index",
         main = sprintf("IQR of code class %s across samples", codeClass), 
         col = colByFun(iqr, thresholds), 
         ylim = c(min(c(iqr, unlist(thresholds))), max(c(iqr, unlist(thresholds)))))
  
    abline(h = unlist(thresholds),
           col = "red",
           lty = 2)
  }
  )

setGeneric( "posR2Plot", function( rccSet ) standardGeneric( "posR2Plot" ) )
##' @rdname posR2Plot
##' @aliases posR2Plot
##'
##' @title          posR2Plot
##' @description    Plot the R squared of linear fit of counts versus input for positive controls in an RccSet object.
##'
##' @details
##' R squared for each sample in the RccSet are plotted and samples with R squared < 0.95 are marked in red
##' (threshold indicated by dashed red line).
##'
##' @param  rccSet  RccSet object
##'
##' @return         A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "posR2Plot",
  "RccSet",
  function(rccSet)
  {
    par(mfrow=c(1,1))
  
    M <- assayData(rccSet)$exprs
    positives <- (fData(rccSet)$CodeClass == "Positive")
  
    tmp <- apply(log2(M[positives, ]),
                 2,
                 function(x) { summary(lm(x ~ log2(fData(rccSet)$SpikeInInput[ positives ])))$r.squared })
    plot(tmp,
         pch = 16,
         col = ifelse(tmp < 0.95, "red", "black"),
         main = "R2 for linearity in positive controls")
  
    abline(h=0.95, col="red", lty=2)
  }
  )

setGeneric( "posSlopePlot", function( rccSet, ... ) standardGeneric( "posSlopePlot" ) )
##' @rdname posSlopePlot
##' @aliases posSlopePlot
##'
##' @title
##' posSlopePlot
##'
##' @description
##' Plot the slope of linear fit of counts versus input for positive controls
##' in an RccSet object.
##'
##' @param rccSet
##' An RccSet object
##'
##' @param method
##' Character string specifying the method for outlier detection: either
##' "cutoffByMMAD" or "cutoffByVar".
##'
##' @param stringency
##' Numeric value passed to the cutoff function specified by the method
##' argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
##'
##' @return
##' A plot
##'
##' @details
##' The slope for each sample in the RccSet are plotted and and outliers (as
##' determined by the function specified by the method argument) are marked in
##' red (thresholds for outlier definition are plotted as red dashed lines).
##'
##' @author Dorothee Nickles
##'
setMethod(
  "posSlopePlot",
  "RccSet",
  function(rccSet,
           method = c("cutoffByMMAD", "cutoffByVar"),
           stringency = 4)
  {
    fun <- match.fun(method)
  
    M <- assayData(rccSet)$exprs
    positives <- (fData(rccSet)$CodeClass == "Positive")
  
    tmp <- apply(log2(M[positives, ]),
                 2,
                 function(x) { coefficients(lm(x ~ log2(fData(rccSet)$SpikeInInput[ positives ])))[2] })
    thresholds <- fun(tmp, stringency)
    plot(tmp,
         pch = 16,
         col = colByFun(tmp, thresholds),
         main = "Slope in positive controls",
         ylab = "slope",
         xlab = "Sample index",
         ylim = c(min(c(tmp, unlist(thresholds))), max(c(tmp, unlist(thresholds)))),
         las = 1)
  
    abline(h=unlist(thresholds), col="red", lty=2)
  }
  )


setGeneric( "posRatioPlot", function( rccSet, ... ) standardGeneric( "posRatioPlot" ) )
##' @rdname posRatioPlot
##' @aliases posRatioPlot
##'
##' @title
##' posRatioPlot
##'
##' @description
##' Plot the ratio of the mean of positive control counts for each sample and
##' the overall mean of positive control counts in an RccSet object.
##'
##' @details
##' The ratio for each sample in the RccSet is plotted and and outliers (as
##' determined the cutoff function specified by the method argument) are marked
##' in red (thresholds for outlier definition are plotted as red dashed lines).
##'
##' @param rccSet
##' An RccSet object
##'
##' @param method
##' Character string specifying the method for outlier detection: either
##' "cutoffByMMAD" or "cutoffByVar".
##'
##' @param stringency
##' Numeric value passed to the cutoff function specified by the method
##' argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
##'
##' @return
##' A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "posRatioPlot",
  "RccSet",
  function(rccSet,
           method = c("cutoffByMMAD", "cutoffByVar"),
           stringency = 4)
  {
    fun <- match.fun(method)
  
    M <- assayData(rccSet)$exprs
    positives <- (fData(rccSet)$CodeClass == "Positive")
  
    meanPos <- log2(colMeans(M[positives, ]))
    meanPosMean <- mean(meanPos)
    meanPosRatio <- meanPos/meanPosMean
    thresholds <- fun(meanPosRatio, stringency)
  
    plot(y = meanPosRatio,
         x = 1:ncol(M),
         las = 2,
         cex.axis = 0.6, 
         ylab = "mean pos ctrl counts/overall mean of pos ctrl counts",
         xlab="Sample index",
         main = "", 
         pch = 16,
         xlab = "samples",
         col = colByFun(meanPosRatio, thresholds),
         log = "y",
         ylim = c(min(c(meanPosRatio, unlist(thresholds))), max(c(meanPosRatio, unlist(thresholds)))))
  
    abline(h=unlist(thresholds), col="red", lty=2)
  }
  )

setGeneric( "allSumPlot", function( rccSet, ... ) standardGeneric( "allSumPlot" ) )
##' @rdname allSumPlot
##' @aliases allSumPlot
##'
##' @title
##' allSumPlot
##'
##' @description
##' Plot the sum of all counts (endogenous and housekeeping genes only) for each
##' sample in an RccSet object.
##'
##' @details
##' The sum of counts for each sample in the RccSet are plotted and and outliers
##' (as determined the cutoff function specified by the method argument) are
##' marked in red (thresholds for outlier definition are plotted as red dashed
##' lines).
##'
##' @param rccSet
##' An RccSet object
##'
##' @param method
##' Character string specifying the method for outlier detection: either
##' "cutoffByMMAD" or "cutoffByVar".
##'
##' @param stringency
##' Numeric value passed to the cutoff function specified by the method
##' argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
##'
##' @return
##' A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "allSumPlot",
  "RccSet",
  function(rccSet,
           method = c("cutoffByMMAD", "cutoffByVar"),
           stringency = 4)
  {
    fun <- match.fun(method)
  
    M <- assayData(rccSet)$exprs
    nonctrls <- (fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))
  
    allSum <- colSums(M[nonctrls, ])
    thresholds <- fun(log2(allSum), stringency)
    blankLabel <- getBlankLabel(rccSet)
  
    plot(y = allSum,
         x = 1:ncol(M),
         log = "y",
         las = 1,
         cex.axis = 0.6,
         ylab = "sum of counts",
         xlab = "Sample index",
         main = "Sum of raw counts for all probes", 
         col = colByFun(log2(allSum), thresholds),
         pch = ifelse( (pData(rccSet)$SampleType %in% blankLabel), 17, 16),
         ylim = as.integer(c(min(c(allSum, 2^unlist(thresholds))), max(c(allSum, 2^unlist(thresholds)))))
         )
  
    abline(h=2^unlist(thresholds), col="red", lty=2)
  }
  )

setGeneric( "posSumVsAllSumPlot", function( rccSet, ... ) standardGeneric( "posSumVsAllSumPlot" ) )
##' @rdname posSumVsAllSumPlot
##' @aliases posSumVsAllSumPlot
##'
##' @title
##' posSumVsAllSumPlot
##'
##' @description
##' Plot the ratio of sums of positive control counts to all counts for all
##' samples in an RccSet object.
##'
##' @details
##' The ratio for each sample in the RccSet is plotted and and outliers (as
##' determined by the cutoff function specified by the method argument) are
##' marked in red (thresholds for outlier definition are plotted as red
##' dashed lines).
##'
##' @param rccSet
##' An RccSet object
##'
##' @param method
##' Character string specifying the method for outlier detection: either
##' "cutoffByMMAD" or "cutoffByVar".
##'
##' @param stringency
##' Numeric value passed to the cutoff function specified by the method
##' argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
##' (If the median ratio is less than 1, three times this value will be
##' used.)
##'
##' @return
##' A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "posSumVsAllSumPlot",
  "RccSet",
  function(rccSet,
           method = c("cutoffByMMAD", "cutoffByVar"),
           stringency = 4)
  {
    fun <- match.fun(method)
  
    M <- assayData(rccSet)$exprs
  
    iSum <- colSums(M[fData(rccSet)$CodeClass %in% "Positive",])
    nSum <- colSums(M[fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"),])

    if (median(iSum/nSum) < 1) {
      stringency <- 3*stringency
    }

    thresholds <- fun(iSum/nSum, stringency)

    blankLabel <- getBlankLabel(rccSet)
  
    plot(y = iSum/nSum,
         x = 1:ncol(M),
         las = 1,
         cex.axis = 0.6,
         ylab = "ratio",
         xlab = "Sample index",
         main = sprintf("Sum of positive control counts /\nsum of endogenous and housekeeping gene counts"),
         col = colByFun(iSum/nSum, thresholds),
         pch = ifelse( (pData(rccSet)$SampleType %in% blankLabel), 17, 16),
         ylim = c(min(c(iSum/nSum, unlist(thresholds))), max(c(iSum/nSum, unlist(thresholds)))))

    abline(h=unlist(thresholds), col="red", lty=2)
  }
  )


setGeneric( "flagSamplesCtrl", function( rccSet, ... ) standardGeneric( "flagSamplesCtrl" ) )
##' @rdname flagSamplesCtrl
##' @aliases flagSamplesCtrl
##'
##' @title
##' flagSamplesCtrl
##'
##' @description
##' Flag samples based on the performance of their controls.
##'
##' @details
##' The method and stringency arguments determine a cutoff value used to
##' flag outlier samples based on the interquartile range of negative and
##' positive controls and in the slope of the linear fit of count versus input
##' of positive controls. Outliers will also be flagged if their positive
##' control scaling factor (see posCtrlNorm) is outside the NanoString
##' recommended range (i.e. below 0.3 or greater than 3).
##'
##' @param rccSet
##' An RccSet object
##'
##' @param method
##' Character string specifying the method for outlier detection: either
##' "cutoffByMMAD" or "cutoffByVar".
##'
##' @param stringency
##' Numeric value passed to the cutoff function specified by the method
##' argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
##'
##' @return
##' A numeric vector giving the indices of samples with outlier values as
##' described above.
##'
##' @author Dorothee Nickles
##'
setMethod(
  "flagSamplesCtrl",
  "RccSet",
  function(rccSet,
           method = c("cutoffByMMAD", "cutoffByVar"),
           stringency = 4)
  {
    method <- match.arg(method)
    fun <- match.fun(method)

    M <- assayData(rccSet)$exprs
  
    negatives    <- (fData(rccSet)$CodeClass == "Negative")
    positives    <- (fData(rccSet)$CodeClass == "Positive")
    positive_128 <- (fData(rccSet)$SpikeInInput == 128)
  
    a <- apply(log2(M[negatives, ]), 2, IQR)
    ctrls <- which(colByFun(a, fun(a, stringency)) == "red")
  
    a <- apply(log2(M[positives, ]), 2, IQR)
    ctrls <- c(ctrls, which(colByFun(a, fun(a, stringency)) == "red"))
  
    #a <- log2(M[positive_128, ])
    #ctrls <- c(ctrls, which(colByFun(a, fun(a, stringency)) == "red"))
  
    a <- apply(log2(M[positives, ]),
               2,
               function(x) { coefficients(lm(x ~ log2(fData(rccSet)$SpikeInInput[ positives ])))[2] })
    ctrls <- c(ctrls, which(colByFun(a, fun(a, stringency)) == "red"))

    if ("PosFactor" %in% rownames(pData(rccSet))) {
        posFactor <- pData(rccSet)$PosFactor
        ctrls2 <- c(which(posFactor < 0.3), which(posFactor > 3))
    } else {
        ctrls2 <- integer(0)
    }

    return(unique(ctrls, ctrls2))
  }
  )

##' @title          pcaPlot
##' @description    Wrapper function to perform a PCA analysis on the exprs slot of an RccSet object
##'                 and plot some results
##'
##' @param  exx     exprs() of an RccSet object
##' @param  ...     additional parameters passed on to the plotting functions
##'
##' @return
##' PCA screeplot and a plot with two panels, one plotting PC1 versus PC2, the other plotting
##' PC1 versus PC3.
##'
##' @author Dorothee Nickles
##'
pcaPlot <- function(exx, ...) {		## takes exprs of an expression set object and title for plots
  if (!is.matrix(exx)) {
    stop("Input is not a matrix")   # was: "stop("This function takes a matrix. Are you sure you put in exprs(rccSet)?")" -RZ 2015-03-24
  }
  pca_test <- prcomp(exx, scale=TRUE, tol=0)
  par(mfrow=c(1,1))
  screeplot(pca_test, ...)
  par(mfrow=c(1,2))
  plot(pca_test$rotation[,1], pca_test$rotation[,2], ylab="PC2", xlab="PC1", pch=16, ...)
  #text(x=pca_test$rotation[,1], y=pca_test$rotation[,2], label=rownames(pca_test$rotation),
  #  xpd=TRUE)
  plot(pca_test$rotation[,1], pca_test$rotation[,3], pch=16, ylab="PC3", xlab="PC1", ...)
  #text(x=pca_test$rotation[,1], y=pca_test$rotation[,3], label=rownames(pca_test$rotation),
  #  xpd=TRUE)
  #plot(pca_test$rotation[,2], pca_test$rotation[,3], pch=16, ylab="PC3", xlab="PC2", ...)
  #text(x=pca_test$rotation[,2], y=pca_test$rotation[,3], label=rownames(pca_test$rotation),
  #  xpd=TRUE)
  #plot(pca_test$rotation[,2], pca_test$rotation[,4], pch=16, ylab="PC4", xlab="PC2", ...)
}

setGeneric( "lodAssess", function( rccSet, ... ) standardGeneric( "lodAssess" ) )
##' @rdname lodAssess
##' @aliases lodAssess
##'
##' @title
##' lodAssess
##'
##' @description
##' Assess how many genes in each sample in an RccSet object are below the
##' limit of detection. (The current implementation does a straightforward
##' column sum on the presence/absence matrix (paData) in assayData.)
##'
##' @param rccSet
##' An RccSet object
##'
##' @return
##' A numeric vector giving the number of missing genes (endogenous and
##' housekeeping genes) for each sample in an RccSet. If paData is not
##' found in the input's assayData, NULL is returned.
##'
##' @author Dorothee Nickles
##'
setMethod(
  "lodAssess",
  "RccSet",
  function(rccSet)
  {
    if ("paData" %in% ls(assayData(rccSet))) {
      nonctrls <- (fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))
      misValues <- colSums( assayData(rccSet)$paData[nonctrls, ] == FALSE )
      return(misValues)
    } else {
      return(NULL)
    }
  }
  )

setGeneric( "flagSamplesCount", function( rccSet, ... ) standardGeneric( "flagSamplesCount" ) )
##' @rdname flagSamplesCount
##' @aliases flagSamplesCount
##'
##' @title
##' flagSamplesCount
##'
##' @description
##' Flag samples based on overall counts
##'
##' @details
##' The method and stringency arguments deterine a cutoff value used to flag
##' samples as outliers: samples will be flagged if the sum of counts of their
##' endogeneous genes exceeds the cutoff or if the ratio of the sums of their
##' positive controls to the sums of their endogenous genes exceeds three
##' times the cutoff. Samples will also be flagged if the fraction of
##' genes below the lower limit of detection exceeds the maxMiss value.
##'
##' @param rccSet
##' An RccSet object
##'
##' @param method
##' Character string specifying the method for outlier detection: either
##' "cutoffByMMAD" or "cutoffByVar".
##'
##' @param stringency
##' Numeric value passed to the cutoff function specified by the method
##' argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
##'
##' @param maxMiss
##' Numeric specifying the allowable fraction of genes below the lower limit
##' of detection in a sample.
##'
##' @return
##' A numeric vector giving the indices of samples with outlier values
##' according to the criteria described above.
##'
##' @author Dorothee Nickles
##'
setMethod(
  "flagSamplesCount",
  "RccSet",
  function(rccSet,
           method = c("cutoffByMMAD", "cutoffByVar"),
           stringency = 4,
           maxMiss = 0.2)
  {
    fun <- match.fun(method)
  
    M <- assayData(rccSet)$exprs
  
    positives  <- (fData(rccSet)$CodeClass == "Positive")
    endogenous <- (fData(rccSet)$CodeClass == "Endogenous")
  
    posSum <- colSums(M[positives, ])
    allSum <- colSums(M[endogenous, ])

    if ("paData" %in% ls(assayData(rccSet))) {
      misValues <- lodAssess(rccSet)
      flagged_maxMiss <- which(misValues/nrow(M) > maxMiss)
    } else {
      flagged_maxMiss <- integer(0)
    }

    sampC <- unique(c(
      which(colByFun(allSum, fun(allSum, stringency)) == "red"),
      which(colByFun(posSum/allSum, fun(posSum/allSum, stringency*3)) == "red"),
      flagged_maxMiss
    ))
  
    return(sampC)
  }
  )

setGeneric( "lodPlot", function( rccSet, ... ) standardGeneric( "lodPlot" ) )
##' @rdname lodPlot
##' @aliases lodPlot
##'
##' @title
##' lodPlot
##'
##' @description
##' Function to plot the number of missing genes per sample in an RccSet object.
##'
##' @details
##' Samples with more than 50% missingness are marked in red. If blank
##' measurements are present, they are represented as triangles.
##'
##' @param rccSet
##' An RccSet object
##'
##' @param maxMiss
##' Numeric specifying the allowable fraction of genes below the lower limit
##' of detection in a sample.
##'
##' @return
##' A plot
##'
##' @author Dorothee Nickles
##'
setMethod(
  "lodPlot",
  "RccSet",
  function(rccSet,
           maxMiss = 0.2)
  {
    if ("paData" %in% ls(assayData(rccSet))) {

        blankLabel <- getBlankLabel(rccSet)
        nonctrls <- (fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))
        n_nonctrls <- sum(nonctrls)
      
        misValues <- lodAssess(rccSet)
      
        plot(misValues/n_nonctrls, 
             col = ifelse(misValues/n_nonctrls >= maxMiss, "red", "black"),
             pch = ifelse(pData(rccSet)$SampleType %in% blankLabel, 17, 16),
             main = "Sample Missingness",
             ylab = "Fraction of genes below background estimate",
             xlab = "Sample index",
             las = 1)
      
        abline(h=maxMiss, col="red", lty=2)   # was: abline(h=length(nonctrls)*maxMiss, col="red", lty=2) -RZ 2015-03-27

    } else {
        print("This plot requires the RccSet to have the presence/absence matrix")
    }
  }
  )

setGeneric( "sampleClustering", function( rccSet, ... ) standardGeneric( "sampleClustering" ) )
##' @rdname sampleClustering
##' @aliases sampleClustering
##'
##' @title
##' Clustering by sample correlation
##' 
##' @description
##' Clustering by sample correlation
##'
##' @param rccSet
##' An RccSet
##'
##' @param outputFile
##' Output PNG filename
##'
##' @param main
##' Plot title
##' 
##' @param annCol
##' See \code{\link{aheatmap}}
##'
##' @param covar
##' Covariate (e.g. "SampleType")
##'
##' @return
##' A PNG file showing clustering of samples by correlation. Any zero-variance
##' samples are omitted from the heatmap.
##' The width and height of the PNG file are set to vary with the size of the input.
##'
##' @importFrom NMF aheatmap
##' @importFrom RColorBrewer brewer.pal
##'
##' @author Dorothee Nickles, Robert Ziman
##'
setMethod(
  "sampleClustering",
  "RccSet",
  function(rccSet,
           outputFile,
           main = "Sample correlations in raw data",
           annCol = NULL,
           covar = "SampleType")
  {
    M <- assayData(rccSet)$exprs
  
    # Remove any zero-variance rows. These rows are problematic
    # in the heatmap-plotting code that follows (they cause NA values in the output of cor() which
    # in turn causes hclust() to error out).

    zero_variance <- apply(M, 2, function(x){ var(x) == 0 })
    if (any(zero_variance)) {
      warning(
        paste(
          c(
            "The following samples were excluded because of zero variance:",
            paste0("    ", colnames(M)[zero_variance])
          ),
          collapse="\n"
        )
      )
      M <- M[ , !zero_variance]
      pdata <- pData(rccSet)[ !zero_variance ] 
    } else {
     #M <- M
      pdata <- pData(rccSet)
    }

    # Assign annCol (specifications of column annotation tracks displayed as
    # coloured rows on top of the heatmaps)

    cols <- colByCovar(pdata, covar)
    if (missing(annCol)) {
      annCol <- data.frame(SampleSubgroup = pdata[ , covar])
    }

    # Check if the input is too large to be comfortably plotted.

    if (ncol(M) > 1000)
      stop("This function is designed to plot a heatmap of up to 1000 samples")

    # Generate the heatmap. Given the finicky aheatmap() behavior, need different
    # settings when the input is small (<50 samples) or large (>50). 

    if (ncol(M) < 50) {

      width = (20*ncol(M) + 250) / 72
      height = (20*ncol(M) + 250) / 72

      png( filename = outputFile, width = width, height = height, units="in", res=72 )

      aheatmap( cor(M),
                annCol      = annCol,
                color       = brewer.pal(8, "Blues"),
                treeheight  = 0,
                legend      = TRUE,
                fontsize    = 10,
                cexRow      = 1,
                cexCol      = 1,
                cellwidth   = 20,
                cellheight  = 20,
                main        = main)

      dev.off()

    } else {

      width <- (10 * ncol(M) + 600) / 300
      height <- (10 * ncol(M) + 200) / 300

      png( filename = outputFile, width = width, height = height, units = "in", res = 300 )

      aheatmap( cor(M),
                annCol      = annCol,
                color       = brewer.pal(8, "Blues"),
                treeheight  = 0,
                legend      = TRUE,
                fontsize    = 2,
               #cexRow      = 0.5,       # These won't work when the input matrix is large (>200 columns);
               #cexCol      = 0.5,       # use cellwidth/cellheight instead. See aheatmap() source.
                cellwidth   = 2,
                cellheight  = 2,
                gp          = grid::gpar(cex=2),  # Required to compensate for hardcoded values in the aheatmap() source
                main        = main )

      dev.off()

    }

  }
  )

##' Plot counts in blank samples (vertical orientation)
##'
##' @param rccSet
##' An RccSet
##'
##' @param outputFile
##' Output PNG filename
##'
##' @return
##' A PNG file containing a boxplot of the gene-wise counts for the blank samples
##' in the input. The PNG is set to a fixed resolution of 300 pixels per inch and
##' a fixed width of 2250 pixels (i.e. 7.5" at 300ppi), but the height varies
##' with the size of the input. The font size is also fixed so that the labels
##' will be legible even for large datasets.
##'
countsInBlankSamples_verticalPlot <- function(rccSet, outputFile)
{
  if (hasBlanks(rccSet))
  {
    blankLabel <- getBlankLabel(rccSet)
    blanks <- (pData(rccSet)$SampleType %in% blankLabel)
    endo   <- which(fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))
    
    M <- assayData(rccSet)$exprs
    rownames(M) <- fData(rccSet)$GeneName   
    
    png(filename=outputFile,
        width=2250,
        height=200 + 30*nrow(M),
        res=300,
        units="px",
        pointsize=7
        )
    
    par(mai=c(0.5,1.5,0.5,0.25))

    par(yaxs="i")
    
    boxplot(t(M[endo, blanks]),
            horizontal=TRUE,
            log="x",
            xlab="Counts (raw)",
            ylab="",
            las=1,
            pch=".",
            main="Gene-wise counts in blank measurements"
            )
    sapply(endo,
           function(n) {
             points(x = median(M[n, blanks]) + (2.5*mad(M[n, blanks])),
                      #
                      # ***** TODO: replace with actual background estimate *****
                      #
                    y=n,
                    col="red",
                    pch=20,
                    cex=0.7)
           })
    
    dev.off()
  }
  else {
    print("No blank samples are present")
  }
  
  return(TRUE)
}


##' @title          densityPlot
##' @description    Plot the density of counts for all endogenous and housekeeping genes for each sample in an RccSet object
##'
##' @param  M               One of the matrices from the assayData() of an RccSet object (make sure
##'                         to set the log.transform parameter accordingly)
##' @param  log.transform   Scalar boolean
##' @param  pdata           pData() of the RccSet object
##' @param  covar           character; colname in pData() that can be used to label genes by a category of interest (passed on to colByCovar)
##' @param  ...             additional plotting parameters
##'
##' @return
##' A density plot
##'
##' @author Dorothee Nickles
##'
densityPlot <- function(M, log.transform=FALSE, pdata, covar, ...) {	## takes exprSet
  
  stopifnot(is(M, "matrix"))

  if (log.transform) {
    M <- log2(M)  
  }
  
  cols <- colByCovar(pdata, covar)
  plot(density(M[,1]),
       ylim=c(0,0.5),
       col="white",
       las=1,
       ...)
  sapply(1:ncol(M),
         function(x) { lines(density(M[,x]),
                       col=cols[["color"]][x]) })
  legend("topright", fill=unique(cols[["color"]]), legend=cols[["legend"]])
}

setGeneric( "assessHousekeeping", function( rccSet, ... ) standardGeneric( "assessHousekeeping" ) )
##' @rdname assessHousekeeping
##' @aliases assessHousekeeping
##'
##' @title          assessHousekeeping
##' @description    Assess correlation and variance/variability of housekeeping genes
##'
##' @details
##' Pairwise correlations of all defined housekeeping genes will be assessed and pairwise scatterplots will be generated. This function does not only
##' output pairwise correlation coefficients, but also - for each housekeeping gene - the variance, the interquartile range (IQR) and median expression
##' level across all samples in the experiment.
##'
##' @param  rccSet      An RccSet object
##' @param  hk          Either a boolean vector of length nrow(exprs(rccSet)) or a numeric vector of indices
##'                     which genes in exprs(rccSet) are housekeeping genes
##' @param  covar       character; colname in fData(rccSet) that can be used to label genes by a category of interest
##' @param  annotate    Scalar boolean; if TRUE (default), probes will be "annotated" using the "GeneName" column in the fData(rccSet) slot
##' @param  digits      Scalar integer, the number of decimal places
##' @param  plot        Scalar boolean, plot pairwise relationships ?
##'
##' @return
##' A dataframe with one row per housekeeping genes and several columns with metrics suggested to
##' assess performance of defined housekeeping genes.
##'
##' @author Dorothee Nickles
##'
setMethod(
  "assessHousekeeping",
  "RccSet",
  function(rccSet, hk, covar, annotate=TRUE, plot=TRUE, digits=2) {
  
    if (!is.logical(hk)) {
      stop("Please provide logical vector assigning whether each gene serves as a housekeeping gene or not.")
    }
    if (sum(hk) == 1) {
      stop("You need more than one housekeeping gene to use this function.")
    }
  
    M <- assayData(rccSet)$exprs
  
    values <- rownames(M[hk, ])
    if (annotate) {
      values <- fData(rccSet)$GeneName[hk]
    }
    if (any(duplicated(values))) {
      n <- 1
      for (r in which(duplicated(values))) {
        values[r] <- paste(values[r], n, sep="v")
        n <- n+1
      }
    }
  
    if(plot == TRUE){
      pairs(t(log2(M[hk, ])), 
            main = "Correlation of housekeeping genes",
            col = colByCovar(pData(rccSet), covar)[["color"]],
            labels = values,
            pch = 20,
            las = 1)
    }
  
    output <- data.frame(matrix(nrow=sum(hk), ncol=0))
    output[,1] <- values
    output[,2] <- var(t(log2(M[hk, ])))[,1]
    output[,3] <- apply(log2(M[hk, ]), 1, IQR)
    output[,4] <- apply(log2(M[hk, ]), 1, median)
    output[, 5:(sum(hk)+4)] <- cor(t(log2(M[hk, ])))
    output[,c(2:ncol(output))] <- round(output[,c(2:ncol(output))], digits=digits)
    colnames(output) <- c("Gene", "Variance", "IQR", "median", paste("cor", values, sep="_"))
  
    return(output)
  }
  )


##' Gene clustering heatmap
##'
##' @param rccSet
##' An RccSet
##'
##' @param outputFile
##' Output PNG filename
##'
##' @param main
##' Plot title
##'
##' @param covar
##' Colname in the rccSet's fData that can be used to label genes by a category of interest
##'
##' @return
##' A PNG file showing clustering of genes by correlation across an experiment
##' Positive and negative control probes and any zero-variance genes (typically
##' housekeeping genes) are omitted from the heatmap.
##' The width and height of the PNG file are set to vary with the size of the input.
##'
##' @importFrom NMF aheatmap
##'
##' @author Dorothee Nickles, Robert Ziman
##'
geneClustering <- function(rccSet,
                           outputFile,
                           main = "Gene clustering",
                           covar = NULL
                          #gsubset = NULL
                               ## @param gsubset
                               ## Either a boolean vector of length nrow(exprs(rccSet)) or a numeric vector of
                               ## indices indicating a subset of genes in exprs(rccSet) with which to generate
                               ## the heatmap instead of the full set.
                           )
{
  stopifnot(is(rccSet, "RccSet"))

  M <- assayData(rccSet)$normData
  rownames(M) <- fData(rccSet)$GeneName

  # Remove positive and negative control probes from the matrix.

  nonctrls <- (fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))
  M <- M[nonctrls, ]

  # Remove any zero-variance rows -- typically the housekeeping genes. These rows are problematic
  # in the heatmap-plotting code that follows (they cause NA values in the output of cor() which
  # in turn causes hclust() to error out), and the housekeeping genes are not informative anyway.

  zero_variance <- apply(M, 1, function(x) { var(x) == 0 })
  if (any(zero_variance)) {
    warning(
      paste(
        c(
          "The following features were excluded because of zero variance:",
          paste0("    ", rownames(M)[zero_variance])
        ),
        collapse="\n"
      )
    )
    M <- M[ !zero_variance, ]
  }

  # Check if the input is too large to be comfortably plotted.

  if (nrow(M) > 1000)
    stop("This function is designed to plot a heatmap of up to 1000 genes")

  # Generate the heatmap. Given the finicky aheatmap() behavior, need different
  # settings when the input is small (<50 genes) or large (>50).

  if (nrow(M) < 50) {

    width = (20*nrow(M) + 250) / 72
    height = (20*nrow(M) + 250) / 72

    png( filename = outputFile, width = width, height = height, units="in", res=72 )

    aheatmap( cor(t(M)),
             #annCol      = plabel,
              color       = "-RdBu",
              treeheight  = 0,
              legend      = TRUE,
              fontsize    = 10,
              cexRow      = 1,
              cexCol      = 1,
              cellwidth   = 20,
              cellheight  = 20,
             #gp=grid::gpar
              main        = main)

    dev.off()

  } else {

    width <- (10 * nrow(M) + 500) / 300
    height <- (10 * nrow(M) + 200) / 300

    png( filename = outputFile, width = width, height = height, units = "in", res = 300 )

    aheatmap( cor(t(M)),
             #annCol      = plabel,
              color       = "-RdBu",
              treeheight  = 0,
              legend      = TRUE,
              fontsize    = 2,
             #cexRow      = 0.5,       # These won't work when the input matrix is large (>200 genes or so);
             #cexCol      = 0.5,       # use cellwidth/cellheight instead. See aheatmap() source.
              cellwidth   = 2,
              cellheight  = 2,
              gp          = grid::gpar(cex=2),  # Required to compensate for hardcoded values in the aheatmap() source
              main        = main )

    dev.off()

  }
}


centeredSampleClustering <- function(gmrccSet,
                                     outputFile,
                                     main,
                                     flags,
                                     excludeFlagged)
{
    if (missing(gmrccSet) || missing(outputFile) || missing(main) || missing(flags) || missing(excludeFlagged))
        stop("missing args")

    if (excludeFlagged)
    {
        flagged <- unique(unlist(apply(flags, 2, which)))

        if (length(flagged) > 0) {
            temp_rccSet <- copyRccSet(gmrccSet)[, -flagged]
        } else {
            temp_rccSet <- copyRccSet(gmrccSet)
        }
        
        gmrccSet <- contentNorm(temp_rccSet,
                                method = "global",
                                summaryFunction = "median",
                                inputMatrix = preproc(gmrccSet)$normData_inputMatrix,
                                quietly = TRUE)
    }

    nonctrls <- (fData(gmrccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))

    M <- t(
            apply( assayData(gmrccSet)$normData[nonctrls, ],
                  1,
                  scale, center = TRUE, scale = FALSE )
          )
    colnames(M) <- colnames( assayData(gmrccSet)$normData[nonctrls, ] )
        #
        # TODO: The apply(... 1, scale, ...) combination above transposes the matrix
        # and strips the rownames. See if the same output -- un-transposed and with names
        # intact -- can be generated with a direct call to scale(). -RZ 2015-04-24
        #
    rownames(M) <- fData(gmrccSet)$GeneName[nonctrls]

    # Remove any zero-variance rows or cols. These are problematic
    # in the heatmap-plotting code that follows (they cause NA values in the output of cor() which
    # in turn causes hclust() to error out).

    zero_variance <- apply(M, 1, function(x) { var(x) == 0 })
    if (any(zero_variance)) {
      warning(
        paste(
          c(
            "The following genes were excluded because of zero variance:",
            paste0("    ", rownames(M)[zero_variance])
          ),
          collapse="\n"
        )
      )
      M <- M[!zero_variance, ]
    }

    zero_variance <- apply(M, 2, function(x) { var(x) == 0 })
    if (any(zero_variance)) {
      warning(
        paste(
          c(
            "The following samples were excluded because of zero variance:",
            paste0("    ", colnames(M)[zero_variance])
          ),
          collapse="\n"
        )
      )
      M <- M[ , !zero_variance]
    }

    # Check if the input is too large to be comfortably plotted.

    if (nrow(M) > 1000 || ncol(M) > 1000)
        stop("This function is designed to plot a heatmap of up to 1000 genes and 1000 samples")

    # Generate the heatmap. Given the finicky aheatmap() behavior, need different
    # settings when the input is small (<50 samples) or large (>50).

    row.cl <- as.dendrogram( hclust( as.dist( 1-cor(t(M)) ), method="ward.D" ) )
    col.cl <- as.dendrogram( hclust( as.dist( 1-cor(M) ), method="ward.D" ) )

    #annColors=lapply( seq_along( colnames( flags )), function(n){
    #  setNames( c("grey90", brewer.pal(ncol(flags), "Set1")[n]), c(FALSE, TRUE))
    #  })
    #names(annColors) <- colnames(flags)

    if (excludeFlagged)
        annCol <- data.frame(Counts = colSums(exprs(gmrccSet)[nonctrls, ]))
    else
        annCol <- flags

    if (nrow(M) < 50 && ncol(M) < 50) {

      width = (20*ncol(M) + 350) / 72
      height = (20*nrow(M) + 350) / 72

      png( filename = outputFile, width = width, height = height, units="in", res=72 )

      aheatmap( M, 
               #annColors   = annColors,
                annCol      = annCol,
                color       = "-RdBu",
                Colv        = col.cl,
                Rowv        = row.cl,
#                labRow      = NA,
#                labCol      = NA,
                scale       = "none",
                breaks      = 0,
                treeheight  = 0,
                legend      = TRUE,
                fontsize    = 10,
                cexRow      = 1,
                cexCol      = 1,
                cellwidth   = 20,
                cellheight  = 20,
                main        = main )

      dev.off()

    } else {

      width <- (10 * ncol(M) + 500) / 300
      height <- (10 * nrow(M) + 200) / 300

      png( filename = outputFile, width = width, height = height, units = "in", res = 300 )

      aheatmap( M, 
               #annColors   = annColors,
                annCol      = annCol,
                color       = "-RdBu",
                Colv        = col.cl,
                Rowv        = row.cl,
#                labRow      = NA,
#                labCol      = NA,
                scale       = "none",
                breaks      = 0,
                treeheight  = 0,
                legend      = TRUE,
                fontsize    = 2,
               #cexRow      = 0.5,       # These won't work when the input matrix is large (>200 columns);
               #cexCol      = 0.5,       # use cellwidth/cellheight instead. See aheatmap() source.
                cellwidth   = 2,
                cellheight  = 2,
                gp          = grid::gpar(cex=2),  # Required to compensate for hardcoded values in the aheatmap() source
                main        = main )

      dev.off()
      
    }
}

##' NanoStringQCPro example dataset
##'
##' Example data for the NanoStringQCPro package
##'
##' @name       example_rccSet
##' @docType    data
##' @format     An RccSet object
##' @source     This is an artificial dataset designed to resemble real data.
##' @author     Dorothee Nickles
##' @keywords   datasets
NULL

check_cols <- function(expectedCols, actualCols, msg) {
    notfound <- is.na(match(expectedCols, actualCols))
    if (any(notfound)) 
        return(paste0(msg, ": ", paste(collapse=", ", expectedCols[notfound])))
    else return(character(0))
}


##' @title
##'
##' RccSet class, derived from ExpressionSet
##'
##' @description
##'
##' The RccSet class is a trivial extension of
##' \code{\linkS4class{ExpressionSet}}, but with additional validation
##' criteria. \code{RccSet} is a class generator function.
##'
##' @details
##'
##' A valid \code{RccSet} object must have the following columns in
##' \code{featureData}: \code{"CodeClass"}, \code{"GeneName"}, and
##' \code{"Accession"}. It must also have the following
##' \code{phenoData} columns: \code{"FileName"}, \code{"SampleID"},
##' \code{"LaneID"}, \code{"FovCount"}, \code{"FovCounted"},
##' \code{"StagePosition"}, \code{"BindingDensity"}, \code{"CartridgeID"}, and
##' \code{"SampleType"}. A final requirement is that the \code{"FovCount"}
##' column of \code{phenoData} have at most one distinct value.
##'
##' @seealso
##'
##' See \code{\link{checkRccSet}}, which provides additional checks and
##' generates warnings for unexpected or unusual conditions which, though
##' permitted by the class, may indicate data import errors.
##' 
##' @export
##'
##' @import methods
##'
##' @examples
##' 
##' data("example_rccSet")
##' e <- example_rccSet
##' 
##' # "ExpressionSet" constructor makes a new assayData environment
##' r1 <- RccSet(e)
##' validObject(r1)
##' assayData(e)
##' assayData(r1)
##' head(pData(r1))
##' head(fData(r1))
##' 
##' # For other constructors, if not explicitly supplied, blank phenoData and
##' # featureData objects are populated with mandatory columns (and NA values).
##' r2 <- RccSet(assayData(e))
##' validObject(r2)
##' head(pData(r2))
##' head(fData(r2))
##' 
##' r3 <- RccSet(assayData(e), phenoData(e), featureData(e))
##' identical(pData(r1), pData(r3))
##' identical(fData(r1), fData(r3))
##' identical(annotation(r1), annotation(r3)) # We forgot it!
##' annotation(e)
##' r3 <- RccSet(assayData(e), phenoData(e), featureData(e), annotation = annotation(e))
##' identical(annotation(r1), annotation(r3)) # Better
##' identical(r1, r3) # False, due to assayData environments
##' assayData(r1)
##' assayData(r3)
##' 
##' # Matrix contructor is similar
##' r4 <- RccSet(exprs(e), phenoData(e), featureData(e), annotation = annotation(e))
##' identical(exprs(r1), exprs(r4))
##' 
##' # Blank object constructor
##' r0 <- RccSet()
##' dim(r0)
##' pData(r0)
##' fData(r0)

.RccSet <- setClass(
    "RccSet",
    contains = "ExpressionSet",
    validity = function( object ) {
        fData.requiredCols <- c(
            "CodeClass"
            ,"GeneName"
            ,"Accession"
            )
        pData.requiredCols <- c(
            "FileName"
            ,"SampleID"
            ,"LaneID"
            ,"FovCount"
            ,"FovCounted"
            ,"StagePosition"
            ,"BindingDensity"
            ,"CartridgeID"
            ,"SampleType"
            )
        result.errors <- check_cols(fData.requiredCols, colnames(fData(object)), "Required featureData cols not found")
        result.errors <- c(result.errors, check_cols(pData.requiredCols, colnames(pData(object)), "Required phenoData cols not found"))        
        if (length(unique(pData(object)$FovCount)) > 1)
            result.errors <- c(result.errors, "The data seems to have been generated using two different settings (more than one value appears in the 'FovCount' field)")
        if (length(result.errors) > 0) {
            indent <- c("", rep("  ", length(result.errors)-1))
            stop(paste(collapse="\n", paste0(indent, result.errors)))
        }
        else return(TRUE)            
    }
    )

##' @title
##'
##' RccSet constructor methods
##'
##' @description
##'
##' Constructor methods for making new \code{\linkS4class{RccSet}} objects.
##'
##' @param obj An object of appropriate class
##' @param ... Passed to methods.
##'
##' @return
##' A new \code{\linkS4class{RccSet}} object.
##'
##' @details
##'
##' Arguments accepted by constructors are identical to those for the
##' \code{\link{ExpressionSet}} constructors.
##'
##' See \code{\linkS4class{RccSet}} class documentation for examples of
##' constructor use.
##'
##' Constructor calls for which mandatory \code{phenoData} or \code{featureData}
##' columns are missing will successfully create objects that include mandatory
##' columns, but with \code{NA} values. See \code{\linkS4class{RccSet}}
##' documentation for a list of mandatory columns.
##'
##' @export

setGeneric( "RccSet", function( obj, ... ) standardGeneric( "RccSet" ) )

##' @rdname RccSet
##' @export

setMethod(
    "RccSet",
    "ExpressionSet",
    function( obj, ... ) {
        .RccSet(
            assayData = copyEnv( assayData( obj ) ),
            phenoData = phenoData( obj ),
            featureData = featureData( obj ),
            experimentData = experimentData( obj ),
            annotation = annotation( obj ),
            protocolData = protocolData( obj ),
            ...
            )
    }
    )

##' @rdname RccSet
##' @export

setMethod(
    "RccSet",
    "environment",
    function( obj, ... ) {

        e <- ExpressionSet( obj, ... )

        fData.char <- c( "CodeClass", "GeneName", "Accession" )
        pData.char <- c( "FileName", "SampleID", "CartridgeID", "SampleType" )
        pData.numeric <- c( "LaneID", "FovCount", "FovCounted", "StagePosition", "BindingDensity" )

        for ( f in fData.char )
            if ( !( f %in% colnames( fData( e ) ) ) )
                fData( e )[[ f ]] <- rep( NA_character_, nrow( e ) ) # Be sure to handle length 0!

        for ( p in pData.char )
            if ( !( p %in% colnames( pData( e ) ) ) )
                pData( e )[[ p ]] <- rep( NA_character_, ncol( e ) )

        for ( p in pData.numeric )
            if ( !( p %in% colnames( pData( e ) ) ) )
                pData( e )[[ p ]] <- rep( NA_real_, ncol( e ) )

        RccSet( e )

    }
)

##' @rdname RccSet
##' @export

setMethod(
    "RccSet",
    "matrix",
    function( obj, ... ) RccSet( assayDataNew( exprs = obj ), ... )
    )

##' @rdname RccSet
##' @export

setMethod(
    "RccSet",
    "missing",
    function( obj, ... ) RccSet( matrix( nrow = 0, ncol = 0 ), ... )
    )

---
title: "Quality control report for `r experimentTitle`"
date: "`r report.date`"
output:
  html_document:
    toc: true
    toc_depth: 3
---

```{r options, echo=FALSE}
options(replace.assign=TRUE, width=90)
opts_chunk$set(dev="png",
               fig.align='center',
               fig.pos='htbp',
               dpi=300,
               out.width='504px',
               echo=FALSE,
               fig.retina=FALSE,
			   fig.path=sprintf("%s/", outputExtrasDir)
			   )
```


# Data set summary

The data set was composed of `r nrow(pData(rccSet))` samples and `r sum(fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))` genes. 


# Technical metrics

As a first step in quality control, we assess whether technical aspects differed across samples.

## Fields of view

According to the [nCounter&reg; Expression Data Analysis Guide](http://www.nanostring.com/media/pdf/MAN_nCounter_Gene_Expression_Data_Analysis_Guidelines.pdf), "the nCounter&reg; Digital Analyzer images each lane in discrete units, called fields of view (FOV). Optical issues, such as an inability to focus due to bubbles or insufficient oiling of the cartridge, can prevent successful imaging of a FOV. The Digital Analyzer reports the number of FOVs successfully imaged as 'FOV Counted'. Significant discrepancy between the number of FOV for which imaging was attempted (FOV Count) and for which imaging was successful (FOV Counted) may be indicative of an issue with imaging performance." Samples with less than 80% FOV Counted are highlighted in red:

```{r flags_fov_plot}
fovPlot(rccSet)
```

## Binding density

As the nCounter&reg; Digital Analyzer only counts non-overlapping barcodes, significant data loss could occur if there are too many barcodes in the imaged area. The nCounter&reg; Digital Analyzer calculates Binding Density as a measure of image saturation. For details, please see the [nCounter&reg; Expression Data Analysis Guide](http://www.nanostring.com/media/pdf/MAN_nCounter_Gene_Expression_Data_Analysis_Guidelines.pdf). According to NanoString&reg;, Binding Density which is either too low (< 0.05) or too high (> 2.25) is indicative of technical issues (e.g., excess RNA input); such samples are marked in red:

```{r bd_plot}
bdPlot(rccSet)
```

## Technical metrics summary

Assessment of these technical factors resulted in flagging of `r sum(flags[,"TechnicalFlags"])` sample(s).


# Control probe metrics

## Negative and positive control probes

All NanoString&reg; runs contain negative control probes that are designed to not hybridize to any human target. The background signal reported by the negative control probes typically differs somewhat from probe to probe. 

Positive control probes and associated spike-ins are also part of every NanoString&reg; run. For positive controls, there should be a linear relationship between the nominal input concentration and the reported counts. Because spike-ins differ by a common dilution factor, this linearity should be visible in the positive control box plot when counts are plotted on a logarithmic scale:

```{r control_plots1}
ctrlsOverviewPlot(rccSet)
```

## Sample-specific background level

Negative control probes can be used to determine lane-specific (i.e., sample-specific) background noise levels (to see the full plot, click on the preview image below):

<div class="centered">
    <a href="`r ncblMainImage`" target="_blank"><img src="`r ncblPreviewImage`"></a>
</div>


## Spike-in linearity

The slope estimate produced by fitting the linear model *log(counts) ~ log(input)* shows how well an increase in spike-in input is reflected by an increase in counts. Thresholds for identification of outliers (dotted red lines) were determined using the *`r method`* method (see package documentation for this function); outliers, if any, are colored in red:

```{r control_plots3}
posSlopePlot(rccSet, method, stringency)
```

## Control probe interquartile range

We can make use of the negative and positive controls for further quality control. For instance, an increased or decreased spread of the data stemming from the negative or positive controls might be indicative of technical issues (such as increased background or decreased dynamic range). Below, we plot the interquartile range (IQR) for negative and positive control probes. Thresholds for identification of outliers (dotted red lines) were determined using the *`r method`* method. Outliers, if any, are colored in red:

```{r iqr_plots, results="hide"}
iqrPlot(rccSet, "Negative", method, stringency)
iqrPlot(rccSet, "Positive", method, stringency)
```

## Positive control scaling factors

Finally, the overall signal for the spike-in controls may identify lanes experiencing technical issues. NanoString&reg; suggests calculating a positive control scaling factor; if this scaling factor is outside a range of 0.3 - 3, it may indicate significant under-performance, and such results should be interpreted with caution. Samples with positive control scaling factors outside the recommended range are colored in red; for more details, please see the vignette as well as the help page for the *posCtrlNorm* function.

```{r pos_norm_fact_plot}
posNormFactPlot(rccSet)
```

## Control probe metrics summary

`r sum(flags[,"ControlFlags"])` sample(s) were flagged based on the performance of the controls.



# Count-based metrics

Problematic samples may exhibit unusual overall counts, or have many targets with counts below the background estimate.

In each plot in this section, blank samples (if present in the experiment) are displayed as triangles. Thresholds for identification of outliers (dotted red lines) were determined using the *`r method`* method (see package documentation for this function); outliers, if any, are colored in red. 

## Total counts and positive control counts

We first plot the sum of all counts for each sample, excluding control probes. These counts reflect the amount of RNA input in each sample; any outliers might not have had enough input to permit reliable detection of genes with low expression levels. The next plot shows the ratio of positive control counts to all non-control counts for each sample.

```{r sum_plots}
allSumPlot(rccSet, method, stringency)
posSumVsAllSumPlot(rccSet, method, stringency)
```

## Gene detection count

For each sample, we plot the number of genes with counts that were below the estimated background, defining the LLOD using *`r method`*. Samples with more than `r maxMiss * 100` % of genes missing are colored in red: 

```{r lod}
lodPlot(rccSet, maxMiss=maxMiss)
```

## Count-based metrics summary

Assessment of these metrics resulted in flagging of `r sum(flags[,"CountFlags"])` sample(s).


# Flagged samples summary

In total, `r length(unique(unlist(apply(flags, 2, which))))` sample(s) were flagged based on quality metrics.


# Similarity between samples

Below, sample to sample correlations are clustered (distfun = "euclidean", hclustfun = "complete") and visualized in a heatmap. Deeper color represents a stronger correlation (to see the full-size image, click on the preview image below):

<div style="display: `r ifelse(heatmaps, 'block', 'none')`">
    <div class="centered">
        <a href="`r scMainImage`" target="_blank"><img src="`r scPreviewImage`"></a>
    </div>
</div>
<div style="display: `r ifelse(heatmaps==FALSE, 'block', 'none')`">
    (omitted since heatmaps were not enabled)
</div>


# Probe level QC

## Probe behavior in blank samples

Blank samples allow background signal estimation in a probe-specific fashion. Blank samples also enable detection of other suspicious behavior, e.g., elevated background counts that might indicate problems during probe-target hybridization. If blank samples were included in the data set, you will see a boxplot showing each gene's counts in the blanks as well as red dots showing the estimated probe-specific background (to see the full plot, click on the preview image below):

<div class="centered" style="display: `r ifelse(hasBlanks(rccSet), 'block', 'none')`">
    <a href="`r gcibsMainImage`" target="_blank"><img src="`r gcibsPreviewImage`"></a>
</div>
<div class="centered" style="display: `r ifelse(hasBlanks(rccSet)==FALSE, 'block', 'none')`">
    (omitted since no blank samples were found in the input)
</div>

## Probes with extreme counts

Probes which rarely produced signals above the LLOD are not informative for your experiment. On the other hand, if a small number of probes scavenge the majority of counts because their targets were extremely highly expressed, detection of low abundance transcripts may be compromised.

To address these two issues, we first look at the least detectable genes. If multiple sample types were defined, we determine for each sample type separately the genes that produced counts above the estimated background in less than 50% of these samples. (Note: up to 20 least detectable genes are shown for each sample type.)

```{r detectability, results="hide", cache=FALSE, message=FALSE}

## define non-controls
endo <- (fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))

## get all the sample types of interest, excluding undefined and blanks
sampleT <- unique(pData(rccSet)$SampleType)
sampleT <- sampleT[ !(sampleT %in% blankLabel) ]    # Don't use == here since it doesn't properly handle NAs in SampleType.
sampleT <- sampleT[ !is.na(sampleT) ]

if ("bgCorrData" %in% ls(assayData(rccSet))) {

  M <- assayData(rccSet)$bgCorrData
  rownames(M) <- fData(rccSet)$GeneName
  
  ## loop over sample types
  par(mfrow=c(length(sampleT), 1))
  par(mar=(par()$mar + c(0, 4, 0, 0)))          # Gene symbols along the y-axis were getting clipped.
  sapply(sampleT,
         function(st) {
            st_subset <- (pData(rccSet)$SampleType %in% st)      # Don't use == here.
            detect <- apply(M[endo, st_subset, drop=FALSE],
                            1,
                            function(x) { sum(x > 1) / sum(endo) * 100 })
            names(detect) <- fData(rccSet)$GeneName[endo]
            lowDetect <- head(which(detect < 50), n=20)
            if (length(lowDetect) > 0) {
              barplot(sort(detect[lowDetect], decreasing=TRUE),
                    main=paste0("Genes with > 50% missing\n(", st, ")"),
                    horiz=TRUE,
                    xlab="Percentage of samples with counts above LLOD",
                    las=1,
                    cex.names=min(0.2 + 1/log2(length(lowDetect)), 1.2))
            } else {
              print("Nothing to plot (all probes passed the detectability check)")
            }
  })
  par(mfrow=c(1,1))

} else {
  print("This plot requires background-corrected data in the input")
}

```

Next, we show the five genes that produced the highest average counts; again, if multiple sample types were defined, the data will be split accordingly:

```{r scavengers, results="hide", cache=FALSE, message=FALSE}

M <- assayData(rccSet)$exprs
rownames(M) <- fData(rccSet)$GeneName

par(mfrow=c(1, length(sampleT)))
sapply(sampleT,
       function(st)  {
         st_subset <- (pData(rccSet)$SampleType %in% st)      # N.B. Don't use == here.
         subData <- M[endo, st_subset, drop=FALSE]
         maxes <- names(tail(sort(rowMeans(subData)), n=5))
         toPlot <- apply(subData[maxes,,drop=FALSE],
                         1,
                         function(x) { x/colSums(subData) * 100 })
         if(!is.matrix(toPlot)) {  
           plot(toPlot, las=2, cex.axis=0.7, main=st, ylab="% counts of all counts", xaxt="n", xlab="")
           axis(1, at=1:5, labels=names(toPlot), las=2)
         } else {
            boxplot(toPlot, las=2, cex.axis=0.7, main=st, ylab="% counts of all counts")
         }
       })
par(mfrow=c(1,1))

```


# QC metrics in normalized data

## Housekeeping genes

After other preprocessing steps, data need to be normalized to correct for count differences caused by varying RNA input amounts. A popular method for doing so is using gene expression levels of housekeeping genes. We first inspect the expression of housekeeping genes across all samples to assess their suitability as normalization factors:

```{r assess_housekeeping}
if ((sum(fData(rccSet)$CodeClass == "Housekeeping") > 1)
    || (("Housekeeping" %in% colnames(fData(rccSet))) && (sum(fData(rccSet)$Housekeeping) > 1)))
{
  if ("Housekeeping" %in% colnames(fData(rccSet))) {
    tmp <- assessHousekeeping(rccSet, hk=fData(rccSet)$Housekeeping, covar=covar)
  } else {
    tmp <- assessHousekeeping(rccSet, hk=fData(rccSet)$CodeClass == "Housekeeping", covar=covar)
  }
  write.table(tmp, file=file.path(outputExtrasDir, "HousekeepingGeneStats.txt"), sep="\t", row.names=FALSE)
} else {
  print("This plot requires at least two housekeeping genes or features to be defined")
}
```

Additional metrics for assessing housekeeping gene behavior are available [here](`r file.path(outputExtrasDir, "HousekeepingGeneStats.txt")`).

## Housekeeping and global median normalization

Another way to normalize data is to use information of all genes measured in the panel and to normalize by their median. Here we show the overall distribution of counts in all samples using raw data, and data normalized by housekeeping genes (if applicable) and scaling to global median:

```{r normalization_comparison_densities, results="hide", cache=FALSE, message=FALSE}

nonctrls <- (fData(rccSet)$CodeClass %in% c("Endogenous", "Housekeeping"))

densityPlot(rawData[ nonctrls, ],
            pdata=pData(rccSet),
            covar=covar,
            log.transform=TRUE, 
		    main="Count distribution in raw data")

densityPlot(gmnormData[ nonctrls, ],
            pdata=pData(rccSet),
            covar=covar, 
		    main="Count distribution in data\nnormalized by global median")

if (!is.null(hknormData)) {
	densityPlot(hknormData[ nonctrls, ],
                pdata=pData(rccSet),
                covar=covar, 
		        main="Count distribution in data\nnormalized by housekeeping genes")
}

```

Then, we have a closer look at how different normalization methods perform with respect to inferred gene-gene correlation. If you have prior knowledge about which genes you expect to cluster together, the heatmaps allow you to check the impact of normalization.

<div style="display: `r ifelse(heatmaps, 'block', 'none')`">
    Global normalization (to see the full-size image, click on the preview image below):

    <div class="centered">
        <a href="`r gcgMainImage`" target="_blank"><img src="`r gcgPreviewImage`"></a>
    </div>

    Housekeeping normalization (to see the full-size image, click on the preview image below):

    <div class="centered" style="display: `r ifelse(!is.null(hknormData), 'block', 'none')`">
        <a href="`r gchMainImage`" target="_blank"><img src="`r gchPreviewImage`"></a>
    </div>
</div>
<div style="display: `r ifelse(heatmaps==FALSE, 'block', 'none')`">
    <div class="centered">
        (omitted since heatmaps were not enabled)
    </div>
</div>



# Recommendations

## QC flag summary

The following table lists all samples and marks those flagged by QC metrics with an "X":

```{r flagged_samples, warning=FALSE, results="asis"}
rownames(flags2) <- NULL
flags2[flags2 == FALSE] <- ""
flags2[flags2 == TRUE] <- "X"
kable(flags2, format="html", table.attr = 'id="datatable"')
```

[Download as tab-delimited text file](`r file.path(outputExtrasDir, "SampleFlags.txt")`)


## Clustering and QC-flagged samples

Below, we center each gene across all samples and perform a clustering based on correlation. Blue means lower expression than the mean of all samples, red higher expression. The colored bars above the heatmap indicate samples flagged in different QC categories (to see the full-size image, click on the preview image below):

<div style="display: `r ifelse(heatmaps, 'block', 'none')`">
    <div class="centered">
        <a href="`r cscMainImage`" target="_blank"><img src="`r cscPreviewImage`"></a>
    </div>
</div>
<div style="display: `r ifelse(heatmaps==FALSE, 'block', 'none')`">
    (omitted since heatmaps were not enabled)
</div>

Finally, we exclude all flagged samples and recluster. The colored bar above the plot now represents the total number of counts per sample, with deeper color reflecting more counts (to see the full-size image, click on the preview image below):

<div style="display: `r ifelse(heatmaps, 'block', 'none')`">
    <div class="centered">
        <a href="`r cscxfsMainImage`" target="_blank"><img src="`r cscxfsPreviewImage`"></a>
    </div>
</div>
<div style="display: `r ifelse(heatmaps==FALSE, 'block', 'none')`">
    (omitted since heatmaps were not enabled)
</div>



# SessionInfo

This report was created by `r Sys.info()[["user"]]` on `r as.character(Sys.time())`.

<div style="font-family: monospace; white-space: pre;">
```{r session_info, results='asis'}
print(sessionInfo())
```
</div>

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{pdata_fdata_adata.to.rccSet}
\alias{pdata_fdata_adata.to.rccSet}
\title{pdata_fdata_adata.to.rccSet}
\usage{
pdata_fdata_adata.to.rccSet(pdata_fdata_adata)
}
\arguments{
\item{pdata_fdata_adata}{List containing the pdata, fdata, and adata returned by
rccFiles.to.pdata_fdata_adata() or nSolverCsv.to.pdata_fdata_adata().}
}
\value{
An \code{\linkS4class{RccSet}} whose contents reflect the input data.
}
\description{
Second stage of readRccBatch()/readRccCollectorToolExport() -- not intended for external use.
}
\details{
Note that a pseudo-count of 1 is always added to all measurements, to enable
subsequent log transformation of the data in cases where zero-counts are
present.

N.B. The function currently expects certain columns to be present in
\code{pdata_fdata_a_data$pdata.m}, and it converts these to numerics. These
expectations should be incorporated into the class definition, and
conversion should only take place with a warning. Future updates will
address this.
}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{readRccCollectorToolExport}
\alias{readRccCollectorToolExport}
\title{Read RCC Collector Tool Export}
\usage{
readRccCollectorToolExport(file)
}
\arguments{
\item{file}{Path to the NSolver .CSV file to be read.}
}
\value{
An RccSet object that has count data in exprs, probe
information in fData and sample annotation in pData.
}
\description{
Reads the contents of a .CSV file generated from the RCC Collector Tool Export feature
of NanoString's nSolver Analysis software into a new RccSet object.
(Note: this function is not intended for external use. For that, see newRccSet().)
}
\details{
See 'details' in the readRccBatch() help page.
}
\author{
Dorothee Nickles, Thomas Sandmann
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/0_RccSet-class.R
\docType{class}
\name{RccSet-class}
\alias{RccSet-class}
\alias{.RccSet}
\title{RccSet class, derived from ExpressionSet}
\description{
The RccSet class is a trivial extension of
\code{\linkS4class{ExpressionSet}}, but with additional validation
criteria. \code{RccSet} is a class generator function.
}
\details{
A valid \code{RccSet} object must have the following columns in
\code{featureData}: \code{"CodeClass"}, \code{"GeneName"}, and
\code{"Accession"}. It must also have the following
\code{phenoData} columns: \code{"FileName"}, \code{"SampleID"},
\code{"LaneID"}, \code{"FovCount"}, \code{"FovCounted"},
\code{"StagePosition"}, \code{"BindingDensity"}, \code{"CartridgeID"}, and
\code{"SampleType"}. A final requirement is that the \code{"FovCount"}
column of \code{phenoData} have at most one distinct value.
}
\examples{

data("example_rccSet")
e <- example_rccSet

# "ExpressionSet" constructor makes a new assayData environment
r1 <- RccSet(e)
validObject(r1)
assayData(e)
assayData(r1)
head(pData(r1))
head(fData(r1))

# For other constructors, if not explicitly supplied, blank phenoData and
# featureData objects are populated with mandatory columns (and NA values).
r2 <- RccSet(assayData(e))
validObject(r2)
head(pData(r2))
head(fData(r2))

r3 <- RccSet(assayData(e), phenoData(e), featureData(e))
identical(pData(r1), pData(r3))
identical(fData(r1), fData(r3))
identical(annotation(r1), annotation(r3)) # We forgot it!
annotation(e)
r3 <- RccSet(assayData(e), phenoData(e), featureData(e), annotation = annotation(e))
identical(annotation(r1), annotation(r3)) # Better
identical(r1, r3) # False, due to assayData environments
assayData(r1)
assayData(r3)

# Matrix contructor is similar
r4 <- RccSet(exprs(e), phenoData(e), featureData(e), annotation = annotation(e))
identical(exprs(r1), exprs(r4))

# Blank object constructor
r0 <- RccSet()
dim(r0)
pData(r0)
fData(r0)
}
\seealso{
See \code{\link{checkRccSet}}, which provides additional checks and
generates warnings for unexpected or unusual conditions which, though
permitted by the class, may indicate data import errors.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{readRcc}
\alias{readRcc}
\title{Read an .RCC file}
\usage{
readRcc(rcc, removeSpikeInLabels = TRUE)
}
\arguments{
\item{rcc}{Path to the .RCC file.}

\item{removeSpikeInLabels}{Logical. If TRUE (the default), RNA \dQuote{spike-in} input labels (if any)
in the GeneName for positive and negative control probes will be removed.}
}
\value{
A list where each element holds the contents of one part of the .RCC file
(Header, Sample_Attributes, Lane_Attributes, Code_Summary, etc) as a
vector or data frame.
}
\description{
Parse an .RCC file into a list with each part of the file (Header,
                Sample_Attributes, Lane_Attributes, Code_Summary, etc) stored as a vector
                or data frame.
}
\examples{
rcc <- system.file("extdata", "RCC", "20140604_C1-unstim_C1-unstim_01.RCC", package="NanoStringQCPro")
rcc.ls <- readRcc(rcc)

}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{negCtrlsPlot,RccSet-method}
\alias{negCtrlsPlot,RccSet-method}
\alias{negCtrlsPlot}
\title{negCtrlsPlot}
\usage{
\S4method{negCtrlsPlot}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A plot with two panels: one showing boxplots for the individual negative controls across all samples, and 
one showing boxplots for the negative control counts for each individual sample (lane-specific background).
}
\description{
Plot negative controls across all samples in an RccSet object
}
\details{
In the second panel, boxplots are colored by lane (as specified in the pData slot). Bars on top of
the panel indicate the stage position for each cartridge/sample (as specified in the pData slot).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{getSpikeInInput}
\alias{getSpikeInInput}
\title{getSpikeInInput}
\usage{
getSpikeInInput(CodeClass, GeneName, nonCtrlProbeVal = NA)
}
\arguments{
\item{CodeClass}{Character vector with code classes for each probe.}

\item{GeneName}{Character vector with gene names/symbols for each probe.}

\item{nonCtrlProbeVal}{Value to assign as the spike-in input for the non-control probes.}
}
\value{
A data frame with the input CodeClass and GeneName but where the latter has been split into
two columns: one showing the GeneName for each probe with spike-in input labels removed
-- and another with the spike-in input levels.
}
\description{
Gets the RNA \dQuote{spike-in} input levels for positive and negative control probes from the label in their GeneName.
Note that this is a helper function for readRlf() and elsewhere and is not intended for external use.
}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{allSumPlot,RccSet-method}
\alias{allSumPlot,RccSet-method}
\alias{allSumPlot}
\title{allSumPlot}
\usage{
\S4method{allSumPlot}{RccSet}(rccSet, method = c("cutoffByMMAD",
  "cutoffByVar"), stringency = 4)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{method}{Character string specifying the method for outlier detection: either
"cutoffByMMAD" or "cutoffByVar".}

\item{stringency}{Numeric value passed to the cutoff function specified by the method
argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).}
}
\value{
A plot
}
\description{
Plot the sum of all counts (endogenous and housekeeping genes only) for each
sample in an RccSet object.
}
\details{
The sum of counts for each sample in the RccSet are plotted and and outliers
(as determined the cutoff function specified by the method argument) are
marked in red (thresholds for outlier definition are plotted as red dashed
lines).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{posR2Plot,RccSet-method}
\alias{posR2Plot,RccSet-method}
\alias{posR2Plot}
\title{posR2Plot}
\usage{
\S4method{posR2Plot}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{RccSet object}
}
\value{
A plot
}
\description{
Plot the R squared of linear fit of counts versus input for positive controls in an RccSet object.
}
\details{
R squared for each sample in the RccSet are plotted and samples with R squared < 0.95 are marked in red
(threshold indicated by dashed red line).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{cutoffByVar}
\alias{cutoffByVar}
\title{cutoffByVar}
\usage{
cutoffByVar(x, d, ...)
}
\arguments{
\item{x}{numeric vector}

\item{d}{scalar numeric, percent CV; passed on to dCoVar}

\item{...}{additional parameters passed on to mean()}
}
\value{
A list of length 2, with a scalar numeric in each slot, one giving the lower threshold (mean(x) - CV% based cutoff),
the other giving the upper threshold (mean(x) + percent CV based cutoff) for outlier definition.
}
\description{
Determine cutoffs of x (for outlier detection) based on a certain percent CV
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{fovPlot,RccSet-method}
\alias{fovPlot,RccSet-method}
\alias{fovPlot}
\title{Fields of view (FOV) plot}
\usage{
\S4method{fovPlot}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A plot
}
\description{
Plot the fraction of successfully imaged fields of view (FOV) in the given RccSet.
The RccSet's phenoData should have 'FovCount' and 'FovCounted' columns populated with the total
and successfully imaged FOV counts, respectively. Samples with a FOV counted/FOV count of less than
80% are marked in red (dashed red line indicates threshold).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{cutoffByMMAD}
\alias{cutoffByMMAD}
\title{cutoffByMMAD}
\usage{
cutoffByMMAD(x, d, ...)
}
\arguments{
\item{x}{numeric vector}

\item{d}{scalar numeric, factor by which to multiply MAD of x}

\item{...}{additional parameters passed on to median()}
}
\value{
A list of length 2, with a scalar numeric in each slot, one giving the lower threshold (median(x) - d * mad(x)),
the other giving the upper threshold (median(x) + d * mad(x)) for outlier definition.
}
\description{
Determine cutoffs of x (for outlier detection) based on median
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/previewPNG.R
\name{previewPNG}
\alias{previewPNG}
\title{Create a preview of a PNG}
\usage{
previewPNG(inputFile, outputFile, width, cropHeight, res = 72)
}
\arguments{
\item{inputFile}{Input PNG filename}

\item{outputFile}{Output PNG filename}

\item{width}{Width (in pixels) for the preview image}

\item{cropHeight}{Height (in pixels) for the preview image (if the rescaled input is larger
than this, it will be cropped)}

\item{res}{Output PNG resolution (passed to the `res' argument of png())}
}
\value{
A resized, vertically-cropped preview version of the input PNG.
}
\description{
Generates a resized, vertically-cropped preview version of the input PNG.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{colByFun}
\alias{colByFun}
\title{colByFun}
\usage{
colByFun(x, thresholds)
}
\arguments{
\item{x}{Numeric vector}

\item{thresholds}{List of length 2, with a scalar numeric in each slot, one giving the lower the upper threshold (for outlier definition)}
}
\value{
A vector of colors, with "red" for all values of x exceeding thresholds and "black" for all other values
}
\description{
Color x based on upper and lower thresholds
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{readRlf}
\alias{readRlf}
\title{Read RLF file}
\usage{
readRlf(rlf)
}
\arguments{
\item{rlf}{Path to the .RLF file}
}
\value{
A data frame containing the contents of the .RLF file.
}
\description{
Reads the contents of an .RLF file into a data frame. RNA \dQuote{spike-in} concentrations recorded in the
GeneName for positive and negative control probes are stripped and stored in a separate
column in the output. An error will be generated for any recognized deviations from the
expected file format.
}
\examples{
rlf <- system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro")
rlf.df <- readRlf(rlf)

}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{negCtrlsPairs,RccSet-method}
\alias{negCtrlsPairs,RccSet-method}
\alias{negCtrlsPairs}
\title{negCtrlsPairs}
\usage{
\S4method{negCtrlsPairs}{RccSet}(rccSet, log.transform = FALSE)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{log.transform}{boolean, whether data needs to be log2 transformed}
}
\value{
Pairs plot of the negative controls with a scatter plot in the lower panel and
correlatation coefficients printed in the upper panel.
}
\description{
Pairs plot of negative controls across all samples in an RccSet object
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{bdPlot,RccSet-method}
\alias{bdPlot,RccSet-method}
\alias{bdPlot}
\title{Binding density plot}
\usage{
\S4method{bdPlot}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A plot
}
\description{
Plot the binding density of each sample in an RccSet object.
Samples with a binding density < 0.05 or > 2.25 (thresholds defined by NanoString) 
are marked in red (dashed red line indicates threshold).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{posSumVsAllSumPlot,RccSet-method}
\alias{posSumVsAllSumPlot,RccSet-method}
\alias{posSumVsAllSumPlot}
\title{posSumVsAllSumPlot}
\usage{
\S4method{posSumVsAllSumPlot}{RccSet}(rccSet, method = c("cutoffByMMAD",
  "cutoffByVar"), stringency = 4)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{method}{Character string specifying the method for outlier detection: either
"cutoffByMMAD" or "cutoffByVar".}

\item{stringency}{Numeric value passed to the cutoff function specified by the method
argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).
(If the median ratio is less than 1, three times this value will be
used.)}
}
\value{
A plot
}
\description{
Plot the ratio of sums of positive control counts to all counts for all
samples in an RccSet object.
}
\details{
The ratio for each sample in the RccSet is plotted and and outliers (as
determined by the cutoff function specified by the method argument) are
marked in red (thresholds for outlier definition are plotted as red
dashed lines).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{assessHousekeeping,RccSet-method}
\alias{assessHousekeeping,RccSet-method}
\alias{assessHousekeeping}
\title{assessHousekeeping}
\usage{
\S4method{assessHousekeeping}{RccSet}(rccSet, hk, covar, annotate = TRUE,
  plot = TRUE, digits = 2)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{hk}{Either a boolean vector of length nrow(exprs(rccSet)) or a numeric vector of indices
which genes in exprs(rccSet) are housekeeping genes}

\item{covar}{character; colname in fData(rccSet) that can be used to label genes by a category of interest}

\item{annotate}{Scalar boolean; if TRUE (default), probes will be "annotated" using the "GeneName" column in the fData(rccSet) slot}

\item{plot}{Scalar boolean, plot pairwise relationships ?}

\item{digits}{Scalar integer, the number of decimal places}
}
\value{
A dataframe with one row per housekeeping genes and several columns with metrics suggested to
assess performance of defined housekeeping genes.
}
\description{
Assess correlation and variance/variability of housekeeping genes
}
\details{
Pairwise correlations of all defined housekeeping genes will be assessed and pairwise scatterplots will be generated. This function does not only
output pairwise correlation coefficients, but also - for each housekeeping gene - the variance, the interquartile range (IQR) and median expression
level across all samples in the experiment.
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{posRatioPlot,RccSet-method}
\alias{posRatioPlot,RccSet-method}
\alias{posRatioPlot}
\title{posRatioPlot}
\usage{
\S4method{posRatioPlot}{RccSet}(rccSet, method = c("cutoffByMMAD",
  "cutoffByVar"), stringency = 4)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{method}{Character string specifying the method for outlier detection: either
"cutoffByMMAD" or "cutoffByVar".}

\item{stringency}{Numeric value passed to the cutoff function specified by the method
argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).}
}
\value{
A plot
}
\description{
Plot the ratio of the mean of positive control counts for each sample and
the overall mean of positive control counts in an RccSet object.
}
\details{
The ratio for each sample in the RccSet is plotted and and outliers (as
determined the cutoff function specified by the method argument) are marked
in red (thresholds for outlier definition are plotted as red dashed lines).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BackgroundSubtractionFunctions.R
\docType{methods}
\name{getBackground,RccSet-method}
\alias{getBackground,RccSet-method}
\alias{getBackground}
\title{Get background estimates for a NanoString RccSet}
\usage{
\S4method{getBackground}{RccSet}(rccSet, bgReference = c("both", "blanks",
  "negatives"), summaryFunction = "median", stringency = 0,
  nSolverBackground.shrink = TRUE, nSolverBackground.w1 = 2.18,
  inputMatrix = c("posCtrlData", "exprs"))
}
\arguments{
\item{rccSet}{NanoString RccSet object.}

\item{bgReference}{Measurements to use for background estimates: one of "blanks" (for blank
samples), "negatives" (for negative control probes), or "both". Blanks are
assumed to be indicated as in the description above.}

\item{summaryFunction}{Summary function for background measurements (e.g. "mean" or "median").
User-defined functions similar to these can be specified here as well.}

\item{stringency}{Factor by which deviation (SD or MAD) of the summarization output will be
multiplied to obtain final background estimates.}

\item{nSolverBackground.shrink}{Value to use for the 'shrink' argument to nSolverBackground().}

\item{nSolverBackground.w1}{Value to use for the 'w1' argument to nSolverBackground().}

\item{inputMatrix}{Name of the matrix in the RccSet's assayData to use as input for calculating
background estimates (one of "exprs" or "posCtrlData"). If posCtrlData is
specified but not present in the assayData, an error will be generated.}
}
\value{
A matrix containing background estimates for a NanoString RccSet object.
}
\description{
Returns background estimates for a NanoString RccSet object. The function
depends upon correct annotation in the RccSet: if the \code{bgReference}
argument is set to \code{"blanks"}, it expects blank measurements (i.e.,
water runs) to have their phenoData SampleType set to the value indicating
blanks or an error will be thrown. (See getBlankLabel(); normally this value
would have been set using an argument to newRccSet()). If \code{bgReference} is set to
\code{"negatives"}, then it expects to find the negative control probes via
CodeClass == "Negative". If set to \code{"both"}, it expects both of the above and
will calculate initial background estimates using an algorithm that mimics
the implementation in NanoString's nSolver Analysis Software (see the
nSolverBackground() man page for details on the algorithm).
}
\examples{

data(example_rccSet)

## Calculate probe-specific background based on negative control probes
bg <- getBackground(example_rccSet, bgReference="negatives", summaryFunction="mean",
    inputMatrix="exprs")

## Calculate sample-specific background based on blanks
bg <- getBackground(example_rccSet, bgReference="blanks", inputMatrix="exprs")

## Calculate background that is both sample- and probe-specific
bg <- getBackground(example_rccSet, bgReference="both", stringency=1,
    inputMatrix="exprs")

}
\seealso{
\code{\link{subtractBackground}}
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{flagSamplesCtrl,RccSet-method}
\alias{flagSamplesCtrl,RccSet-method}
\alias{flagSamplesCtrl}
\title{flagSamplesCtrl}
\usage{
\S4method{flagSamplesCtrl}{RccSet}(rccSet, method = c("cutoffByMMAD",
  "cutoffByVar"), stringency = 4)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{method}{Character string specifying the method for outlier detection: either
"cutoffByMMAD" or "cutoffByVar".}

\item{stringency}{Numeric value passed to the cutoff function specified by the method
argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).}
}
\value{
A numeric vector giving the indices of samples with outlier values as
described above.
}
\description{
Flag samples based on the performance of their controls.
}
\details{
The method and stringency arguments determine a cutoff value used to
flag outlier samples based on the interquartile range of negative and
positive controls and in the slope of the linear fit of count versus input
of positive controls. Outliers will also be flagged if their positive
control scaling factor (see posCtrlNorm) is outside the NanoString
recommended range (i.e. below 0.3 or greater than 3).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\docType{methods}
\name{copyRccSet,RccSet-method}
\alias{copyRccSet,RccSet-method}
\alias{copyRccSet}
\title{Deep-copy a NanoString RccSet}
\usage{
\S4method{copyRccSet}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{A NanoString RccSet to be copied.}
}
\value{
A new RccSet that is a deep copy of the original.
}
\description{
Returns a copy of the input RccSet where the copy's assayData has been
produced via copyEnv() rather than a simple assignment -- hence deep-copying
the environment pointed to by assayData rather than just copying the
pointer. This guarantees that if the copy's assayData is affected later in
the code, assayData for the original won't be affected.
}
\examples{
data(example_rccSet)
example_rccSet_2 <- copyRccSet(example_rccSet)
assayData(example_rccSet)
assayData(example_rccSet_2) # Should be different

}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{lodPlot,RccSet-method}
\alias{lodPlot,RccSet-method}
\alias{lodPlot}
\title{lodPlot}
\usage{
\S4method{lodPlot}{RccSet}(rccSet, maxMiss = 0.2)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{maxMiss}{Numeric specifying the allowable fraction of genes below the lower limit
of detection in a sample.}
}
\value{
A plot
}
\description{
Function to plot the number of missing genes per sample in an RccSet object.
}
\details{
Samples with more than 50% missingness are marked in red. If blank
measurements are present, they are represented as triangles.
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{ctrlsZprimePlot,RccSet-method}
\alias{ctrlsZprimePlot,RccSet-method}
\alias{ctrlsZprimePlot}
\title{ctrlsZprimePlot}
\usage{
\S4method{ctrlsZprimePlot}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A plot
}
\description{
Plot distribution of counts and the Z' Factors comparing the nagative controls and
                the three highest input positive controls of an RccSet object.
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{zfacFun}
\alias{zfacFun}
\title{zfacFun}
\usage{
zfacFun(p, n)
}
\arguments{
\item{p}{numeric vector: measurements for the positive controls (or actual measurement)}

\item{n}{numeric vector: measurements for the negative controls}
}
\value{
Scalar numeric: the Z' Factor
}
\description{
Calculate Z' Factor
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{posNormFactPlot,RccSet-method}
\alias{posNormFactPlot,RccSet-method}
\alias{posNormFactPlot}
\title{posNormFactPlot}
\usage{
\S4method{posNormFactPlot}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A plot of the positive control scaling factor for each sample in an RccSet object.
Samples with a positive control scaling factor < 0.3 or > 3 (thresholds defined by NanoString) are
marked in red (dashed red line indicates threshold).
}
\description{
Plot positive control scaling factor for each sample in an RccSet object
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{countsInBlankSamples_verticalPlot}
\alias{countsInBlankSamples_verticalPlot}
\title{Plot counts in blank samples (vertical orientation)}
\usage{
countsInBlankSamples_verticalPlot(rccSet, outputFile)
}
\arguments{
\item{rccSet}{An RccSet}

\item{outputFile}{Output PNG filename}
}
\value{
A PNG file containing a boxplot of the gene-wise counts for the blank samples
in the input. The PNG is set to a fixed resolution of 300 pixels per inch and
a fixed width of 2250 pixels (i.e. 7.5" at 300ppi), but the height varies
with the size of the input. The font size is also fixed so that the labels
will be legible even for large datasets.
}
\description{
Plot counts in blank samples (vertical orientation)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQCreport.R
\docType{methods}
\name{makeQCReport,RccSet-method}
\alias{makeQCReport,RccSet-method}
\alias{makeQCReport}
\title{Make NanoString QC report}
\usage{
\S4method{makeQCReport}{RccSet}(rccSet,
  outputBaseName = "NanoStringQCPro_QC_report", outputDir = getwd(),
  preprocOverride = FALSE,
  experimentTitle = expinfo(experimentData(rccSet))["title"],
  covar = "SampleType", method = c("cutoffByMMAD", "cutoffByVar"),
  stringency = 4, maxMiss = 0.2, sampleNameCol = "SampleID",
  heatmaps = FALSE, cleanMarkdown = TRUE, verbose = FALSE)
}
\arguments{
\item{rccSet}{RccSet object for which to generate the QC report.}

\item{outputBaseName}{Character string specifying the base filename (without extension) to use
for the output file.}

\item{outputDir}{Character string specifying the path to the output directory for the QC
report and associated files.}

\item{preprocOverride}{Logical. If TRUE, the input's preprocessing will be ignored, and a default
preprocessing configuration (specifically, the defaults for
preprocRccSet()) will be applied so that all applicable plots can be
rendered in the report.}

\item{experimentTitle}{Character string specifying an easy to read identifier of the experiment.}

\item{covar}{Character string specifying a covariate for stratifying samples (e.g.
"SampleType").}

\item{method}{Method to determine outlier samples: either "cutoffByVar" or
"cutoffByMMAD".}

\item{stringency}{Multiplier with which to adjust cutoff values for determining outlier
samples.}

\item{maxMiss}{Numeric specifying the allowable fraction of genes below the lower limit
of detection in a sample.}

\item{sampleNameCol}{Character string specifying the name of the phenoData column holding the
sample names.}

\item{heatmaps}{Logical: render and show heatmaps?}

\item{cleanMarkdown}{Logical: upon completion, delete markdown files used to produce QC report?}

\item{verbose}{Logical: print progress messages?}
}
\value{
An html report is written to disk and a copy of the input RccSet is
invisibly returned with columns added to phenoData that show the QC flags
for each sample.
}
\description{
Creates an html QC report for an RccSet object. Alongside the html file, a
directory with matching filename is produced that contains additional files
as well as high resolution versions of the various plots in the report.
In addition to generating the QC report, the function returns a copy of the
input RccSet with columns added to phenoData that show the QC flags for each
sample.

The various plots in the report depend upon correct annotation and
preprocessing in the input object. If the input is missing any elements
required for a given plot, the plot will be replaced with a message
indicating the missing elements. If the preprocOverride argument is set to
TRUE, the input's preprocessing will be ignored and a default configuration
will be used so that all applicable plots will be rendered.
}
\examples{
data(example_rccSet)
norm_example_rccSet <- preprocRccSet(example_rccSet)
qc_example_rccSet <- makeQCReport(norm_example_rccSet, "example_QC_report")

}
\author{
Dorothee Nickles, Thomas Sandmann, Robert Ziman, Richard Bourgon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{ctrlsOverviewPlot,RccSet-method}
\alias{ctrlsOverviewPlot,RccSet-method}
\alias{ctrlsOverviewPlot}
\title{ctrlsOverviewPlot}
\usage{
\S4method{ctrlsOverviewPlot}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A plot with two panels, one for the negative controls, one for the positive controls.
}
\description{
Plot individual negative and positive controls across all samples in an RccSet object.
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{dCoVar}
\alias{dCoVar}
\title{dCoVar}
\usage{
dCoVar(x, d, ...)
}
\arguments{
\item{x}{numeric vector}

\item{d}{scalar numeric, percent CV}

\item{...}{additional parameters passed on to mean()}
}
\value{
standard deviation of x at d percent of CV
}
\description{
Determine standard deviation at a certain percent CV
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{pcaPlot}
\alias{pcaPlot}
\title{pcaPlot}
\usage{
pcaPlot(exx, ...)
}
\arguments{
\item{exx}{exprs() of an RccSet object}

\item{...}{additional parameters passed on to the plotting functions}
}
\value{
PCA screeplot and a plot with two panels, one plotting PC1 versus PC2, the other plotting
PC1 versus PC3.
}
\description{
Wrapper function to perform a PCA analysis on the exprs slot of an RccSet object
                and plot some results
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{iqrPlot,RccSet-method}
\alias{iqrPlot,RccSet-method}
\alias{iqrPlot}
\title{iqrPlot}
\usage{
\S4method{iqrPlot}{RccSet}(rccSet, codeClass = c("Negative", "Positive",
  "Endogenous", "Housekeeping"), method = c("cutoffByMMAD", "cutoffByVar"),
  stringency = 4)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{codeClass}{Character string specifying the code class (as annotated in the
fData(rccSet)$CodeClass column) for which the IQR shall be determined.}

\item{method}{Character string specifying the method for outlier detection: either
"cutoffByMMAD" or "cutoffByVar".}

\item{stringency}{Numeric value passed to the cutoff function specified by the method
argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).}
}
\value{
A plot
}
\description{
Plot the interquartile range (IQR) for a certain code class of probes in an
RccSet object.
}
\details{
IQR of the specified code class for each sample in the RccSet are plotted
and outliers (as determined by the function specified in the method
argument) are marked in red (thresholds for outlier definition are plotted
as red dashed lines).
}
\seealso{
\code{\link{cutoffByMMAD}}, \code{\link{cutoffByVar}}
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{panelCor}
\alias{panelCor}
\title{panelCor}
\usage{
panelCor(x, y, digits = 2, cex.cor = 0.75, doTest = FALSE)
}
\arguments{
\item{x}{integer}

\item{y}{integer, same length as x}

\item{digits}{scalar integer, indicating the number of decimal positions for displaying the correlation coefficient}

\item{cex.cor}{scalar numeric to specify relative font size for priting the correlation coefficient}

\item{doTest}{boolean, whether a results of cor.test should be displayed as well}
}
\value{
Prints correlation coefficients (and p-values if doTest = TRUE) within a pairs plot.
}
\description{
Helper function for printing correlation coefficients inside a pairs plots
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{lodAssess,RccSet-method}
\alias{lodAssess,RccSet-method}
\alias{lodAssess}
\title{lodAssess}
\usage{
\S4method{lodAssess}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A numeric vector giving the number of missing genes (endogenous and
housekeeping genes) for each sample in an RccSet. If paData is not
found in the input's assayData, NULL is returned.
}
\description{
Assess how many genes in each sample in an RccSet object are below the
limit of detection. (The current implementation does a straightforward
column sum on the presence/absence matrix (paData) in assayData.)
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{newRccSet}
\alias{newRccSet}
\title{Create a new RccSet object}
\usage{
newRccSet(rccFiles, rccCollectorToolExport = NULL, rlf = NULL,
  cdrDesignData = NULL, extraPdata = NULL, blankLabel = "blank",
  addEgAnnotations = FALSE, dropPdataCols = c("FileVersion",
  "SoftwareVersion", "Owner", "SystemAPF", "ScannerID", "CartridgeBarcode"),
  dropFdataCols = c("CodeClass_codesetAnnot", "Accession_codesetAnnot",
  "GeneName_codesetAnnot", "Accession_CDR"), experimentData.name = "",
  experimentData.lab = "", experimentData.contact = "",
  experimentData.title = "", experimentData.abstract = "",
  experimentData.url = "", experimentData.other = list())
}
\arguments{
\item{rccFiles}{Vector of paths to .RCC files with the raw count data.}

\item{rccCollectorToolExport}{Path to a .CSV file generated via the RCC Collector
Tool Export feature of NanoString's nSolver
Analysis Software. (Note that this is an alternative
to rccFiles, and if both arguments are specified at the
same time, the function will throw an error.)}

\item{rlf}{Path to the NanoString .RLF file describing
the codeset used in generating the .RCCs.}

\item{cdrDesignData}{Path to a .CSV extract of the "Design Data"
tab of a CDR spreadsheet corresponding to the
rest of the input files. See 'Details'
section of the buildCodesetAnnotation() help page
for more info on how this extract should be
prepared.}

\item{extraPdata}{Vector of paths to files containing additional
annotation about the samples which will be added
to the phenoData of the output RccSet. All
files should be tab-separated and should contain
a column labelled "FileName" whose values correspond
exactly to the basenames (including .RCC extension)
of the files specified in rccFiles or listed in
the RCC Collector Tool Export. More than one such file
may be used. A SampleType column should be present
in at most one file.}

\item{blankLabel}{Value for the output's phenoData SampleType column
that will indicate blank samples. This will be
recorded in the varMetadata for
SampleType. Blank samples, if available,
play an important role in preprocessing.}

\item{addEgAnnotations}{Logical indicating whether or not to add
EntrezGene annotations from the org.Hs.eg.db
package.}

\item{dropPdataCols}{Character vector specifying phenoData columns
to be dropped from the output object (if empty or
NULL, no columns will be dropped).}

\item{dropFdataCols}{Character vector specifying featureData columns
to be dropped from the output object (if empty or
NULL, no columns will be dropped).}

\item{experimentData.name}{String passed to the 'name' slot of the
output RccSet's experimentData.}

\item{experimentData.lab}{String passed to the 'lab' slot of the
output RccSet's experimentData.}

\item{experimentData.contact}{String passed to the 'contact' slot of the
output RccSet's experimentData.}

\item{experimentData.title}{String passed to the 'title' slot of the
output RccSet's experimentData.}

\item{experimentData.abstract}{String passed to the 'abstract' slot of the
output RccSet's experimentData.}

\item{experimentData.url}{String passed to the 'url' slot of the
output RccSet's experimentData.}

\item{experimentData.other}{List passed to the 'other' slot of the
output RccSet's experimentData.}
}
\value{
An \code{\linkS4class{RccSet}} containing the raw NanoString data and annotations.
}
\description{
This is the main wrapper function for generating an RccSet from NanoString
data. The function takes as input a vector of NanoString .RCC files with the
raw data or a .CSV file generated via the RCC Collector Tool Export feature
of NanoString's nSolver Analysis Software, an optional path to the .RLF file
describing the codeset used, optional paths to additional annotation about
the features and samples, and details about the experiment. It returns an
RccSet object.
}
\details{
In the .RLF (and sometimes in the .RCC files), the GeneName field for
positive and negative control probes contains a parenthesized label
indicating the RNA \dQuote{spike-in} levels for each probe. These labels are
removed from the control probe GeneNames in the output and recorded instead
in SpikeInInput in the output's featureData.

A pseudocount of 1 is added to all measurements to enable subsequent
log transformation of the data.

If the phenoData SampleType column is not specified via an annotation file
passed in through extraPdata, it will be created and assigned NA for all
samples.
}
\examples{
rccDir <- system.file("extdata", "RCC", package="NanoStringQCPro")
rccSet <- newRccSet(
    rccFiles = dir(rccDir, full.names=TRUE),
    rlf = system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro"),
    extraPdata = system.file("extdata", "extraPdata", "SampleType.txt", package="NanoStringQCPro"),
    blankLabel = "blank",
    experimentData.name = "Robert Ziman",
    experimentData.lab = "Richard Bourgon",
    experimentData.contact = "ziman.robert@gene.com",
    experimentData.title = "NanoStringQCPro example dataset",
    experimentData.abstract = "Example data for the NanoStringQCPro package"
)

}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\docType{methods}
\name{checkRccSet,RccSet-method}
\alias{checkRccSet,RccSet-method}
\alias{checkRccSet}
\title{Check an RccSet}
\usage{
\S4method{checkRccSet}{RccSet}(rccSet, reportWarnings = TRUE,
  showMessages = FALSE)
}
\arguments{
\item{rccSet}{An RccSet to be checked.}

\item{reportWarnings}{Logical. If TRUE, warnings are reported.}

\item{showMessages}{Logical. If TRUE, notes are shown indicating any optional missing
columns and the like.}
}
\value{
Returns TRUE if no warnings were generated and FALSE otherwise.
}
\description{
Provides additional checks and generates warnings for unexpected or unusual conditions
which, though permitted by the RccSet class, may indicate data import errors.
}
\examples{
data(example_rccSet)
checkRccSet(example_rccSet)

}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\docType{methods}
\name{getBlankLabel,RccSet-method}
\alias{getBlankLabel,RccSet-method}
\alias{getBlankLabel}
\title{Get the SampleType value that indicates blank samples}
\usage{
\S4method{getBlankLabel}{RccSet}(rccSet, showWarnings = TRUE)
}
\arguments{
\item{rccSet}{An RccSet}

\item{showWarnings}{Logical. If FALSE, no warnings will be generated (if any).}
}
\value{
NULL if the SampleType column is missing altogether, NA if the varMetadata doesn't
have blankLabel recorded, or the blankLabel value otherwise.
}
\description{
Returns the phenoData SampleType value that indicates blank samples (i.e. water runs).
This value is parsed from the single-quoted string enclosed by "blankLabel='...'"
in the varMetadata for SampleType.
}
\examples{
data(example_rccSet)
blankLabel <- getBlankLabel(example_rccSet)

}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\docType{methods}
\name{posCtrlNorm,RccSet-method}
\alias{posCtrlNorm,RccSet-method}
\alias{posCtrlNorm}
\title{Positive control normalization}
\usage{
\S4method{posCtrlNorm}{RccSet}(rccSet, summaryFunction = "sum",
  quietly = FALSE)
}
\arguments{
\item{rccSet}{An RccSet object.}

\item{summaryFunction}{Function to be used for the normalization (e.g. "mean", "median", or
"sum"). User-defined functions similar to these can be specified here as
well.}

\item{quietly}{Logical. If TRUE, messages and warnings will not be shown.}
}
\value{
A copy of the input RccSet that has count data adjusted by positive control
counts. The positive control scaling factor is recorded in PosFactor in the
output's phenoData (if this column already exists in the input, it will
be overwritten in the output copy).
}
\description{
Applies positive control normalization to the data in an RccSet object.
}
\examples{
data(example_rccSet)
pcnorm_example_rccSet <- posCtrlNorm(example_rccSet)

}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{buildCodesetAnnotation}
\alias{buildCodesetAnnotation}
\title{Build NanoString codeset annotation}
\usage{
buildCodesetAnnotation(rlf = NULL, cdrDesignData = NULL,
  removeRedundantCols = TRUE, addEgAnnotations = FALSE)
}
\arguments{
\item{rlf}{Path to the RLF file}

\item{cdrDesignData}{Path to a manually prepared .CSV export of the
"Design Data" tab of the CDR file (optional;
see 'details' section below for how the export
should be prepared)}

\item{removeRedundantCols}{Logical. If TRUE, cols in the CDR that are redundant
with those in the RLF will be omitted from the output.}

\item{addEgAnnotations}{Logical indicating whether or not to add
EntrezGene IDs and HGNC symbols from the
org.Hs.eg.db package.}
}
\value{
A data frame whose content is the combination of the NanoString-provided
codeset annotation with gene annotation in the org.Hs.eg.db package.
}
\description{
This function returns a data frame whose content is the combination of
                the NanoString-provided codeset annotation (.RLF file and the
                "Design Data" tab of the CDR spreadsheet) with gene annotation in the
                org.Hs.eg.db package.
}
\details{
The original NanoString provided .RLF file is expected as input. This
file is the master (i.e. only probes listed here will be annotated;
any extra ones in the CDR export will be dropped). If
the CDR "Design Data" .CSV is specified, the function expects this .CSV
file to be generated from the "Design Data" tab of the original NanoString
provided Excel CDR file. This tab needs to be trimmed by skipping the
NanoString header and first column containing only integers;
the resulting .CSV should contain the actual table (including its header
-- beginning with "Customer Identifier"). The function will match and
join the .RLF and CDR .CSV using their "ProbeID" and "NSID" fields, and
then it will add gene annotation (EntrezGene ID, HGNC symbol, and
chromosomal position) by doing lookups in the org.Hs.eg.db package using
the RefSeq accessions from the RLF.
}
\examples{
rlf <- system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro")
cdrDesignData <- system.file("extdata", "CDR", "CDR-DesignData.csv", package="NanoStringQCPro")
annot <- buildCodesetAnnotation(rlf, cdrDesignData)

}
\author{
Dorothee Nickles, Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{flagSamplesCount,RccSet-method}
\alias{flagSamplesCount,RccSet-method}
\alias{flagSamplesCount}
\title{flagSamplesCount}
\usage{
\S4method{flagSamplesCount}{RccSet}(rccSet, method = c("cutoffByMMAD",
  "cutoffByVar"), stringency = 4, maxMiss = 0.2)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{method}{Character string specifying the method for outlier detection: either
"cutoffByMMAD" or "cutoffByVar".}

\item{stringency}{Numeric value passed to the cutoff function specified by the method
argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).}

\item{maxMiss}{Numeric specifying the allowable fraction of genes below the lower limit
of detection in a sample.}
}
\value{
A numeric vector giving the indices of samples with outlier values
according to the criteria described above.
}
\description{
Flag samples based on overall counts
}
\details{
The method and stringency arguments deterine a cutoff value used to flag
samples as outliers: samples will be flagged if the sum of counts of their
endogeneous genes exceeds the cutoff or if the ratio of the sums of their
positive controls to the sums of their endogenous genes exceeds three
times the cutoff. Samples will also be flagged if the fraction of
genes below the lower limit of detection exceeds the maxMiss value.
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{myCols}
\alias{myCols}
\title{myCols}
\usage{
myCols()
}
\value{
A vector of colors
}
\description{
Function that defines nice colors
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\docType{methods}
\name{preprocRccSet,RccSet-method}
\alias{preprocRccSet,RccSet-method}
\alias{preprocRccSet}
\title{Preprocess an RccSet}
\usage{
\S4method{preprocRccSet}{RccSet}(rccSet, doPosCtrlNorm = TRUE,
  doBackground = TRUE, doPresAbs = TRUE, doContentNorm = TRUE,
  pcnSummaryFunction = "sum", bgReference = c("both", "blanks",
  "negatives"), bgSummaryFunction = "median", bgStringency = 1,
  nSolverBackground.w1 = 2.18, nSolverBackground.shrink = TRUE,
  paStringency = 2, normMethod = c("global", "housekeeping"),
  normSummaryFunction = "median", hkgenes = NULL, hkfeatures = NULL,
  quietly = FALSE)
}
\arguments{
\item{rccSet}{An RccSet.}

\item{doPosCtrlNorm}{Boolean specifying whether or not to perform positive control normalization.
(`pcd' is short for `posCtrlData', the matrix which gets added to assayData
when this step is performed.)}

\item{doBackground}{Boolean specifying whether or not to perform background correction.}

\item{doPresAbs}{Boolean specifying whether or not the presence/absence call should be
performed. For details, see presAbsCall().}

\item{doContentNorm}{Boolean specifying whether or not content normalization should be performed.}

\item{pcnSummaryFunction}{Function to be used for the positive control normalization (e.g. "mean",
"median", or "sum"). User-defined functions similar to these can be
specified here as well.}

\item{bgReference}{Measurements to use for background estimates: either "blank" (for blank
samples), "negatives" (for negative control probes), or "both". For
details on exactly how the background estimates are computed in each
case, see getBackground().}

\item{bgSummaryFunction}{Summary function for background measurements (e.g. "mean" or "median").
User-defined functions similar to these can be specified here as well.}

\item{bgStringency}{Factor by which deviation (SD or MAD) of the summarization output will be
multiplied to obtain final background estimates.}

\item{nSolverBackground.w1}{Value to use for the 'w1' argument to nSolverBackground(). (Only takes
effect if bgReference == "both"; see getBackground().)}

\item{nSolverBackground.shrink}{Value to use for the 'shrink' argument to nSolverBackground(). (Only takes
effect if bgReference == "both"; see getBackground().)}

\item{paStringency}{Multiplier to use in establishing the presence/absence call. For details,
see presAbsCall().}

\item{normMethod}{Specifies the features to be used for content normalization. "global" indicates that all
features should be used and "housekeeping" indicates that only housekeeping
features should be used. If "housekeeping" is specified and the `hk' argument
(below) is also specified, then the features indicated by `hk' will be used.
If "housekeeping" is specified and `hk' is left NULL, then the default
housekeeping features (i.e. those with CodeClass == "Housekeeping") will be used.}

\item{normSummaryFunction}{Character specifying the summary function to apply to the selected features
(e.g. "mean" or "median") during the content normalization step. User-defined
functions similar to these can be specified here as well.}

\item{hkgenes}{Character vector with gene symbols to be used for content normalization if
housekeeping is specified as the normalization method. If specified, all
features that match any of the specified symbols will be used. (To specify
specific features, use the `hkfeatures' argument instead; see below.)}

\item{hkfeatures}{Character vector with full feature names
("<CodeClass>_<GeneName>_<Accession>", e.g. "Endogenous_ACTG1_NM_001614.1")
to be used for content normalization if housekeeping is specified as the normalization
method. (Note: if this argument is specified at the same time as `hkgenes',
an error will be thrown.)}

\item{quietly}{Boolean specifying whether or not messages and warnings should be omitted.}
}
\value{
A copy of the input RccSet with additional matrices in the assayData for each
successive preprocessing step along with parameters for each step recorded in the
experimentData@preprocessing list.
}
\description{
This function is a wrapper to perform any combination of positive control
normalization, background correction, and content normalization on the
input RccSet. For each completed preprocessing step, a matrix is added to
the assayData of the resulting RccSet object:

\itemize{
  \item posCtrlData: expression data after positive control normalization
  \item bgEstimates: background estimates
  \item bgCorrData: expression data after positive control normalization and
        background correction
  \item normData: expression data after positive control normalization,
        background correction, and content normalization
}

(\bold{NOTE}: normData is on a log2 scale while all the other matrices are
on a linear scale.)

If any step is omitted, the corresponding matrix will not be present in
the output's assayData. The parameters for all steps are recorded in the
output's experimentData@preprocessing list (accessible through
preproc(rccSet) where rccSet is an RccSet output by this function). In
addition:

\itemize{
  \item If blanks are not present in the data, use bgReference="negatives"
        to prevent the function from throwing an error.
  \item If positive control normalization is performed, a column named
        'PosCtrl' is added to the output's phenoData to record the
        positive control scaling factors.
  \item If the presence/absence call is performed, a matrix named `paData'
        is added to the output's assayData to indicate the
        presence/absence of each feature in each sample. See the `pa'
        argument for details.
  \item If housekeeping normalization is performed, a column labeled
        `Housekeeping' is added to the featureData to indicate which
        features were used for it.
}
}
\details{
For more information on the rationale behind the recommended
preprocessing and normalization steps, please see the vignette.
}
\examples{
data(example_rccSet)
hknorm_example_rccSet <- preprocRccSet(example_rccSet)

}
\references{
\href{http://www.nanostring.com/media/pdf/MAN_nCounter_Gene_Expression_Data_Analysis_Guidelines.pdf}{NanoString nCounter(R) Expression Data Analysis Guide (2012)}
}
\author{
Dorothee Nickles, Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{sampleClustering,RccSet-method}
\alias{sampleClustering,RccSet-method}
\alias{sampleClustering}
\title{Clustering by sample correlation}
\usage{
\S4method{sampleClustering}{RccSet}(rccSet, outputFile,
  main = "Sample correlations in raw data", annCol = NULL,
  covar = "SampleType")
}
\arguments{
\item{rccSet}{An RccSet}

\item{outputFile}{Output PNG filename}

\item{main}{Plot title}

\item{annCol}{See \code{\link{aheatmap}}}

\item{covar}{Covariate (e.g. "SampleType")}
}
\value{
A PNG file showing clustering of samples by correlation. Any zero-variance
samples are omitted from the heatmap.
The width and height of the PNG file are set to vary with the size of the input.
}
\description{
Clustering by sample correlation
}
\author{
Dorothee Nickles, Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{posSlopePlot,RccSet-method}
\alias{posSlopePlot,RccSet-method}
\alias{posSlopePlot}
\title{posSlopePlot}
\usage{
\S4method{posSlopePlot}{RccSet}(rccSet, method = c("cutoffByMMAD",
  "cutoffByVar"), stringency = 4)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{method}{Character string specifying the method for outlier detection: either
"cutoffByMMAD" or "cutoffByVar".}

\item{stringency}{Numeric value passed to the cutoff function specified by the method
argument (see the 'd' argument of cutoffByMMAD and cutoffByVar).}
}
\value{
A plot
}
\description{
Plot the slope of linear fit of counts versus input for positive controls
in an RccSet object.
}
\details{
The slope for each sample in the RccSet are plotted and and outliers (as
determined by the function specified by the method argument) are marked in
red (thresholds for outlier definition are plotted as red dashed lines).
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{readRccBatch}
\alias{readRccBatch}
\title{Read RCC files}
\usage{
readRccBatch(rccFiles)
}
\arguments{
\item{rccFiles}{Vector of .RCC file paths}
}
\value{
An RccSet object that has raw counts in assayData, probe information
in fData, and sample annotation in pData.
}
\description{
Reads the contents of all .RCC files from a given directory into a new
RccSet object. Note: this function is not intended for external use. For
that, see newRccSet().
}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{rccFiles.to.pdata_fdata_adata}
\alias{rccFiles.to.pdata_fdata_adata}
\title{rccFiles.to.pdata_fdata_adata}
\usage{
rccFiles.to.pdata_fdata_adata(rccFiles)
}
\arguments{
\item{rccFiles}{Vector of .RCC paths}
}
\value{
A list containing matrices (for pdata and adata) and a data frame (for fdata)
that pdata_fdata_adata.to.rccSet() then transforms into a full ExpessionSet.
}
\description{
First stage of readRccBatch(): produces a list containing matrices (for pdata and adata) and a data frame (for fdata) that
                pdata_fdata_adata.to.rccSet() then transforms into a full RccSet (after some further checks and adjustments).
                See also nSolverCsv.to.pdata_fdata_adata().
}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQCPro-package.r
\docType{package}
\name{NanoStringQCPro}
\alias{NanoStringQCPro}
\alias{NanoStringQCPro-package}
\title{NanoStringQCPro}
\description{
NanoStringQCPro
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\docType{methods}
\name{addCodesetAnnotation,RccSet-method}
\alias{addCodesetAnnotation,RccSet-method}
\alias{addCodesetAnnotation}
\title{Add NanoString codeset annotation to an RccSet}
\usage{
\S4method{addCodesetAnnotation}{RccSet}(rccSet, annot, reorder = TRUE,
  showWarnings = TRUE)
}
\arguments{
\item{rccSet}{An RccSet object.}

\item{annot}{Data frame containing the codeset annotation.}

\item{reorder}{Logical indicating whether the probes should be reordered
according to their barcodes (this can help in identifying
barcode-specific artifacts -- i.e. background noise).}

\item{showWarnings}{Logical indicating whether or not warnings should be shown, if any.}
}
\value{
A copy of the input RccSet where the codeset annotation has been
merged into its fData slot.
}
\description{
Returns a copy of the input RccSet where the codeset annotation
                has been merged into its fData slot. The merge key for each is a string
                formed from the concatenation of their CodeClass, GeneName, and
                Accession columns ("<CodeClass>_<GeneName>_<Accession>"). For creating
                the codeset annotation object, see buildCodesetAnnotation().
}
\examples{
rccDir <- system.file("extdata", "RCC", package="NanoStringQCPro")
rccSet <- newRccSet(rccFiles = dir(rccDir, full.names=TRUE))
rlf <- system.file("extdata", "RLF", "NQCP_example.rlf", package="NanoStringQCPro")
annot <- buildCodesetAnnotation(rlf)
rccSet.annotated <- addCodesetAnnotation(rccSet, annot)

}
\author{
Dorothee Nickles, Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\docType{methods}
\name{contentNorm,RccSet-method}
\alias{contentNorm,RccSet-method}
\alias{contentNorm}
\title{Content normalization}
\usage{
\S4method{contentNorm}{RccSet}(rccSet, method = c("global", "housekeeping"),
  summaryFunction = "median", hk = NULL, inputMatrix = c("bgCorrData",
  "posCtrlData", "exprs"), quietly = FALSE)
}
\arguments{
\item{rccSet}{An RccSet.}

\item{method}{Specifies the features to be used for normalization. "global" indicates that all
features should be used and "housekeeping" indicates that only housekeeping
features should be used. If "housekeeping" is specified and the `hk' argument
(below) is also specified, then the features indicated by `hk' will be used.
If "housekeeping" is specified and `hk' is left NULL, then the default
housekeeping features (i.e. those with CodeClass == "Housekeeping") will be used.}

\item{summaryFunction}{Character specifying the summary function to apply to the selected features
(e.g. "mean" or "median"). User-defined functions similar to these can be
specified here as well.}

\item{hk}{Logical vector defining, for each feature, whether or not it shall
be used for housekeeping normalization if housekeeping is specified as the
normalization method.}

\item{inputMatrix}{Name of the matrix in the RccSet's assayData to use as input for performing
content normalization (one of "exprs", "posCtrlData", or "bgCorrData"). If
posCtrlData or bgCorrData are specified but not found in the assayData, an
error will be generated.}

\item{quietly}{Boolean specifying whether or not messages and warnings should be omitted.}
}
\value{
A copy of the input is returned with a new matrix named `normData' added to
the assayData that contains the content-normalized counts. (\bold{NOTE}: normData
contains values on a log2 scale while all other matrices in assayData are
on a linear scale.) If housekeeping is specified as the normalization method,
then the housekeeping features used will be recorded in the returned RccSet in
a new featureData column named `Housekeeping'. Parameters specified in the
function call are also recorded in the output's experimentData@preprocessing
list.
}
\description{
Performs content normalization on the given RccSet.
}
\examples{
data(example_rccSet)

pcnorm_example_rccSet <- posCtrlNorm(example_rccSet)
bg <- getBackground(pcnorm_example_rccSet)
bgcorr_example_rccSet <- subtractBackground(pcnorm_example_rccSet, bg)

gmnorm_example_rccSet <- contentNorm(bgcorr_example_rccSet, method="global",
    inputMatrix="exprs")
hknorm_example_rccSet <- contentNorm(bgcorr_example_rccSet, method="housekeeping",
    summaryFunction="mean")

}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{readCdrDesignData}
\alias{readCdrDesignData}
\title{Read .CSV containing CDR 'Design Data' extract}
\usage{
readCdrDesignData(cdrDesignData)
}
\arguments{
\item{cdrDesignData}{Path to the .CSV file containing the content extracted from the CDR's 'Design Data' tab}
}
\value{
A data frame containing the contents of the CDR 'Design Data' tab.
}
\description{
Return a data frame containing the contents of the 'Design Data' tab
                extracted from a CDR spreadsheet. The extract, a .CSV file, must be
                manually prepared in advance (see 'details' section in the
                buildCodesetAnnotation() help page for more info).
}
\examples{
path <- system.file("extdata", "CDR", "CDR-DesignData.csv", package="NanoStringQCPro")
cdr <- readCdrDesignData(path)

}
\author{
Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\docType{methods}
\name{addQCFlags,RccSet-method}
\alias{addQCFlags,RccSet-method}
\alias{addQCFlags}
\title{Add sample QC flags to an rccSet}
\usage{
\S4method{addQCFlags}{RccSet}(rccSet, flagFile)
}
\arguments{
\item{rccSet}{An RccSet object}

\item{flagFile}{Path to a sample QC flag file as generated by the
NanoStringQCPro QC report (see makeQCReport())}
}
\value{
A copy of the input RccSet with columns added to pData from the QC
flag file.
}
\description{
Returns a copy of the input RccSet with columns added to pData
                from the provided sample QC flag annotation file. (That file is
                produced by makeQCReport(); see its help page for more
                details.)
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\docType{methods}
\name{presAbsCall,RccSet-method}
\alias{presAbsCall,RccSet-method}
\alias{presAbsCall}
\title{Presence/absence call}
\usage{
\S4method{presAbsCall}{RccSet}(rccSet, stringency = 2,
  inputMatrix = c("posCtrlData", "exprs"), quietly = FALSE)
}
\arguments{
\item{rccSet}{An RccSet with background-corrected data.}

\item{stringency}{Multiplier to use in establishing the presence/absence call as
mentioned in the description.}

\item{inputMatrix}{Name of the matrix in the RccSet's assayData on which to apply the
presence/absence call (either "posCtrlData" or "exprs").}

\item{quietly}{Logical. If TRUE, messages and warnings will not be shown.}
}
\value{
A copy of the input is returned with a new matrix named `paData' added to
the assayData that contains the presence/absence calls.
}
\description{
Adds a matrix to assayData (`paData') which indicates the presence/absence
call for each gene in each sample using the background estimates and
a stringency value. A gene is considered present in a sample if
its count in that sample exceeds the corresponding background estimate
times the stringency. The count values can be taken from either the
positive control normalized data or the raw data (see
the inputMatrix agrument). If the input doesn't contain background-corrected
data, an error will be generated.
}
\examples{
data(example_rccSet)
pcnorm_rccSet <- posCtrlNorm(example_rccSet)
bgEst <- getBackground(pcnorm_rccSet)
bgcorr_rccSet <- subtractBackground(pcnorm_rccSet, bgEst)
pa_rccset <- presAbsCall(bgcorr_rccSet)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\docType{methods}
\name{flagSamplesTech,RccSet-method}
\alias{flagSamplesTech,RccSet-method}
\alias{flagSamplesTech}
\title{flagSamplesTech}
\usage{
\S4method{flagSamplesTech}{RccSet}(rccSet)
}
\arguments{
\item{rccSet}{An RccSet object}
}
\value{
A numeric vector giving the indices of samples with outlier values in FOV counted and
binding density < 0.05 or > 2.25 (thresholds defined by NanoString) will be flagged.
}
\description{
Flag samples based on their technical performance, i.e. field of vision (FOV) counted and binding density
}
\details{
Samples with a FOV counted/FOV count of less than 80% will be flagged. Also samples with a binding density
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{colByCovar}
\alias{colByCovar}
\title{colByCovar}
\usage{
colByCovar(pdata, covar)
}
\arguments{
\item{pdata}{pData() of an RccSet object}

\item{covar}{character, colname in the pdata used to stratify (color) data}
}
\value{
A list of length 2, with [["color"]] being a character vector of colors (one color for each level of covar) of length=number of observations
and [["legend"]] providing the levels of covar to map colors to covar
}
\description{
Define colors based on a covariate of an RccSet object
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringConvenience.R
\name{nSolverCsv.to.pdata_fdata_adata}
\alias{nSolverCsv.to.pdata_fdata_adata}
\title{nSolverCsv.to.pdata_fdata_fdata}
\usage{
nSolverCsv.to.pdata_fdata_adata(rccCollectorToolExport)
}
\arguments{
\item{rccCollectorToolExport}{Path to the nSolver RCC Collector Tool .CSV export.}
}
\value{
A list containing matrices (for pdata and adata) and a data frame (for fdata)
that pdata_fdata_adata.to.rccSet() then transforms into a full ExpessionSet.
}
\description{
First stage of readRccCollectorToolExport(): produces a list containing
                matrices (for pdata and adata) and a data frame (for fdata) that
                pdata_fdata_adata.to.rccSet then transforms into a full RccSet
                (after some further checks and adjustments). Not intended for
                external use; see also rccFiles.to.pdata_fdata_adata().
}
\author{
Dorothee Nickles, Thomas Sandmann, Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/example_rccSet.R
\docType{data}
\name{example_rccSet}
\alias{example_rccSet}
\title{NanoStringQCPro example dataset}
\format{An RccSet object}
\source{
This is an artificial dataset designed to resemble real data.
}
\description{
Example data for the NanoStringQCPro package
}
\author{
Dorothee Nickles
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BackgroundSubtractionFunctions.R
\docType{methods}
\name{subtractBackground,RccSet-method}
\alias{subtractBackground,RccSet-method}
\alias{subtractBackground}
\title{Subtract background estimates for a NanoString RccSet}
\usage{
\S4method{subtractBackground}{RccSet}(rccSet, bgEstimates,
  bgEstimatesParams = list(), inputMatrix = c("posCtrlData", "exprs"),
  quietly = FALSE)
}
\arguments{
\item{rccSet}{NanoString RccSet object}

\item{bgEstimates}{Matrix containing the background estimates to subtract.}

\item{bgEstimatesParams}{A list with the parameters that were used to generate the background
estimates (see getBackground()):

\itemize{
  \item bgReference
  \item summaryFunction
  \item stringency
  \item nSolverBackground.w1
  \item nSolverBackground.shrink
  \item inputMatrix
}

The values of these list elements will be assigned to corresponding elements
in the output's experimentData@preprocessing list. If any element is NULL,
the corresponding element in the output's preprocessing list will be NA.}

\item{inputMatrix}{Name of the matrix in the RccSet's assayData to use as input for subtracting
background estimates (one of "exprs" or "posCtrlData"). If posCtrlData is
specified but not found in the assayData, an error will be generated.}

\item{quietly}{Boolean specifying whether or not messages and warnings should be omitted.}
}
\value{
A NanoString \code{linkS4class{RccSet}} object with background estimates
subtracted from the count data.
}
\description{
Returns a NanoString \code{\linkS4class{RccSet}} with background-corrected
count data. During subtraction, any counts below 1 will be truncated to 1 to
enable subsequent log transformation of the data.
}
\examples{

data(example_rccSet)

pcnorm_rccSet <- posCtrlNorm(example_rccSet)

bg1 <- getBackground(pcnorm_rccSet, bgReference="negatives", summaryFunction="mean")
bg2 <- getBackground(pcnorm_rccSet, bgReference="blanks")
bg3 <- getBackground(pcnorm_rccSet, bgReference="both", stringency=1)

bgCor1 <- subtractBackground(pcnorm_rccSet, bgEstimates=bg1)
bgCor2 <- subtractBackground(pcnorm_rccSet, bgEstimates=bg2)
bgCor3 <- subtractBackground(pcnorm_rccSet, bgEstimates=bg3)

}
\seealso{
\code{\link{getBackground}}
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/0_RccSet-class.R
\docType{methods}
\name{RccSet}
\alias{RccSet}
\alias{RccSet,ExpressionSet-method}
\alias{RccSet,environment-method}
\alias{RccSet,matrix-method}
\alias{RccSet,missing-method}
\title{RccSet constructor methods}
\usage{
RccSet(obj, ...)

\S4method{RccSet}{ExpressionSet}(obj, ...)

\S4method{RccSet}{environment}(obj, ...)

\S4method{RccSet}{matrix}(obj, ...)

\S4method{RccSet}{missing}(obj, ...)
}
\arguments{
\item{obj}{An object of appropriate class}

\item{...}{Passed to methods.}
}
\value{
A new \code{\linkS4class{RccSet}} object.
}
\description{
Constructor methods for making new \code{\linkS4class{RccSet}} objects.
}
\details{
Arguments accepted by constructors are identical to those for the
\code{\link{ExpressionSet}} constructors.

See \code{\linkS4class{RccSet}} class documentation for examples of
constructor use.

Constructor calls for which mandatory \code{phenoData} or \code{featureData}
columns are missing will successfully create objects that include mandatory
columns, but with \code{NA} values. See \code{\linkS4class{RccSet}}
documentation for a list of mandatory columns.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{densityPlot}
\alias{densityPlot}
\title{densityPlot}
\usage{
densityPlot(M, log.transform = FALSE, pdata, covar, ...)
}
\arguments{
\item{M}{One of the matrices from the assayData() of an RccSet object (make sure
to set the log.transform parameter accordingly)}

\item{log.transform}{Scalar boolean}

\item{pdata}{pData() of the RccSet object}

\item{covar}{character; colname in pData() that can be used to label genes by a category of interest (passed on to colByCovar)}

\item{...}{additional plotting parameters}
}
\value{
A density plot
}
\description{
Plot the density of counts for all endogenous and housekeeping genes for each sample in an RccSet object
}
\author{
Dorothee Nickles
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{geneClustering}
\alias{geneClustering}
\title{Gene clustering heatmap}
\usage{
geneClustering(rccSet, outputFile, main = "Gene clustering", covar = NULL)
}
\arguments{
\item{rccSet}{An RccSet}

\item{outputFile}{Output PNG filename}

\item{main}{Plot title}

\item{covar}{Colname in the rccSet's fData that can be used to label genes by a category of interest}
}
\value{
A PNG file showing clustering of genes by correlation across an experiment
Positive and negative control probes and any zero-variance genes (typically
housekeeping genes) are omitted from the heatmap.
The width and height of the PNG file are set to vary with the size of the input.
}
\description{
Gene clustering heatmap
}
\author{
Dorothee Nickles, Robert Ziman
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BackgroundSubtractionFunctions.R
\docType{methods}
\name{nSolverBackground,RccSet-method}
\alias{nSolverBackground,RccSet-method}
\alias{nSolverBackground}
\title{nSolver Analysis Software background estimation}
\usage{
\S4method{nSolverBackground}{RccSet}(rccSet, stringency = 1, shrink = TRUE,
  w1 = 2.18, inputMatrix = c("posCtrlData", "exprs"))
}
\arguments{
\item{rccSet}{NanoString RccSet object}

\item{stringency}{Multiplier with which to adjust final values.}

\item{shrink}{Boolean specifying if probe-specific estimates should be shrunken towards
their global mean.}

\item{w1}{Shrink weight "w1".}

\item{inputMatrix}{Name of the matrix in the RccSet's assayData to use as input for calculating
background estimates (one of "exprs" or "posCtrlData"). If posCtrlData is
specified but not present in the assayData, an error will be generated.}
}
\value{
A matrix containing lane- and probe-specific background estimates.
}
\description{
Calculates initial probe- and lane-specific background estimates using an
algorithm that mimics the implementation in NanoString's nSolver Analysis
Software (see details below for the exact algorithm).
}
\details{
The mean values for each blank lane (not including positive control probes)
are computed from the original data, and a vector of probe-specific
background is established by taking the rowMeans of the blank measurements
for each probe after subtracting out these values. If shrink=TRUE, the
vector is adjusted via the following formula (where 'probe.bg' represents
the vector):

\preformatted{w2 <- 1/length(blanks)
probe.bg <- (w1*probe.bg + w2*mean(probe.bg)) / (w1 + w2)
}

This probe-specific background is further adjusted by subtracting the mean
of its values for the negative control probes. A lane-specific "affinity" is
calculated for all lanes in the original data by taking the colMeans of the
negative control probe values in the original data, and background estimates
for each probe and lane in the original data are computed by summing the
corresponding probe-specific background and lane-specific affinity. Any
resulting values less than zero are set to zero, and the last step before
returning these values is to multiply them by the given stringency.
}
\seealso{
\code{\link{getBackground}}, \code{\link{subtractBackground}}
}
\author{
Dorothee Nickles, Thomas Sandmann
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NanoStringQualityMetrics.R
\name{scatterPair}
\alias{scatterPair}
\title{scatterPair}
\usage{
scatterPair(x, y)
}
\arguments{
\item{x}{integer, x positions}

\item{y}{integer, y positions}
}
\value{
A scatter plot x versus y.
}
\description{
Helper function for a scatter plot inside a pairs plots
}
